# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sqlobject
from model.channel_entry import get_entry as get_model_channel_entry
from util import datetime__
import datetime

import config

def get_uid (parsed_entry) :
	__uid = None
	if parsed_entry.has_key("id")		: __uid = str(parsed_entry["id"]).strip()
	if parsed_entry.has_key("gid")	: __uid = str(parsed_entry["gid"]).strip()
	if parsed_entry.has_key("uid")	: __uid = str(parsed_entry["uid"]).strip()

	return __uid

def get_time_updated (d) :
	d = d[:-3]
	d = d + (0, 0, 0, )
	return datetime__.get_datetime(d)

def get_latest_posts_with_old_entries (id_channel, new_item_list) :
	__model_entry = get_model_channel_entry(id_channel)

	# remove the duplicated entries from new_item_list
	__new_pool = list()
	for i in new_item_list :
		__item = (get_uid(i), i.title, i.get("updated_parsed", None), )
		__new_pool.append(__item)

	__new_list = list()
	for i in new_item_list :
		__item = (get_uid(i), i.title, i.get("updated_parsed", None), )

		if __new_pool.count(__item) > 1 :
			del __new_pool[__new_pool.index(__item)]
		else :
			__new_list.append(i)

	__list = list()
	for i in __new_list :
		__clause = list()
		__uid = get_uid(i)

		if __uid :
			__clause.append(__model_entry.q.uid == __uid)

		if i.has_key("updated_parsed") and i.updated_parsed :
			__time_updated = get_time_updated(i.updated_parsed)
			__clause.append( \
				__model_entry.q.timeUpdated == __time_updated \
			)

		__clause.append( \
			__model_entry.q.title == i.title.encode("utf8") \
		)

		# find out the exact same entry.
		try :
			__c = __model_entry.select(sqlobject.AND(*__clause)).count()
		except Exception, e :
			raise

		if __c < 1 :
			__list.append(i)

	return __list

def get_latest_posts_with_last_entry (id_channel, new_item_list) :
	__model_entry = get_model_channel_entry(id_channel)

	__o = list( \
		__model_entry.select( \
			orderBy=__model_entry.q.id, \
			reversed=True \
		).limit(1) \
	)

	if not __o :
		return new_item_list

	"""
	* old data is the latest item from the DB
	* and new_item_list must be ordered by updated_parsed DESCENDENTLY.
	"""
	__list = list()
	for i in new_item_list :
		"""
		NOTE: Find out which post is newly updated one.
			1. match 'uid'
			1. match 'title'
			2. match 'updated_parsed'
		We consider this post as same post.
		"""
		# get uid

		"""
		__uid = None
		if i.has_key("id") : __uid = i["id"]
		if i.has_key("gid") : __uid = i["gid"]
		if i.has_key("uid") : __uid = i["uid"]
		"""
		__uid = get_uid(i)

		if __uid and old_data.uid.strip() : # if guid,
			if __uid == old_data.uid :
				break

		if i.has_key("title") and old_data.title.strip() and \
				i.has_key("link") and old_data.link.strip() : # if link,

			if i["link"] == old_data.link and \
					i["title"] == old_data.title :

				if i.has_key("updated_parsed") and i.updated_parsed : # if date,
					if datetime__.get_datetime(i.updated_parsed).timetuple() == \
							old_data.timeUpdated.timetuple() :
						break
				else : # if 'updated_parsed' does not exits, compare with only 'title'
					break

		__list.append(i)

	# sort reversely.
	#__l = __list.items()

	#return [i[1] for i in __l]
	return __list

from model import channel_entry_user as model_channel_entry_user
from model import configuration_user as __config_user
from model.channel_user import get_model as get_model_channel_user
from model.entry_pool import EntryPool as model_entry_pool
def get_channel_entries \
		( \
			id_user, id_channel=None, \
			term="today", offset=0, \
			limit=15, skip_read=True, \
			show_starred=False \
		) :
	try :
		__offset = int(offset)
	except :
		__offset = 0

	__limit = int(limit)

	# get user data
	__model_channel_entry_user = model_channel_entry_user.get_model(id_user)

	# calculate term
	__clause_term_entry_pool = None
	__clause_term_channel_entry_user = None
	if term == "today" :
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > datetime__.today()
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > datetime__.today()
	elif term == "yesterday" :
		__yesterday = datetime.timedelta(days=1)
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > \
				(datetime__.today() - __yesterday)
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > \
				(datetime__.today() - __yesterday)
	elif term == "3days" :
		__d = datetime.timedelta(days=2)
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > \
				(datetime__.today() - __d)
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > \
				(datetime__.today() - __d)
	elif term == "1week" :
		__week1 = datetime.timedelta(days=7)
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > \
				(datetime__.today() - __week1)
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > (datetime__.today() - __week1)
	elif term == "all" :
		__clause_term_entry_pool = (1==1)
		__clause_term_channel_entry_user = (1==1)

	elif term == "allunread" :
		__clause_term_entry_pool = (1==1)
		__clause_term_channel_entry_user = (1==1)

	# get channel list by user.
	if id_channel :
		__channels = [id_channel, ]
	else :
		__model_channel_user = get_model_channel_user(id_user)
		__channels = [ i.channelID for i in \
			list(__model_channel_user.select( \
				sqlobject.AND( \
					__model_channel_user.q.showFrontpage == True, \
					__model_channel_user.q.removed == False, \
				) \
			)) \
		]

	if len(__channels) < 1 :
		return (list(), None, None, )

	__clause_starred = (1 == 1)
	if not skip_read :
		__clause_already_read = (1 != 1)

		if show_starred :
			__o = list( \
				__model_channel_entry_user.select( \
					sqlobject.AND( \
						sqlobject.IN( \
							__model_channel_entry_user.q.channelID, __channels \
						), \
						__model_channel_entry_user.q.isStar == True \
					) \
				) \
			)
			__clause_starred0 = list()
			for i in __o :
				__clause_starred0.append( \
					sqlobject.AND( \
						model_entry_pool.q.channelID == i.channelID, \
						model_entry_pool.q.entryID == i.entryID, \
					) \
				)

			if len(__clause_starred0) > 0 :	
				__clause_starred = sqlobject.OR( \
					*__clause_starred0 \
				)
			else :
				__clause_starred = (1 != 1)

	else :
		# get read list.
		__entries_read0 = list( \
			__model_channel_entry_user.select( \
				sqlobject.AND( \
					__clause_term_channel_entry_user, \
					sqlobject.IN( \
						__model_channel_entry_user.q.channelID, __channels \
					), \
					sqlobject.OR( \
						__model_channel_entry_user.q.isRead == True, \
						__model_channel_entry_user.q.isSkip == True \
					) \
				) \
			) \
		)

		__entries_read = None
		__dict_read_and_skip = dict()
		__args_clause = list()
		for i in __entries_read0 :
			"""
			__args_clause.append( \
				sqlobject.AND( \
					model_entry_pool.q.channelID == i.channelID, \
					model_entry_pool.q.entryID == i.entryID \
				)
			)
			"""
			if not __dict_read_and_skip.has_key(i.channelID) :
				__dict_read_and_skip[i.channelID] = list()

			__dict_read_and_skip[i.channelID].append(i.entryID)

		for i, j in __dict_read_and_skip.items() :
			if len(j) < 1 :
				continue

			__args_clause.append( \
				sqlobject.AND( \
					model_entry_pool.q.channelID == i,
					sqlobject.IN( \
						model_entry_pool.q.entryID, j
					) \
				) \
			)

		__clause_already_read = (1 != 1, )
		if len(__args_clause) > 0 :
			__clause_already_read = sqlobject.OR(*__args_clause)

	# pages
	__total_entries = model_entry_pool.select( \
			sqlobject.AND( \
				sqlobject.IN( \
					model_entry_pool.q.channelID, __channels \
				), \
				__clause_term_entry_pool, \
				sqlobject.NOT( \
					__clause_already_read \
				),
				__clause_starred, \
			), \
			orderBy=model_entry_pool.q.timeUpdated, \
			reversed=True \
		).count()

	__total_pages = int(__total_entries / __limit)
	__left_entries = __total_entries % __limit

	if __offset == -1 :
		__offset = __total_pages * __limit

	__pages = { \
		"total_entries" : __total_entries, \
		"total_pages" : __total_pages, \
		"pages_left" : __total_pages - (__offset / __limit), \
	}

	__o = list( \
		model_entry_pool.select( \
			sqlobject.AND( \
				sqlobject.IN( \
					model_entry_pool.q.channelID, __channels \
				), \
				__clause_term_entry_pool, \
				sqlobject.NOT( \
					__clause_already_read \
				), \
				__clause_starred, \
			), \
			orderBy=model_entry_pool.q.timeUpdated, \
			reversed=True \
		) \
	)[__offset:__offset + __limit]

	# subtrack removed entries.
	__removed_entries = 0
	__entries = list()
	for i in __o :
		(i.entry_user, i.entry, i.hasMemo, ) = i.getEntry(id_user)
		if i.entry is None :
			__removed_entries += 1
			continue

		i.channel = i.getChannels(id_user)
		__entries.append(i)

	__pages["total_entries"] -= __removed_entries

	# offsets
	__offsets = dict()
	__offsets["current"] = __offset
	__offsets["prev"] = __offset - __limit
	__offsets["next"] = __offset + __limit
	if __offsets["prev"] < 0 :
		__offsets["prev"] = -1

	if len(__entries) < __limit or offset == "-1":
		__offsets["next"] = 0

	return (__entries, __offsets, __pages, )

def get_channel_entry_limit (id_user, id_channel=None) :
	__limit = None
	if id_channel :
		__limit = __config_user.get_value( \
			id_user, "entry.limit.%s" % id_channel)

	if not __limit :
		__limit = __config_user.get_value(id_user, "entry.limit.default")
		if not __limit :
			__limit = config.www_page_limit

	return __limit


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "channel_entry.py"


