# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, urllib
from util import favicon

import config

def get_image (obj_channel) :
	# get channel label image
	__filename = "channel_image-%s.gif" % obj_channel.id
	__path_file = "%s/%s" % (config.directory["favicon"], __filename, )
	if os.path.exists(__path_file) :
		return __filename
	else :
		# if not, get favicon
		__filename = "favicon-%s.gif" % obj_channel.id
		__path_file = "%s/%s" % (config.directory["favicon"], __filename, )
		if os.path.exists(__path_file) :
			return __filename
		else :
			return None

def get_favicon (obj_channel) :
	# check whether we got the favicon already or not.
	__link = obj_channel.link
	if not __link :
		__link = obj_channel.href

	__filename = "favicon-%s.gif" % obj_channel.id
	__path_file = "%s/%s" % (config.directory["favicon"], __filename, )

	if os.path.exists(__path_file) :
		return __filename
	else :
		# get favicon from it's server
		__filename_tmp = \
			"%s/%s.ico" % (config.directory["tmp"], urllib.quote(__link, ""), )
		if not favicon.get(__link, __filename_tmp) :
			return None
		else :
			# convert it to png file.
			if not favicon.convert(__filename_tmp, __path_file) :
				return None
			else :
				return __filename


"""
Description
-----------

ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Channels.py"

