# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, sre
from document.formatter.wiki.formatter.text_html import Formatter
from document.formatter.wiki import wikiutil
from document.formatter.wiki.parser import wiki
from document.formatter.wiki import config
from document.formatter.wiki.Page import Page

class Request :
	DATA = list()

	properties = dict()
	PAGENAME = str()
	cfg = config
	form = None
	_page_headings = dict()
	current_lang = "en"
	content_lang = "en"
	rootpage = ""

	def getScriptname (self) :
		return ""

	def getPragma (self, s, default=None) :
		return self._page_headings.get(s, default)

	def __init__ (self) :
		self.PAGENAME = ""
		self.properties["show-section-numbers"] = "1"

	def write (self, st) :
		self.DATA.append(st)

	def getText (self, s) :
		return s

	def get_property (self, key, default_value=None) :
		if self.properties.has_key(key) :
			return self.properties[key]
		else :
			return default_value

class Wiki :

	REQUEST = None
	FORMATTER = None
	PARSER = None

	def __init__ (self) :
		#self.PARSER = wikiutil.importPlugin("parser", "wiki", "Parser")
		self.PARSER = wiki.Parser

		self.REQUEST = Request()
		self.FORMATTER = Formatter(self.REQUEST)
		self.FORMATTER.page = Page(self.REQUEST, "")
		self.REQUEST.formatter = self.FORMATTER

	def format (self, text, **condition) :
		self.REQUEST.DATA = list()
		self.PARSER(text, self.REQUEST).format(self.FORMATTER)
		#print type("".join(self.REQUEST.DATA))
		#__formatted = "".join([ i.encode("utf8") for i in self.REQUEST.DATA])
		__formatted = "".join(self.REQUEST.DATA)

		return __formatted

def format (text) :
	w = Wiki()
	return w.format(text)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Formatter.py"


