# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sqlobject
import database
import config

URI = config.database["user"]

class ConfigurationUser (sqlobject.SQLObject) :
	_connection = URI

	name			= sqlobject.UnicodeCol(notNone=True)
	value			= sqlobject.PickleCol(notNone=False)
	valueRaw		= sqlobject.UnicodeCol(notNone=False)

	index0		= sqlobject.DatabaseIndex({'column': "name", "length" : 200})

	def __getRow (self, name) :
		try :
			return list( \
				self.select( \
					self.q.name == name.strip().lower() \
				) \
			)[0]
		except :
			return None

	def getValue (self, name) :
		try :
			__o = self.__getRow(name)
		except :
			return None
		else :
			if not __o :
				return None
			else :
				return __o.value

	def setValue (self, name, value) :
		__o = self.__getRow(name)

		if not __o :
			__kwargs = { \
				"name" : name.strip().lower(), \
				"value" : str(value), \
				"valueRaw" : str(value), \

			}
			return self(**__kwargs)
		else :
			__o.value = value
			__o.valueRaw = value

			return __o

	__getRow = classmethod(__getRow)
	getValue = classmethod(getValue)
	setValue = classmethod(setValue)

SKEL_TABLENAME = "configuration_%s"
def get_model (id_user) :
	__model = database.get_model( \
		database.get_table("configuration_user", "ConfigurationUser"), \
		SKEL_TABLENAME % id_user \
	)

	__conn = database.get_connection(URI)
	__model.createTable( \
		ifNotExists=True, \
		createIndexes=True, \
		connection= __conn \
	)

	return __model

def getDict (id_user) :
	__model = get_model(id_user)
	__a = list( \
		__model.select(orderBy=__model.q.name)\
	)

	__v = dict()
	for k in __a :
		__v[k.name.replace(".", "_")] = k.value

	return __v

def set_value (id_user, name, value) :
	__model = get_model(id_user)
	return __model.setValue(name, value)

def get_value (id_user, name) :
	__model_configuration_user = get_model(id_user)
	return __model_configuration_user.getValue(name)

if __name__ == "__main__" :
	print Configuration.createTable()



"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""
