# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sqlobject
import database, config
SKEL_TABLENAME = "memo_history_%s"

URI = config.database["user"]

class MemoHistoryUser (sqlobject.SQLObject) :
	_connection = URI

	memoID		= sqlobject.IntCol(notNone=True)
	diff_content	= sqlobject.UnicodeCol(notNone=False)
	diff_media		= sqlobject.UnicodeCol(notNone=False)
	timeChanged		= sqlobject.DateTimeCol(default="0000-00-00 00:00", notNone=True)

	index0			= sqlobject.DatabaseIndex({'column': "memoID"})
	index1			= sqlobject.DatabaseIndex({'column': "diff_content", "length": 200})
	index2			= sqlobject.DatabaseIndex({'column': "diff_media", "length": 200})
	index3			= sqlobject.DatabaseIndex({'column': "timeChanged"})

def get_model (id_user) :
	__model = database.get_model( \
		database.get_table("memo_history_user", "MemoHistoryUser"), \
		SKEL_TABLENAME % id_user \
	)

	__conn = database.get_connection(URI)
	__model.createTable( \
		ifNotExists=True, \
		createIndexes=True, \
		connection= __conn \
	)

	return __model

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""
