# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sqlobject
import database, config

from model.label_user import get_model as get_model_label_user

SKEL_TABLENAME = "memo_label_%s"
URI = config.database["user"]

class MemoLabelUser (sqlobject.SQLObject) :
	_connection = URI

	memoID			= sqlobject.Intcol(notNone=False)
	labelID			= sqlobject.Intcol(notNone=False)

	index0			= sqlobject.DatabaseIndex({'column': "memoID"})
	index1			= sqlobject.DatabaseIndex({'column': "labelID"})

	name = None

	def getLabels (self, id_memo) :
		__id_user = self.getUserID()

		__l = list( \
			self.select( \
				self.q.memoID == id_memo, \
				orderBy=self.q.labelID, \
				reversed=False \
			) \
		)

		__label_user = get_model_label_user(__id_user)
		for i in __l :
			i.name = __label_user.get(i.labelID).name

		return __l

	getLabels = classmethod(getLabels)

	def getUserID (self) :
		try :
			return int(self.sqlmeta.table.replace("memo_label_", ""))
		except :
			return None

	def removeLabel (self, id_memo, id_label) :
		# At first, insert label_user table.
		try :
			__memo_label = list( \
				self.select( \
					sqlobject.AND( \
						self.q.labelID == id_label, \
						self.q.memoID == id_memo \
					) \
				).limit(1) \
			)[0]
		except IndexError : # create new
			return False
		else :
			__memo_label.destroySelf()

			return True

	def setLabel (self, id_memo, name_label) :
		__id_user = self.getUserID()

		__name_label = str(name_label).strip()
		# At first, insert label_user table.
		__model_label_user = get_model_label_user(__id_user)
		try :
			__label = list( \
				__model_label_user.select( \
					__model_label_user.q.name == __name_label \
				).limit(1) \
			)[0]
		except IndexError : # create new
			__kwargs = { \
				"name" : __name_label, \
			}
			__label = __model_label_user(**__kwargs)

		try :
			__memo_label = list( \
				self.select( \
					sqlobject.AND( \
						self.q.memoID == id_memo, \
						self.q.labelID == __label.id \
					), \
				) \
			)[0]
		except :
			pass
		else :
			return __memo_label

		__kwargs = { \
			"memoID" : id_memo, \
			"labelID" : __label.id, \
		}

		return self(**__kwargs)

	getUserID = classmethod(getUserID)
	removeLabel = classmethod(removeLabel)
	setLabel = classmethod(setLabel)

def get_model (id_user) :
	__model = database.get_model( \
		database.get_table("memo_label_user", "MemoLabelUser"), \
		SKEL_TABLENAME % id_user \
	)

	__conn = database.get_connection(URI)
	__model.createTable( \
		ifNotExists=True, \
		createIndexes=True, \
		connection= __conn \
	)

	return __model


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""
