# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import xml.dom.minidom
def isTextNode (element) :
	if element.nodeType == xml.dom.minidom.Attr.TEXT_NODE :
		return True
	else :
		return False

class OPML : 

	DATA = None
	LIST_CHANNEL = list()

	def __init__ (self, data) :
		self.DATA = data

	def parse (self) :
		dom = xml.dom.minidom.parseString(self.DATA)
		try :
			__e_root = dom.getElementsByTagName("opml")[0]
			__e_body = dom.getElementsByTagName("body")[0]
		except :
			raise

		self.LIST_CHANNEL = list()
		self.__parseOutline(__e_body)

		return self.LIST_CHANNEL

	def __parseOutline (self, o, category=list()) :
		class DummyValue :
			value = unicode()

		category = [i for i in category if i.strip()]

		outline = { \
			"attribute"  : { \
				"text" : unicode(), \
				"title" : unicode(), \
				"description" : unicode(), \
				"type" : unicode(), \
				"htmlUrl" : unicode(), \
				"xmlUrl" : unicode(), \
				"updateInterval" : unicode(), \
			}, \
			"category" : category, \
		}

		# get title
		outline["attribute"]["text"] = \
			unicode(o.attributes.get("text", DummyValue()).value)
		outline["attribute"]["title"] = \
			unicode(o.attributes.get("title", DummyValue()).value)
		outline["attribute"]["description"] = \
			unicode(o.attributes.get("description", DummyValue()).value)
		outline["attribute"]["type"] = \
			unicode(o.attributes.get("type", DummyValue()).value)
		outline["attribute"]["htmlUrl"] = \
			unicode(o.attributes.get("htmlUrl", DummyValue()).value)
		outline["attribute"]["xmlUrl"] = \
			unicode(o.attributes.get("xmlUrl", DummyValue()).value)
		outline["attribute"]["updateInterval"] = \
			unicode(o.attributes.get("updateInterval", DummyValue()).value)

		if outline["attribute"]["xmlUrl"].strip() or \
				 outline["attribute"]["htmlUrl"].strip() :
			self.LIST_CHANNEL.append(outline)

		if o.hasChildNodes() :
			for i in o.childNodes :
				if isTextNode(i) : continue

				__category = category + [outline["attribute"]["title"], ]
				self.__parseOutline(i, __category)


def parse (data) :
	p = OPML(data)
	return p.parse()

if __name__ == "__main__" :
	# parse root
	a = file(sys.argv[1], "r")
	__data = a.read()

	p = OPML(__data)
	o = p.parse()

	for i in o :
		print "--------------------------------------------"
		print " > ".join(i["category"]).encode("utf8")
		print i["attribute"]["title"].encode("utf8")
		print i["attribute"]["xmlUrl"].encode("utf8")
		print i["attribute"]["htmlUrl"].encode("utf8")


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "1.py"





