# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from model import configuration_user as __config_user
import nokcene.result
import nokcene.xmlquery_new
import func
from model.entry_pool import EntryPool as model_entry_pool

def get_xml (id_user, keyword, keywords, offset) :
	__limit = __config_user.get_value(id_user, "entry.limit.search")
	if not __limit :
		__limit = config.www_page_limit
		__config_user.set_value(id_user, "entry.limit.search", __limit)

	__limit = int(__limit)

	# handle search string
	#__s = ["%s~" % i for i in func.split_with_field(__s)]

	__s_and = { \
		"author" : "", \
		"title" : "", \
		"summary" : "", \
	}

	__s_or = { \
		"author" : "", \
		"title" : "", \
		"summary" : "", \
	}

	if keyword :
		__s = ["%s" % i for i in func.split_with_field(keyword)]
		#__s_or = " OR ".join(__s)
		#__s_and = " OR ".join(__s)

		__s_and = { \
			"author" : " AND ".join(__s), \
			"title" : " AND ".join(__s), \
			"summary" : " AND ".join(__s), \
		}

		__s_or = { \
			"author" : " OR ".join(__s), \
			"title" : " OR ".join(__s), \
			"summary" : " OR ".join(__s), \
		}

	if keywords :
		__keywords_and = dict()
		__keywords_or = dict()
		for k, v in keywords.items() :
			__v = ["%s" % i for i in func.split_with_field(v)]
			__keywords_and[k] = " AND ".join(__v)
			__keywords_or[k] = " OR ".join(__v)

		__s_and.update(__keywords_and)
		__s_or.update(__keywords_or)

	return_fields=(
		"title",
		"__uid__",
		"link__",
		"summary",
		"timeUpdated",
		"author",
	)

	search_fields=( \
		(
			"AND",
			{
				"id" : "document_type",
				"type" : "keyword",
				"value": "channel_entry",
				"usage" : "",
				"condition" : "AND",
			},
			[ "OR", ],
		),
	)

	for k, v in __s_or.items() :
		if v.strip() :
			search_fields[0][2].append( \
				{
					"id" : k,
					"type" : "",
					"value": "(%s)^4" % v,
					"usage" : "",
				}
			)

			search_fields[0][2].append( \
				{
					"id" : k,
					"type" : "",
					"value": "(%s)" % v,
					"usage" : "",
				}
			)

	for k, v in __s_and.items() :
		if v.strip() :
			search_fields[0][2].append( \
				{
					"id" : k,
					"type" : "",
					"value": "(%s)^4" % v,
					"usage" : "",
				}
			)

			search_fields[0][2].append( \
				{
					"id" : k,
					"type" : "",
					"value": "(%s)" % v,
					"usage" : "",
				}
			)

	search_options = { \
		"sort-on" : "uid",
		"sort-order" : "reverse",
		"start" : offset,
		"size" : __limit,
		"operator" : "OR",
	}

	"""
	__xml = nokcene.result.generate_xml_query( \
		return_fields=return_fields, \
		search_fields=search_fields, \
		search_options=search_options \
	)
	"""
	__xml = nokcene.xmlquery_new.args_to_xml( \
		return_fields=return_fields, \
		search_fields=search_fields, \
		search_options=search_options \
	)

	return (__xml, __limit, )

def search (id_user, keyword, keywords, offset=0) :

	(__xml, __limit, ) = get_xml(id_user, keyword, keywords, offset)
	(__result, __num, ) = nokcene.result.get_result(__xml)

	# reform result
	__entries = list()
	__pool_channel = dict()
	for i in __result :
		# get channel and channel_entry info
		__uid = i.get("__uid__", None)
		if not __uid :
			continue
		else :
			try :
				(__id_channel, __id_entry, ) = \
					[int(j) for j in __uid.split(".")]
			except Exception, e :
				print e
				continue
			else :
				__o = model_entry_pool.getOne(__id_channel, __id_entry)
				if not __o :
					continue

				(__o.entry_user, __o.entry, __o.hasMemo, ) = __o.getEntry(id_user)
				__o.channel = __o.getChannels(id_user)
				__entries.append(__o)

	if (offset + __limit) > __num :
		__offset_next = -1
	else :
		__offset_next = offset + __limit

	if (offset - __limit) < 0 :
		__offset_prev = -1
	else :
		__offset_prev = offset - __limit

	__offsets = { \
		"current" : offset, \
		"prev" : __offset_prev, \
		"next" : __offset_next, \
	}

	return (__entries, __num, __offsets, )


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "entry.py"


