# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import simplejson, xmlrpclib, sqlobject, datetime, urllib
from django.utils.httpwrappers import HttpResponse
from django.core.extensions import render_to_response
from django.models.auth import users
from sqlobject import sqlbuilder

import http
from http.pageGetterBasic import get_page
from rss import parser_rss_or_html as parser, opml as opml_parser
from model.channel import Channel as model_channel
from model import configuration_user as __config_user
from model.entry_pool import EntryPool as model_entry_pool
from model import channel_entry_user as model_channel_entry_user
from model.channel_entry_user import get_model as get_model_channel_entry_user
from model.channel_user import get_model as get_model_channel_user
from model.channel_entry import get_entry as get_entry_channel_entry
from model.channel_label_user import get_model as get_model_channel_label_user
from model.label_user import get_model as get_model_label_user
from search.entry import search as search_entry

from document.channel_entry import get_channel_entries, get_channel_entry_limit

from util import datetime__
import libwww.func
import func

import config

@libwww.func.anonymouse_to_404
def getPageFrontpage (request) :
	__user = request.session.get("user", False)

	# get user configuration
	__term = __config_user.get_value( \
		__user.id, "entry.frontpage.term")

	# calculate term
	__msg = None
	if __term == "yesterday" :
		__term = "Yesterday"
	elif __term == "3days" :
		__term = "3 days"
	elif __term == "1week" :
		__term = "1 week"
	elif __term == "allunread" :
		__term = "All Unread"
	else :
		__term = "Today"

	return render_to_response( \
		"frontpage/frontpage.partial", \
		{ \
			"term" : __term, \
		} \
	)

@libwww.func.anonymouse_to_404
def setAsReadChannelEntry (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") or \
			not __argument.has_key("id_entry") :
		return http.exitWithStatus(404)

	__channel_entry_user = model_channel_entry_user.get_model(__user.id)
	__channel_entry_user.setRead( \
		int(__argument["id_channel"]), \
		int(__argument["id_entry"]), \
		True \
	)

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def removeChannel (request) :
	__user = request.session.get("user")

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") :
		return http.exitWithStatus(404)

	__model = get_model_channel_user(__user.id)
	if not __model :
		return http.exitWithStatus(404)
	else :
		__model.setRemoved(__argument["id_channel"], True)

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def removeChannelFromFrontpage (request) :
	__user = request.session.get("user")

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") :
		return http.exitWithStatus(404)

	__value = __argument.get("value", "").lower() in ("true", "1", "yes", )

	__model = get_model_channel_user(__user.id)
	if not __model :
		return http.exitWithStatus(404)
	else :
		__model.setShowFrontpage(__argument["id_channel"], __value)

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def getEntriesViewChannel (request) :
	__user = request.session.get("user")
	__argument = request.POST.copy()
	try :
		__id_channel = int(__argument.get("id_channel", None))
	except :
		return http.exitWithStatus(404)

	# show starred?
	__show_starred = __argument.get("show_starred", "false").lower() in  \
		["true", "1", "yes", ]

	try :
		__offset = int(__argument.get("offset", 0))
	except :
		__offset = 0

	__limit = int(get_channel_entry_limit(__user.id, __id_channel))
	__term = __argument.get("term", None)
	if __term :
		__config_user.set_value( \
			__user.id, "entry.channel_%s.term" % __id_channel, __term)
	else :
		__term = __config_user.get_value( \
			__user.id, "entry.channel_%s.term" % __id_channel)

	if not __term : __term = "today"

	__kwargs = {
		"id_channel" : __id_channel, \
		"term" : __term, \
		"offset" : __offset, \
		"limit" : __limit, \
		"skip_read" : False, \
		"show_starred" : __show_starred, \
	}
	(__entries, __offsets, __pages, ) = \
		get_channel_entries(__user.id, **__kwargs)

	return render_to_response( \
		"channel/view_channel_entry.partial", \
		{
			"entries" : __entries, \
			"offsets" : __offsets, \
			"num" : len(__entries), \
			"pages" : __pages, \
			"id_channel" : __id_channel, \
			"uid" : func.get_unique_id(), \
		} \
	)

@libwww.func.anonymouse_to_404
def getEntriesFrontpage (request) :
	__user = request.session.get("user")

	__argument = request.POST.copy()
	try :
		__offset = int(__argument.get("offset", 0))
	except :
		__offset = 0

	# get limit
	__limit = int(get_channel_entry_limit(__user.id, "frontpage"))

	__term = __config_user.get_value(__user.id, "entry.frontpage.term")
	if not __term : __term = "today"

	(__entries, __offsets, __pages, ) = \
		get_channel_entries(__user.id, None, __term, __offset, __limit)

	return render_to_response( \
		"frontpage/frontpage.entries.partial", \
		{
			"entries" : __entries, \
			"offsets" : __offsets, \
			"num" : len(__entries), \
			"pages" : __pages, \
			"uid" : func.get_unique_id(), \
		} \
	)

@libwww.func.anonymouse_to_404
def changeTermOfEntriesInViewChannel (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	if not __argument.has_key("term") : return http.exitWithStatus(404)
	if not __argument.has_key("id_channel") : return http.exitWithStatus(404)
	__id_channel = __argument["id_channel"]

	__model_channel_user = get_model_channel_user(__user.id)
	__model_channel_user.isExists(__id_channel)

	__config_user.set_value( \
		__user.id, \
		"entry.channel_%s.term" % __id_channel, __argument["term"])

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def changeTermOfEntriesInFrontpage (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	if not __argument.has_key("term") : return http.exitWithStatus(404)

	__config_user.set_value( \
		__user.id, "entry.frontpage.term", __argument["term"])

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def setAsSkipMany (request) :
	__user = request.session.get("user", False)

	__channel_entry_user = model_channel_entry_user.get_model(__user.id)
	__argument = request.POST.copy()
	__uids = __argument.getlist("uid")
	for i in __uids :
		try :
			(__id_channel, __id_entry, ) = [int(i) for i in i.split("-")]
		except :
			continue

		__channel_entry_user.setSkip( \
			__id_channel, \
			__id_entry, \
			True \
		)

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def setAsReadChannelEntry (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") or \
			not __argument.has_key("id_entry") :
		return http.exitWithStatus(404)

	__channel_entry_user = model_channel_entry_user.get_model(__user.id)
	__channel_entry_user.setRead( \
		int(__argument["id_channel"]), \
		int(__argument["id_entry"]), \
		True \
	)

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def setAsStarChannelEntry (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") or \
			not __argument.has_key("id_entry") :
		return http.exitWithStatus(404)

	try :
		__value = bool(int(__argument.get("value", 1)))
	except :
		__value = True

	__channel_entry_user = model_channel_entry_user.get_model(__user.id)
	__channel_entry_user.setStar( \
		int(__argument["id_channel"]), \
		int(__argument["id_entry"]), \
		__value \
	)

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def setSkipChannel (request) :
	__user = request.session.get("user")

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") : return http.exitWithStatus(404)
	try :
		__id_channel = int(__argument.get("id_channel"))
	except :
		return http.exitWithStatus(404)

	# check this channel in user list.
	__model_channel_user = get_model_channel_user(__user.id)

	__channel = list( \
		__model_channel_user.select( \
			sqlobject.AND( \
				__model_channel_user.q.channelID == __id_channel, \
				__model_channel_user.q.showFrontpage == True, \
				__model_channel_user.q.removed == False, \
			) \
		) \
	)
	if not __channel :
		return http.exitWithStatus(404)

	# get user data
	__model_channel_entry_user = model_channel_entry_user.get_model(__user.id)
	__term = __config_user.get_value(__user.id, "entry.frontpage.term")
	if not __term : __term = "today"

	# calculate term
	__clause_term_entry_pool = None
	__clause_term_channel_entry_user = None
	if __term == "today" :
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > datetime__.today()
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > datetime__.today()
	elif __term == "yesterday" :
		__yesterday = datetime.timedelta(days=1)
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > \
				(datetime__.today() - __yesterday)
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > \
				(datetime__.today() - __yesterday)
	elif __term == "3days" :
		__d = datetime.timedelta(days=2)
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > \
				(datetime__.today() - __d)
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > \
				(datetime__.today() - __d)
	elif __term == "1week" :
		__week1 = datetime.timedelta(days=7)
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > \
				(datetime__.today() - __week1)
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > (datetime__.today() - __week1)
	elif __term == "allunread" :
		__clause_term_entry_pool = (1==1)
		__clause_term_channel_entry_user = (1==1)

	# get read and skipped list in this channel.
	__entries_read_skip = list( \
			__model_channel_entry_user.select( \
				sqlobject.AND( \
					__model_channel_entry_user.q.channelID == __id_channel, \
					__clause_term_channel_entry_user, \
					sqlobject.OR( \
						__model_channel_entry_user.q.isRead == True, \
						__model_channel_entry_user.q.isSkip == True \
					) \
				) \
			) \
		)

	__args_clause = list()
	for i in __entries_read_skip :
		__args_clause.append( \
			sqlobject.AND( \
				model_entry_pool.q.channelID == i.channelID, \
				model_entry_pool.q.entryID == i.entryID \
			)
		)

	if len(__args_clause) < 1 :
		__clause_already_read_skip = (1 != 1, )
	else :
		__clause_already_read_skip = sqlobject.OR(*__args_clause)

	__o = list( \
		model_entry_pool.select( \
			sqlobject.AND( \
				model_entry_pool.q.channelID == __id_channel, \
				__clause_term_entry_pool, \
				sqlobject.NOT( \
					__clause_already_read_skip \
				) \
			) \
		) \
	)

	for i in __o :
		__model_channel_entry_user.setSkip(__id_channel, i.entryID, True)

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def getChannelList (request) :
	__user = request.session.get("user")

	__model_channel_user = get_model_channel_user(__user.id)
	if not __model_channel_user :
		return http.exitWithStatus(404)

	__model_channel_label_user = get_model_channel_label_user(__user.id)

	# filtering by id_label
	__argument = request.POST.copy()
	__id_labels = __argument.getlist("id_label")

	try :
		__id_labels = [int(i) for i in __id_labels]
	except :
		__id_labels = list()

	__clause = sqlobject.AND(1 == 1)
	if len(__id_labels) < 1 :
		if len(__argument.getlist("id_label")) == 1 and \
				__argument.getlist("id_label")[0] == "uncategorized" :
			# get channel list, which has label.
			__list_channels = list( \
				__model_channel_label_user.select( \
					__model_channel_label_user.q.seq == 0, \
				) \
			)
			__channel_has_label = [i.channelID for i in __list_channels]
			if len(__channel_has_label) < 1 :
				__clause = (1 == 1)
			else :
				__clause = sqlbuilder.NOTIN( \
					__model_channel_user.q.channelID, __channel_has_label \
				)
		else :
			__clause = sqlobject.AND(1 == 1)
	else :
		__pool_channels = list()
		for i in __id_labels :
			__pool_channels.append( \
				[ i.channelID for i in list( \
					__model_channel_label_user.select( \
						__model_channel_label_user.q.labelID == i, \
						orderBy=__model_channel_label_user.q.id \
					) \
				)] \
			)

		if len(__pool_channels) < 1 :
			__clause = sqlobject.AND(1 == 1)
		else :
			__id_channels = set(__pool_channels[0])
			for i in __pool_channels[1:] :
				__id_channels = __id_channels & set(i)

			if len(__id_channels) < 1 :
				__clause = sqlobject.AND(1 == 1)
			else :
				__clause_list = list()
				for i in __id_channels :
					__clause_list.append( \
						__model_channel_user.q.channelID == i \
					)

				if len(__clause_list) < 1 :
					__clause = sqlobject.AND(1 == 1)
				else :
					__clause = sqlobject.OR(*__clause_list)

	__clause = sqlobject.AND( \
		__clause, \
		__model_channel_user.q.removed == False, \
	)

	__channels = __model_channel_user.getChannelList(__clause)

	return render_to_response( \
		"channel/list_channel.partial", \
		{
			"id_labels" : __id_labels, \
			"channels" : __channels, \
		}
	)

@libwww.func.anonymouse_to_404
def setLabel (request) :
	__user = request.session.get("user")

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") : return http.exitWithStatus(404)
	if not __argument.has_key("label") : return http.exitWithStatus(404)

	__id_channel = __argument["id_channel"]
	__label = __argument["label"].strip()

	__model_channel_label = get_model_channel_label_user(__user.id)
	__label = __model_channel_label.setLabel(__id_channel, __label)

	return HttpResponse(str(__label.labelID))

@libwww.func.anonymouse_to_404
def removeChannelLabel (request) :
	__user = request.session.get("user")

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") : return http.exitWithStatus(404)
	if not __argument.has_key("id_label") : return http.exitWithStatus(404)

	__id_channel = __argument["id_channel"]
	__id_label = __argument["id_label"]

	__model_channel_label = get_model_channel_label_user(__user.id)
	if __model_channel_label.removeLabel(__id_channel, __id_label) :
		return http.exitWithStatus(200)
	else :
		return http.exitWithStatus(404)

@libwww.func.anonymouse_to_404
def setLabelSequence (request) :
	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") : return http.exitWithStatus(404)
	if not __argument.has_key("labels[]") : return http.exitWithStatus(404)

	__id_channel = __argument["id_channel"]
	__list_argument = __argument.getlist("labels[]")

	try :
		__ids_label = [int(i.split(".")[1]) for i in __list_argument]
	except :
		return http.exitWithStatus(404)

	__user = request.session.get("user")
	if not __user :
		return http.exitWithStatus(500)

	__model_channel_label = get_model_channel_label_user(__user.id)

	# clean up and re-insert labels.
	#__model_channel_label.cleanUp(__id_channel)
	__n = 0
	for i in __ids_label :
		__model_channel_label.setSeq(__id_channel, i, __n)
		__n += 1

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def getChannelLabelList (request) :
	__user = request.session.get("user")

	__argument = request.POST.copy()
	__id_labels = __argument.getlist("id_label")
	try :
		__id_labels = [int(i) for i in __id_labels]
	except :
		__id_labels = list()

	__model_channel_user = get_model_channel_user(__user.id)
	__model_channel_label = get_model_channel_label_user(__user.id)
	__model_label_user = get_model_label_user(__user.id)

	__channels = [i.channelID for i in list( \
		__model_channel_user.select( \
			__model_channel_user.q.removed == False \
		) \
	)]

	# get all channels, which has this label
	if len(__channels) < 1 :
		__labels = list()
	else :
		if len(__id_labels) < 1 :
			__o = list( \
				__model_channel_label.select( \
					sqlobject.AND( \
						__model_channel_label.q.seq == 0, \
						sqlobject.IN( \
							__model_channel_label.q.channelID, __channels \
						) \
					), \
					orderBy=__model_channel_label.q.id \
				) \
			)
			__new = dict()
			for i in __o :
				if not __new.has_key(i.labelID) :
					__new[i.labelID] = i.labelID
			__list = __new.values()
			__clause = [(__model_label_user.q.id == i) for i in __list]
			if len(__clause) > 0 :
				__clause = sqlobject.OR(*__clause)
			else :
				__clause = (1 == 1)
			__labels = list( \
				__model_label_user.select( \
					__clause, \
					orderBy=__model_label_user.q.name, \
					reversed=True \
				) \
			)
		else :
			# get the intersection set between channel lists.
			__inter_list = list()
			for i in __id_labels :
				__inter_list.append( \
					[i.channelID for i in \
						list( \
							__model_channel_label.select( \
								sqlobject.AND( \
									__model_channel_label.q.labelID == i, \
									sqlobject.IN( \
										__model_channel_label.q.channelID, __channels \
									) \
								) \
							) \
						) \
					] \
				)

			__o = set(__inter_list[0])
			if len(__inter_list) > 1 :
				for i in __inter_list[1:] :
					__o = __o & set(i)

			# get all the labeles in this channels
			__labels = dict()
			for i in __o :
				__la = list( \
					__model_channel_label.select( \
						__model_channel_label.q.channelID == i, \
					) \
				)
				[__labels.update({i.labelID : None}) for i in __la]

			__new = dict()
			for i in __labels :
				__name = __model_label_user.get(i).name
				if not __new.has_key(__name) and i not in __id_labels :
					__new[__name] = { \
						"id" : i, \
						"name" : __name, \
					}

				#__new[__name]["child"].append(i)

			__labels = list()
			__names = __new.keys()
			__names.sort()
			__names.reverse()
			for i in __names :
				__labels.append(__new[i])

	return render_to_response( \
		"channel/list_channel_label.partial", \
		{
			"labels" : __labels, \
		}
	)

@libwww.func.anonymouse_to_404
def getRSSUrlCandidate (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	if not __argument.has_key("href") : return http.exitWithStatus(404)

	__url = __argument.get("href", None)
	if not __url :
		return http.exitWithStatus(500)
	"""
	__url = http.validate_url(__argument["href"])
	if not __url :
		return http.exitWithStatus(500)
	"""

	# check whether this url is already add or not.
	# if already added, return 600 as status code.
	__channel = __getChannelByHref(__url)
	if not __channel :
		pass
	else :
		__channel_user = __getChannelUser(__channel.id, __user.id)
		if __channel_user :
			return http.exitWithStatus(600)
		else :
			return render_to_response( \
				"channel/add_channel_result_channel.partial", \
				{
					"channel" : __channel, \
					"href" : __url, \
				}
			)

	__d = get_page(__url)
	if not __d.strip() :
		return http.exitWithStatus(500)

	__parsed = parser.parse(__d)

	if not __parsed.has_key("bozo") :
		return http.exitWithStatus(500)
	else :
		# If parser returns exception, we assumes this data is html or others, so
		# try to find rss links in this document by it's content-type.
		if not __parsed["bozo"] : # it's xml document.
			# check the duplicated channel, using feed information
			__clause = list()
			if __parsed.feed.has_key("link") :
				__clause.append( \
					model_channel.q.link == __parsed.feed.link.encode("utf8") \
				)

			if __parsed.feed.has_key("title") :
				__clause.append( \
					model_channel.q.title == __parsed.feed.title.encode("utf8") \
				)

			if type(__parsed["namespaces"]) is dict and \
					__parsed["namespaces"].has_key("dc") :
				__clause.append( \
					model_channel.q.namespace == \
						__parsed.namespaces["dc"].encode("utf8") \
				)

			__channels = list()
			if len(__clause) > 0 :
				__channels = list(model_channel.select(sqlobject.AND(*__clause)))

			if len(__channels) > 1 :
				__channel = __channels[0]
				__model_channel_user = get_model_channel_user(__user.id)

				try :
					__channel_user = list( \
						__model_channel_user.select( \
							__model_channel_user.q.channelID == __channel.id \
						).limit(1) \
					)[0]
				except :
					__channel_user = None

				if __channel_user :
					return http.exitWithStatus(600)
				else :
					return render_to_response( \
						"channel/add_channel_result_channel.partial", \
						{
							"channel" : __channel, \
							"href" : __url, \
						}
					)

			__is_podcasting = False
			if type(__parsed["namespaces"]) is dict and \
					__parsed["namespaces"].has_key("itunes"):
				# it's itunes podcasting feed.
				__is_podcasting = True

			return render_to_response( \
				"channel/add_channel_result_rss.partial", \
				{
					"parsed" : __parsed, \
					"is_podcasting" : __is_podcasting, \
					"href" : __url, \
				}
			)
		elif isinstance(__parsed["bozo_exception"], Exception) :
			__links = list()
			if __parsed.has_key("feed") and __parsed["feed"].has_key("links") :
				# it's html document, so try to find rss links in header.
				for i in __parsed["feed"]["links"] :
					# assume if there will be a GODDAMM relative path.
					__channel = __getChannelByHref(i["href"])
					__is_added = False
					if __channel :
						__channel_user = __getChannelUser(__channel.id, __user.id)
						if __channel_user :
							__channel_user.main = __channel
							__is_added = __channel_user

					i.update( \
						{ \
							"href": urllib.basejoin(__url, i["href"]), \
							"is_added" : __is_added, \
						} \
					)
					__links.append(i)

			return render_to_response( \
				"channel/add_channel_result_links.partial", \
				{
					"links" : __links, \
					"href" : __url, \
				}
			)

def __getChannelByHref (href) :
	try :
		__channel = list( \
			model_channel.select( \
				model_channel.q.href == href \
			).limit(1) \
		)[0]
	except :
		return False
	else :
		return __channel

def __getChannelUser (id_channel, id_user) :
	__model_channel_user = get_model_channel_user(id_user)
	try :
		__channel = list( \
			__model_channel_user.select( \
				sqlobject.AND( \
					__model_channel_user.q.channelID == id_channel, \
					__model_channel_user.q.removeed == False, \
				) \
			).limit(1) \
		)[0]
	except Exception, e:
		return None
	else :
		return __channel

@libwww.func.anonymouse_to_404
def addChannel (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	if not __argument.has_key("hrefs") : return http.exitWithStatus(404)

	# get href
	__list_href = __argument.getlist("hrefs")
	if len(__list_href) < 1 :
		return http.exitWithStatus(404)

	# get id_labels
	__id_labels0 = __argument.get("id_labels", str());
	__id_labels = list()
	try :
		__id_labels = [int(i) for i in __id_labels0.split(",") if i.strip() ]
	except :
		pass

	__server_add = xmlrpclib.Server("http://localhost:%d" % config.zzim_add_port)
	__id_channels = dict()
	for i in __list_href :
		__id_channels[i] = __server_add.addChannel(i)

	__model_channel_user = get_model_channel_user(__user.id)
	__model_channel_label_user = get_model_channel_label_user(__user.id)
	for __href, __id_channel in __id_channels.items() :
		if __id_channel :
			# check whether it is removed from channel_user or not
			if __model_channel_user.isExists(__id_channel) :
				__model_channel_user.setRemoved(__id_channel, False)
			else :
				__kwargs_channel_user = { \
					"channelID" : __id_channel, \
					"timeAdded" : datetime__.now(), \
				}
				__model_channel_user(**__kwargs_channel_user)

				# add label
				__seq = 0
				for __id_label in __id_labels :
					__kwargs_channel_label = { \
						"channelID" : __id_channel, \
						"labelID" : __id_label, \
						"seq" : __seq, \
					}
					__model_channel_label_user(**__kwargs_channel_label)
					__seq += 1

	return HttpResponse(simplejson.dumps(__id_channels))

@libwww.func.anonymouse_to_404
def addChannelKnown (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") :
		return http.exitWithStatus(404)

	__id_channel = __argument.get("id_channel")

	__model_channel_user = get_model_channel_user(__user.id)
	__channel = __model_channel_user.isExists(__id_channel)
	if __channel :
		__channel.removed = False
	else :
		__kwargs = \
		{ \
			"channelID" : __id_channel, \
			"timeAdded" : datetime__.now(), \
		}
		__model_channel_user(**__kwargs)

	return http.exitWithStatus(200)


@libwww.func.anonymouse_to_404
def parseOpmlFile (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	__files = request.FILES.copy()

	__status_code = None
	__list_channels_unknown = list()
	__list_channels_known = list()

	if not __files.has_key("file_opml") :
		__status_code = "no_file"
	else :
		__data = __files["file_opml"]["content"]

		try :
			__list_channel = opml_parser.parse(__data)
		except :
			__status_code = "not_opml"
		else :
			if len(__list_channel) < 1 :
				__status_code = "not_opml"
			else :
				# filter whether the channel is already added or not.
				__list_channels_known = list()
				__list_channels_unknown = list()
				for i in __list_channel :
					__id_channel = model_channel.isExists(i["attribute"]["xmlUrl"])
					if __id_channel :
						__list_channels_known.append(__id_channel)
					else :
						__list_channels_unknown.append(i)

	return render_to_response( \
		"channel/import_opml_select_opml.partial", \
		{ \
			"parsed" : True, \
			"status_code" : __status_code, \
			"list_channels_known" : simplejson.dumps(__list_channels_known), \
			"list_channels_unknown" : simplejson.dumps(__list_channels_unknown), \
		} \
	)

@libwww.func.anonymouse_to_404
def formatCandidateChannelList (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()

	# known channel list
	__channels_known = list()
	if __argument.has_key("known") :
		__model_channel_user = get_model_channel_user(__user.id)
		__clause = sqlobject.IN( \
			__model_channel_user.q.channelID, simplejson.loads(__argument["known"])
		)
		__channels_known = list( \
			__model_channel_user.getChannelList(__clause) \
		)

	return render_to_response( \
		"channel/import_opml_list_candidate_channels.partial", \
		{ \
			"channels_known" : __channels_known, \
			"channels_unknown" : simplejson.loads(__argument.get("unknown", "")), \
		} \
	)

@libwww.func.anonymouse_to_404
def checkNewEntryFrontpage (request) :
	__user = request.session.get("user")

	# get user data
	__model_channel_entry_user = model_channel_entry_user.get_model(__user.id)

	__term = __config_user.get_value(__user.id, "entry.frontpage.term")
	if not __term : __term = "today"

	# calculate term
	__clause_term_entry_pool = None
	__clause_term_channel_entry_user = None
	if __term == "today" :
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > datetime__.today()
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > datetime__.today()
	elif __term == "yesterday" :
		__yesterday = datetime.timedelta(days=1)
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > \
				(datetime__.today() - __yesterday)
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > \
				(datetime__.today() - __yesterday)
	elif __term == "3days" :
		__d = datetime.timedelta(days=2)
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > \
				(datetime__.today() - __d)
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > \
				(datetime__.today() - __d)
	elif __term == "1week" :
		__week1 = datetime.timedelta(days=7)
		__clause_term_entry_pool = model_entry_pool.q.timeUpdated > \
				(datetime__.today() - __week1)
		__clause_term_channel_entry_user = \
			__model_channel_entry_user.q.timeUpdated > (datetime__.today() - __week1)
	elif __term == "allunread" :
		__clause_term_entry_pool = (1==1)
		__clause_term_channel_entry_user = (1==1)

	# get channel list by user.
	__model_channel_user = get_model_channel_user(__user.id)
	__channels = [ i.channelID for i in \
		list(__model_channel_user.select( \
			sqlobject.AND( \
				__model_channel_user.q.showFrontpage == True, \
				__model_channel_user.q.removed == False, \
			) \
		)) \
	]

	if len(__channels) < 1 :
		return http.exitWithStatus(404)

	# get read list.
	__entries_read0 = list( \
		__model_channel_entry_user.select( \
			sqlobject.AND( \
				__clause_term_channel_entry_user, \
				sqlobject.IN( \
					__model_channel_entry_user.q.channelID, __channels \
				), \
				sqlobject.OR( \
					__model_channel_entry_user.q.isRead == True, \
					__model_channel_entry_user.q.isSkip == True \
				) \
			) \
		) \
	)

	__entries_read = None
	__dict_read_and_skip = dict()
	__args_clause = list()
	for i in __entries_read0 :
		if not __dict_read_and_skip.has_key(i.channelID) :
			__dict_read_and_skip[i.channelID] = list()

		__dict_read_and_skip[i.channelID].append(i.entryID)

	for i, j in __dict_read_and_skip.items() :
		if len(j) < 1 :
			continue

		__args_clause.append( \
			sqlobject.AND( \
				model_entry_pool.q.channelID == i,
				sqlobject.IN( \
					model_entry_pool.q.entryID, j
				) \
			) \
		)

	__clause_already_read = (1 != 1, )
	if len(__args_clause) > 0 :
		__clause_already_read = sqlobject.OR(*__args_clause)

	__total_entries = model_entry_pool.select( \
			sqlobject.AND( \
				sqlobject.IN( \
					model_entry_pool.q.channelID, __channels \
				), \
				__clause_term_entry_pool, \
				sqlobject.NOT( \
					__clause_already_read \
				)
			) \
		).count()

	if __total_entries > 0 :
		return http.exitWithStatus(200)

	return http.exitWithStatus(404)

@libwww.func.anonymouse_to_login_page
def viewChannel (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") : return http.exitWithStatus(404)

	__id_channel = int(__argument["id_channel"])

	# get user configuration
	__term = __config_user.get_value( \
		__user.id, "entry.channel_%s.term" % __id_channel)

	# get channel info
	__id_channel = int(__argument.get("id_channel"))
	__model_user = get_model_channel_user(__user.id)
	__channel = __model_user.getChannel(__id_channel)

	# calculate term
	if __term == "yesterday" :
		__term = "Yesterday"
	elif __term == "1week" :
		__term = "1 week"
	elif __term == "3days" :
		__term = "3 days"
	elif __term == "all" :
		__term = "All"
	else :
		__term = "Today"

	return render_to_response( \
		"channel/view_channel.partial", \
		{ \
			"term" : __term, \
			"channel" : __channel , \
		} \
	)

@libwww.func.anonymouse_to_login_page
def getPageSearch (request) :
	__user = request.session.get("user", False)

	return render_to_response("channel/search.partial")

@libwww.func.anonymouse_to_login_page
def getPageViewChannels (request) :
	__user = request.session.get("user", False)

	__argument = request.GET.copy()
	__id_labels = __argument.getlist("id_labels")

	#######################################################################
	# FIXME: __id_labels must be list, but at this time, we just return one
	# single value as __labels
	# get label names
	__labels = list()
	if len(__id_labels) > 0 :
		__model_label = get_model_label_user(__user.id)
		for i in __id_labels :
			__labels.append(__model_label.get(i))

	if len(__labels) < 1 :
		__labels = None
	else :
		__labels = __labels[0]
	#######################################################################

	return render_to_response( \
		"channel/view_channels.partial", \
		{ \
			"labels" : __labels, \
		} \
	)

@libwww.func.anonymouse_to_login_page
def getPageAddChannel (request) :
	return render_to_response( \
		"channel/add_channel.partial", \
	)

@libwww.func.anonymouse_to_login_page
def getPageImportOPML (request) :
	return render_to_response( \
		"channel/import_opml.partial", \
	)

def selectOpmlFile (request) :
	return render_to_response( \
		"channel/import_opml_select_opml.partial" \
	)

@libwww.func.anonymouse_to_404
def searchChannel (request) :
	__user = request.session.get("user", False)
	__argument = request.POST.copy()

	__id_labels = __argument.getlist("id_label")
	try :
		__id_labels = [int(i) for i in __id_labels]
	except :
		__id_labels = list()

	if not __argument.has_key("keyword") :
		return http.exitWithStatus(404)

	__keyword = __argument.get("keyword").lower()

	__model_channel_user = get_model_channel_user(__user.id)

	# search in label
	__model_label = get_model_label_user(__user.id)
	__labels = list( \
		__model_label.select( \
			__model_label.q.name.contains(__keyword) \
		) \
	)

	__id_labels = [i.id for i in __labels]
	__id_channels_labels = list()
	if len(__id_labels) > 0 :
		__model_channel_label = get_model_channel_label_user(__user.id)
		__o = list( \
			__model_channel_label.select( \
				sqlobject.IN( \
					__model_channel_label.q.labelID, __id_labels \
				) \
			) \
		)
		__id_channels_labels = [i.channelID for i in __o]

	# search in channel.
	__id_channels = __model_channel_user.getChannelIDs()
	if len(__id_channels) > 0 :
		__clause_channel = sqlobject.AND( \
			sqlobject.IN( \
				model_channel.q.id, __id_channels \
			), \
			sqlobject.OR( \
				model_channel.q.title.contains(__keyword), \
				model_channel.q.subtitle.contains(__keyword) \
			) \
		)

		__id_channels = [ i.id for i in list(model_channel.select(__clause_channel))]

	__id_channels = list(set(__id_channels_labels) | set(__id_channels))

	__channels = list()
	if len(__id_channels) > 0 :
		__clause = \
			sqlobject.IN( \
				__model_channel_user.q.channelID, __id_channels \
			)

		__channels = __model_channel_user.getChannelList(__clause)

	return render_to_response( \
		"channel/list_channel.partial", \
		{
			"id_labels" : __id_labels, \
			"channels" : tuple(__channels), \
			"keyword" : __keyword, \
		}
	)

@libwww.func.anonymouse_to_404
def searchChannelEntry (request) :
	__user = request.session.get("user", False)

	__argument = request.POST.copy()

	# tidy post argument
	__argument_new = dict()
	[__argument_new.update({i : " ".join(__argument.getlist(i)), }) \
		for i in __argument.keys() \
			if i != "offset" and \
				not i.startswith("_") and \
				__argument.get(i, "").strip()]

	__query = list()
	for k, v in __argument.items() :
		if k.startswith("_") : continue
		if k == "offset" : continue

		#__query.append("%s=%s" % (k, urllib.quote(v)))
		for i in __argument.getlist(k) :
			__query.append("%s=%s" % (k, urllib.quote(i)))

	if __argument_new.has_key("keyword") :
		__keyword = __argument["keyword"]
		__keywords = None
	elif len(__argument_new) > 0 :
		__keyword = None
		__keywords = __argument_new
	else :
		return http.exitWithStatus(404)

	__offset = int(__argument.get("offset", 0))
	(__entries, __num, __offsets, ) = \
		search_entry(__user.id, __keyword, __keywords, __offset)

	return render_to_response( \
		"channel/search_result.partial", \
		{
			"entries" : __entries, \
			"num" : __num, \
			"search_string" : "&".join(__query), \
			"offsets" : __offsets, \
			"uid" : func.get_unique_id(), \
		}
	)

@libwww.func.anonymouse_to_404
def setChannelTitle (request) :
	__user = request.session.get("user")

	__argument = request.POST.copy()
	if not __argument.has_key("id_channel") :
		return http.exitWithStatus(404)

	__title = __argument.get("title", "")

	__model = get_model_channel_user(__user.id)
	if not __model :
		return http.exitWithStatus(404)
	else :
		__model.setTitle(__argument["id_channel"], __title.strip())

	return http.exitWithStatus(200)

@libwww.func.anonymouse_to_404
def getChannelEntry (request) :
	__user = request.session.get("user")
	__argument = request.POST.copy()
	__id_channel = __argument.get("id_channel", None)
	if not __id_channel : return http.exitWithStatus(404)

	__id_entry = __argument.get("id_entry", None)
	if not __id_entry : return http.exitWithStatus(404)

	__model_channel_entry_user = get_model_channel_entry_user(__user.id)
	(__entry_user, __entry, __has_memo, ) = \
		__model_channel_entry_user.getEntry_new(__id_channel, __id_entry)

	__entry.entry = __entry
	__entry.entry_user = __entry_user
	__entry.hasMemo = __has_memo

	# get channel info
	__model_channel_user = get_model_channel_user(__user.id)
	__entry.channel = __model_channel_user.getChannel(__id_channel)

	return render_to_response( \
		"channel/entry_one.partial",
		{
			"one" : __entry, \
			"uid" : func.get_unique_id(), \
		}
	)


__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "views.py"


