# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, simplejson
from django.utils.httpwrappers import HttpResponse
from django.core.extensions import render_to_response

from model.channel_entry import get_entry as get_model_channel_entry
from model.memo_user import get_model as get_model_memo_user
from model.channel_entry_user import get_model as get_model_channel_entry_user
from model.channel_user import get_model as get_model_channel_user
import func

import libwww.func
import http
import config

@libwww.func.anonymouse_to_404
def getPage (request) :
	__user = request.session.get("user", False)

	return render_to_response("memo/page.partial")

def getList (request) :
	__user = request.session.get("user", False)
	__argument = request.POST.copy()

	__model_memo_user = get_model_memo_user(__user.id)
	__memos = __model_memo_user.getList()

	return render_to_response( \
		"memo/memo_list.partial", \
		{ \
			"memos" : __memos, \
		}
	)

@libwww.func.anonymouse_to_404
def removeMemo (request) :
	__user = request.session.get("user", False)
	__argument = request.POST.copy()

	__id_memo = __argument.get("id_memo", None)
	if __id_memo is None : return http.exitWithStatus(404)
	__model_memo_user = get_model_memo_user(__user.id)

	if not __model_memo_user.removeMemo(__id_memo) :
		return http.exitWithStatus(404)
	else :
		return http.exitWithStatus(200)

from django.core.template.defaultfilters import format_to_wiki
@libwww.func.anonymouse_to_404
def formatToWiki (request) :
	__argument = request.POST.copy()
	__s = __argument.get("content", str())
	if not __s.strip() :
		return http.exitWithStatus(404)

	s = format_to_wiki(__s)
	return HttpResponse(s)

@libwww.func.anonymouse_to_404
def getMemo (request) :
	__user = request.session.get("user", False)
	__argument = request.POST.copy()

	__id_memo = __argument.get("id_memo", None)
	if __id_memo is None : return http.exitWithStatus(404)
	__model_memo_user = get_model_memo_user(__user.id)

	from django.core.template.defaultfilters import format_to_wiki
	__memo = __model_memo_user.get(__id_memo)
	__value = { \
		"title" : __memo.title, \
		"content" : format_to_wiki(__memo.content), \
	}

	return HttpResponse(simplejson.dumps(__value))

def getEditorInChannelEntry (request) :
	__user = request.session.get("user", False)
	__argument = request.POST.copy()

	__id_channel = __argument.get("id_channel", None)
	if __id_channel is None : return http.exitWithStatus(404)
	__id_entry = __argument.get("id_entry", None)
	if __id_entry is None : return http.exitWithStatus(404)

	__uid = __argument.get("uid", None)
	if __uid is None :
		__uid = func.get_unique_id()

	__model_channel_entry = get_model_channel_entry(__id_channel)
	__entry = __model_channel_entry.get(__id_entry)
	if not __entry :
		return http.exitWithStatus(404)

	# get memo(s)
	__model_memo_user = get_model_memo_user(__user.id)
	__conditions = { \
		"channelID" : __id_channel, \
		"entryID" : __id_entry, \
	}
	__memos = __model_memo_user.getMemos(**__conditions)

	return render_to_response( \
		"memo/editor_channel_entry.partial", \
		{ \
			"entry" : __entry, \
			"memos" : __memos, \
			"uid" : __uid, \
		} \
	)

def saveChannelEntry (request) :
	__user = request.session.get("user", False)
	__argument = request.POST.copy()

	__id_channel = __argument.get("id_channel", None)
	if __id_channel is None : return http.exitWithStatus(404)
	__id_entry = __argument.get("id_entry", None)
	if __id_entry is None : return http.exitWithStatus(404)

	__content = __argument.get("content", "")

	__properties = { \
		"from" : "channel_entry", \
		"entryID" : __id_entry, \
		"channelID" : __id_channel, \
	}

	__model_memo_user = get_model_memo_user(__user.id)
	__memo = __model_memo_user.insert("", __content, __properties)

	try :
		__title = __content.split(os.linesep)[0][:100]
	except :
		__title = __content[:100]

	__value = { \
		"title" : unicode(__title, "utf8"), \
		"id_memo" : __memo.id, \
	}

	return HttpResponse(simplejson.dumps(__value, ensure_ascii=False))


__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "views.py"


