# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import simplejson, xmlrpclib, sqlobject, datetime, urllib
from django.utils.httpwrappers import HttpResponse
from django.core.extensions import render_to_response
from django.models.auth import users
from sqlobject import sqlbuilder

import http
from http.pageGetterBasic import get_page
from rss import parser_rss_or_html as parser, opml as opml_parser
from model.channel import Channel as model_channel
from model import configuration_user as __config_user
from model.entry_pool import EntryPool as model_entry_pool
from model import channel_entry_user as model_channel_entry_user
from model.channel_user import get_model as get_model_channel_user
from model.channel_entry import get_entry as get_entry_channel_entry
from model.channel_label_user import get_model as get_model_channel_label_user
from model.label_user import get_model as get_model_label_user
from search.entry import search as search_entry

from document.channel_entry import get_channel_entries

from util import datetime__
import libwww.func

import config

def validateUrl (request) :
	"""
	@retval,
		valid : validated url,
		not valid : exit status code, 404
	"""
	__argument = request.POST.copy()
	if not __argument.has_key("url") : return http.exitWithStatus(404)

	__r = http.validate_url(__argument["url"])
	if not __r :
		return http.exitWithStatus(404)
	else :
		return HttpResponse(__r)

def checkLogin (request) :
	"""
	@retval is,
		404 : username or password was not given
		405 : username does not exists
		406 : password mis-match
	"""
	__argument = request.POST.copy()

	if not __argument.has_key("username") or \
			not __argument.has_key("password") :
		return http.exitWithStatus(404)

	kwargs = { \
		"username__exact": __argument["username"], \
		"is_active__exact": True \
	}
	try:
		user = users.get_object(**kwargs)
	except users.UserDoesNotExist:
		return http.exitWithStatus(405)

	# check the password and any permission given
	if user.check_password(__argument["password"]):
		request.session["user"] = user
		return http.exitWithStatus(200)
	else :
		return http.exitWithStatus(406)

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "views.py"


