Editors = Class.create();
Object.extend(Editors.prototype, {
	pool: $H(),
	initialize: function()
	{
	},
	get: function(id)
	{
		if (this.pool.keys().indexOf(id) == -1)
		{
			return null;
		} else {
			return this.pool[id];
		}
	},
	add: function(grid)
	{
		this.pool[grid.id] = grid;
	},
	close: function(id)
	{
		delete this.pool[id];
	},
	current: null,
	setCurrent: function(id)
	{
		this.current = id;

		this.pool.each(
			function(e)
			{
				if (e.key == id)
				{
					e.value.setOnTop();
				} else {
					e.value.setOnDown();
				}
			}
		);
	}
}
);

var __EDITORS__ = new Editors();

Editor = Class.create();
Object.extend(Object.extend(Editor.prototype), {

	/* properties begin */
	id: null,
	box: null,
	moving: false,
	height_box: 0,
	resizer: null,
	/* properties end */

	/* properties begin */
	properties: {
		box: {
			id: this.id + "-box"
		},
		box_handler: {
			id: this.id + "-box_handler"
		},
		element_form: {
			action: "/api/memo/saveMemo",
			method: "POST",
			name: "memo_editor",
			id: "memo_editor"
		},
		element_textarea: {
			name: "memo_editor-textarea",
			id: "memo_editor-textarea"
		},
		onPreview: function (obj_editor, s, callback) {
			callback();
		},
		onSave: function (obj_editor, s, callback) {
			callback();
		}
	},
	/* properties end */

	/* basic method begin */
	initialize: function(id, properties) {
		this.id = id;
		__EDITORS__.add(this);

		Object.extend(this.properties, properties || {});

		this.setup();
	},
	setup: function()
	{
		var __self = this;

		// create box.
		this.box = document.createElement("DIV");
		this.setProperty(this.box, this.properties.box);

		// set box style
		this.box.className = "memo_editor";
		this.box.setStyle({display: "none"});

		// create handle to move box.
		this.box_handler = this.__createElement_handler();
		this.box_handler.className = "box_handler";

		this.box_content = document.createElement("DIV");
		this.box_content.className = "box_content";

		this.box.appendChild(this.box_handler);
		this.box.appendChild(this.box_content);

		// tab
		// editor div box.
		this.box_content_editor = document.createElement("DIV");
		this.box_content_preview = document.createElement("DIV");
		this.box_content_preview.className = "box_content_preview";
		this.box_content_preview.setStyle({display: "none"});

		this.element_form = this.__createElement_content_editor();
		this.box_content_editor.appendChild(this.element_form);

		this.box_content.appendChild(this.box_content_editor);
		this.box_content.appendChild(this.box_content_preview);

		// add resizer.
		this.element_resizer = document.createElement("DIV");
		this.element_resizer.setStyle(
			{
				display: "none",
				height: "20px",
				width: "20px",
				background:
					"transparent url('/__media__/image/resizer.png') top left no-repeat"
			}
		);
		this.box.appendChild(this.element_resizer);

		document.body.appendChild(this.box);
	},
	attachEvent: function()
	{
		this.eventMouseUp = this.eventUp.bindAsEventListener(this);
		this.eventMouseDown = this.eventDown.bindAsEventListener(this);
		this.eventMouseDownOnBox = this.eventDownOnBox.bindAsEventListener(this);
		this.eventMouseMove = this.eventMove.bindAsEventListener(this);

		/*
		this.eventMouseDblClick = this.eventDblClick.bindAsEventListener(this);
		this.eventMouseClick = this.eventClick.bindAsEventListener(this);
		Event.observe(this.box_handler, "dblclick", this.eventMouseDblClick);
		Event.observe(this.box_handler, "click", this.eventMouseClick);
		*/

		Event.observe(this.box_handler, "mousedown", this.eventMouseDown);
		Event.observe(this.box, "mousedown", this.eventMouseDownOnBox);
		Event.observe(document, "mouseup", this.eventMouseUp);
		Event.observe(document, "mousemove", this.eventMouseMove);
	},
	/*
	eventClick: function(event)
	{
		//this.hide();
		return true;
	},
	eventDblClick: function(event)
	{
		this.hide();
	},
	*/
	eventUp: function(event)
	{
		this.moving = false;

		var __x = 50 * Math.round(this.box.offsetLeft / 50);
		var __y = 50 * Math.round(this.box.offsetTop / 50);
		if (__x < 50) __x = 50;
		if (__y < 50) __y = 50;
		if (__x > (window.innerWidth - 200)) __x = window.innerWidth - 200;
		if (__y > (window.innerHeight - 50)) __y = window.innerHeight - 50;

		this.box.style.left = __x + "px";
		this.box.style.top = __y + "px";

		this.resizer.resetPosition();
	},
	eventDownOnBox: function(event)
	{
		__EDITORS__.setCurrent(this.id);
		return true;
	},
	eventDown: function(event)
	{
		this.moving = true ;
		this.suplus_x = Event.pointerX(event) - this.box.offsetLeft;
		this.suplus_y = Event.pointerY(event) - this.box.offsetTop;

		return true;
	},
	eventMove: function(event)
	{
		if (this.moving)
		{
			var __x = Event.pointerX(event);
			var __y = Event.pointerY(event);

			this.box.style.left = (__x - this.suplus_x) + "px";
			this.box.style.top = (__y - this.suplus_y) + "px";
		}
	},
	setProperty: function(element, properties)
	{
		var __p = $H(properties);
		for (var i in properties)
		{
			element.setAttribute(i, __p[i]);
		}
	},

	/* create elements begin */
	__createElement_tab: function()
	{
		var __self = this;
		var __box_tab = document.createElement("UL");
		__box_tab.className = "tab";

		var __tab_edit = document.createElement("LI");
		var __tab_preview = document.createElement("LI");
		var __tab_save = document.createElement("LI");

		__tab_edit.className = "tab_element";
		__tab_preview.className = "tab_element";
		__tab_save.className = "tab_element";

		var __tab_edit_button = document.createElement("IMG");
		__tab_edit_button.src = "/__media__/image/pencil-25.png";
		__tab_edit.appendChild(__tab_edit_button);

		var __tab_preview_button = document.createElement("IMG");
		__tab_preview_button.src =
		"/__media__/image/preview-25.png";
		__tab_preview.appendChild(__tab_preview_button);

		var __tab_save_button = document.createElement("IMG");
		__tab_save_button.src = "/__media__/image/save-25.png";
		__tab_save.appendChild(__tab_save_button);

		// assign event method
		__tab_edit_button.onclick = function(e)
		{
			if (__self.box_content_editor.style.display == "none")
			{
				Element.hide(__self.box_content_preview);
				Element.show(__self.box_content_editor);
				setTimeout(
					function()
					{
						__self.element_textarea.style.height =
							parseInt(__self.box_content_editor.offsetHeight * 0.9) + "px";
						__self.element_textarea.focus();
					},
					100
				);
			}

			return true;
		}

		__tab_preview_button.onclick = function(e)
		{
			var __running = new Running(__self.box);
			__running.begin();

			if (__self.box_content_preview.style.display == "none")
			{
				Element.show(__self.box_content_preview);
				Element.hide(__self.box_content_editor);
			}

			var __s = trimString(__self.element_textarea.value);

			// show previewed text.
			var __s = __self.properties.onPreview(
				__self,
				__s,
				function() // it's callback function for AJAX call.
				{
					__running.end();
				}
			);

			return true;
		}

		__tab_save_button.onclick = function(e)
		{
			var __running = new Running(__self.box);
			__running.begin();
			// show previewed text.
			var __s = __self.properties.onSave(
				__self,
				__s,
				function() // it's callback function for AJAX call.
				{
					__running.end();
				}
			);

			return true;
		}

		__box_tab.appendChild(__tab_edit);
		__box_tab.appendChild(__tab_preview);
		__box_tab.appendChild(__tab_save);

		return __box_tab;
	},
	__createElement_content_editor : function()
	{
		// add form
		var __element_form = document.createElement("FORM");
		this.setProperty(__element_form, this.properties.element_form);
		this.element_textarea = document.createElement("TEXTAREA");
		this.element_textarea.className = "element_textarea";
		this.setProperty(this.element_textarea, this.properties.element_form);
		__element_form.appendChild(this.element_textarea);

		return __element_form;
	},
	__createElement_end_div : function()
	{
		var __end = document.createElement("DIV");
		__end.setStyle({clear: "both"});

		return __end;
	},
	__createElement_handler: function()
	{
		var __self = this;

		var __box_handler = document.createElement("DIV");
		this.setProperty(__box_handler, this.properties.box_hander);

		// title
		var __title = document.createElement("SPAN");
		__title.innerHTML = "Memo Editor";
		__title.className = "box_handler_title";
		__box_handler.appendChild(__title);

		// close
		var __button_blank = document.createElement("DIV");
		__button_blank.setStyle({height: "20px", width: "20px"});
		__button_blank.setStyle({cssFloat: "left"});

		var __buttons = document.createElement("DIV");
		__buttons.className = "box_handler_button";

		var __close_image_hide = document.createElement("IMG");
		__close_image_hide.src =
			"/__media__/image/arrow_down-25.png";
		__close_image_hide.onclick = function(e)
		{
			__self.hide();
		}

		var __close_image = document.createElement("IMG");
		__close_image.src = "/__media__/image/close-25.png";
		__close_image.onclick = function(e)
		{
			__self.close();
			return false;
		}

		__buttons.appendChild(__button_blank);
		__buttons.appendChild(__close_image_hide);
		__buttons.appendChild(__close_image);

		var __box_tab = this.__createElement_tab();

		__box_handler.appendChild(__buttons);
		__box_handler.appendChild(__box_tab);
		__box_handler.appendChild(this.__createElement_end_div());

		return __box_handler;
	},
	/* create elements end */
	show: function()
	{
		Element.show(this.box);

		// set the height of this box.
		this.box.style.height = this.box.offsetHeight + "px";
		this.height_box = this.box.offsetHeight + "px";

		// set resizer
		this.element_resizer.setStyle(
			{
				position: "absolute",
				display: "",
				right: "0px",
				bottom: "0px",
			}
		);

		// add resizer
		var __self = this;
		this.resizer = new Resizer(
			this.box,
			{
				handle: this.element_resizer,
				vertical: true,
				horizontal: true,
				afterFinish: function(e)
				{
					var __w = parseInt(__self.box_content.offsetHeight * 0.9);
					__self.box_content_editor.style.height = __w + "px";
					__self.box_content_preview.style.height = __w + "px";

					__self.element_textarea.style.height =
						parseInt(__self.box_content_editor.offsetHeight * 0.9) + "px";
				}
			}
		);

		this.box_content.style.height = "95%";
		//this.element_textarea.style.height = "90%";

		this.attachEvent();
	},
	close: function()
	{
		var __self = this;
		new Effect.Fade(
			this.box,
			{
				duration: 0.5,
				afterFinish: function(e)
				{
					__self.box.parentNode.removeChild(__self.box);
				}
			}
		);
	},
	hide: function()
	{
		if (this.box_content.style.display == "none")
		{
			this.box.style.height = this.height_box;
			Element.show(this.element_resizer);

			Element.show(this.box_content);
		} else {
			this.height_box = this.box.offsetHeight;
			this.box.style.height = "";

			Element.hide(this.box_content);

			// hide resizer
			Element.hide(this.element_resizer);
		}
	},
	updatePreview: function(s)
	{
		this.box_content_preview.innerHTML = s;
	},
	setOnDown: function()
	{
		this.box.setStyle({zIndex: 0});
	},
	setOnTop: function()
	{
		this.box.setStyle({zIndex: 1});
	}
	/* basic method end */
});


