Grids = Class.create();
Object.extend(Grids.prototype, {
	pool: $H(),
	initialize: function()
	{
	},
	get: function(id)
	{
		if (this.pool.keys().indexOf(id) == -1)
		{
			return null;
		} else {
			return this.pool[id];
		}
	},
	add: function(grid)
	{
		this.pool[grid.id] = grid;
	},
	remove: function(id)
	{
		delete this.pool[id];
	}
}
);

var __GRIDS__ = new Grids();

Grid = Class.create();
Object.extend(Grid.prototype, {
		$c: function(tagname)
		{
			return document.createElement(tagname);
		},

		styles: {
			header: {
				padding: "0",
				margin: "0",
				clear: "both",
				height: "25px",
				borderWidth: "1px 1px 1px 1px",
				borderStyle: "solid",
				borderColor: "#546b04",
				background: "transparent url('/__media__/image/grid-field.png') top left repeat-x",
				backgroundColor: "#8fb40c"
			},
			grid: {
				padding: "0",
				margin: "0",
				clear: "both",
				overflowY: "auto",
				borderWidth: "0px 0px 1px 0px",
				borderStyle: "solid",
				borderColor: "#083772",
				backgroundColor: "white"
				/*
				background: "transparent url('/__media__/image/test/gradient-bg.gif') bottom left repeat-x"
				*/
			},
			field: {
				listStyle: "none",
				cursor: "pointer",
				cssFloat: "left",
				margin: "0px",
				padding: "0px",
				height: "25px",
				paddingTop: "1px",
				paddingBottom: "1px",
				paddingLeft: "5px",
				background: "#b8cb85 url('/__media__/image/grid-field.png') bottom left repeat-x"
			},
			splitter_field_none: {
				listStyle: "none",
				cssFloat: "left",
				margin: "0px",
				height: "25px",
				width: "2px",
				paddingTop: "1px",
				paddingBottom: "1px",
				background: "#b8cb85 url('/__media__/image/grid-field.png') bottom left repeat-x"
			},
			splitter_field: {
				listStyle: "none",
				cssFloat: "left",
				margin: "0px",
				height: "25px",
				width: "2px",
				paddingTop: "1px",
				paddingBottom: "1px",
				background: "#b8cb85 url('/__media__/image/grid-split.png') bottom right no-repeat"
			},
			column: {
				cursor: "pointer",
				listStyle: "none",
				cssFloat: "left",
				margin: "0px",
				padding: "0px",
				paddingTop: "1px",
				paddingBottom: "1px",
				paddingLeft: "5px",
				borderWidth: "0px 0px 1px 0px",
				borderColor: "#e3efff",
				borderStyle: "solid",
				padding: "0px",
				backgroundColor: "white"
			},
			column_selected: {
				backgroundColor: "#dddddd"
			}
		},

		id: null,
		fields : $A(),
		max_width_column : $H(),
		style_column : $H(),
		frame: null,
		body: null,
		document: null,
		options_field : $H(),
		height_real: 0,

		initialize : function(id, options)
		{
			this.fields = $A();
			this.max_width_column = $H();
			this.style_column = $H();
			this.body= null;
			this.data_rows = $A();
			this.options_field = $H();
			this.height_real = 0;

			this.id = id;

			this.options = options;
			this.options = Object.extend(
				{
					max_width: 600,
					height: 500,
					obj_parent: null,
					debug: false,
					cssUrl : null
				},
				options
			);

			this.body = this.options.obj_parent;
			//this.options.max_width -= 10;
			this.width = this.options.max_width;

			this.obj_grid = this.$c("UL");
			this.obj_grid.width = this.options.max_width + "px";
			this.obj_grid.setStyle(this.styles.grid);
			this.obj_grid_header = this.$c("UL");
			this.obj_grid_header.setStyle(this.styles.header);
			this.obj_grid_header.style.width = this.options.max_width + "px";
			this.obj_grid.style.width = this.options.max_width + "px";
			this.__show();

			// add grids pool
			__GRIDS__.add(this);
		},
		show: function()
		{
			if (this.data_rows.length > 0)
			{
				this.indicator = new Running(this.obj_grid);
				this.indicator.begin();
			}

			this.resizeGrid();

			var __div_end = this.$c("DIV");
			__div_end.setStyle({clear: "both"});
			this.body.appendChild(__div_end);

			var __self = this;
			var __s = 0;

			this.data_rows.each(
				function(r)
				{
					/*
					__self.__addRow(r);
					*/
					setTimeout(
						function()
						{
							__self.__addRow(r);
						},
						100 * __s
					);
					__s += 1;
				}
			);

			if (this.data_rows.length > 0)
			{
				this.indicator.end();
			}

			// calculate height of all.
			this.height_real =
				this.obj_grid.offsetHeight + this.obj_grid_header.offsetHeight;
		},
		__show: function()
		{
			this.body.appendChild(this.obj_grid_header);

			this.obj_grid.style.height =
				this.options.height - this.obj_grid_header.offsetHeight - 50 + "px";

			this.body.appendChild(this.obj_grid);
		},
		findElementByUIDRow: function(uid)
		{
			var __children= new Array();
			$A(this.obj_grid.childNodes).each(
				function(e)
				{
					if (e.tagName &&
							e.tagName.toUpperCase()== "LI")
					{
						var __uid = e.getAttribute("uid_row");
						if (uid ==__uid) __children.push(e);
					}
				}
			);

			return __children;
		},
		findElementByUIDField: function(uid)
		{
			var __children= new Array();
			$A(this.obj_grid.childNodes).each(
				function(e)
				{
					if (e.tagName &&
							e.tagName.toUpperCase()== "LI")
					{
						var __uid = e.getAttribute("uid_field");
						if (uid ==__uid) __children.push(e);
					}
				}
			);

			return __children;
		},
		clearRows: function()
		{
			this.data_rows = $A();
			this.obj_grid.innerHTML = "";
		},
		addField: function (options)
		{
			var options_field = {
				label: "Column-" + this.fields.length,
				type: "int",
				className: "field",
				width: null,
				with_splitter: true,
				is_fixed_width: false,
				sortBy: function(a, b)
				{
					//return parseInt(a[0]) - parseInt(b[0]);
					a = parseInt(a);
					b = parseInt(b);
					return a < b ? -1 : a > b ? 1 : 0;
				}
			}

			var options = Object.extend(options_field, options);

			var __uid = get_unique_id();

			this.options_field[__uid] = options;
			var __is_begin = false;
			if (this.fields.length < 1)
			{
				__is_begin = true;
			}

			var __li = this.$c("LI");
			__li.setStyle(this.styles.field);
			__li.id = "field-" + __uid;
			__li.setAttribute("type", "field");
			__li.setAttribute("uid_field", __uid);
			__li.setAttribute("sort", "desc");
			__li.innerHTML = options.label;
			this.fields.push(__uid);

			__li.className = options.className;
			if (__is_begin)
			{
				//__li.setStyle({float: "left", clear: "left"});
				__li.style.cssFloat = "left";
				__li.style.clear = "left";
			}

			// add sort function
			var __self = this;
			__li.onclick = function(e)
			{
				var __children = __self.findElementByUIDField(__uid);
				var __a = $A();
				var __b = $A();
				$A(__children).each(
					function(e)
					{
						if (e.getAttribute("type") == "field") return;
						__a.push(
							[
								e.getAttribute("column_value"),
								e.getAttribute("uid_field"),
								e.getAttribute("uid_row")
							]
						);
					}
				);

				if (options.sortBy)
				{
					var __sorted = __a.sort(options.sortBy);
				} else {
					var __sorted = __a.sort();
				}

				var __last = __self.findElementByUIDField(__self.fields[0])[0];

				if (this.getAttribute("sort") == "desc")
				{
					for (var i = 0; i < __sorted.length; i++)
					{
						var __uid_row = __sorted[i][2];
						$A(__self.fields).each(
							function(e)
							{
								var __id_li = "column-" + e + "-" + __uid_row;
								__self.obj_grid.insertBefore($(__id_li), __last.nextSibling);
								__last = $(__id_li);
							}
						)

					}
					this.setAttribute("sort", "asc");
				} else {
					for (var i = (__sorted.length - 1); i >= 0; i--)
					{
						var __uid_row = __sorted[i][2];
						$A(__self.fields).each(
							function(e)
							{
								var __id_li = "column-" + e + "-" + __uid_row;
								__self.obj_grid.insertBefore($(__id_li), __last.nextSibling);
								__last = $(__id_li);
							}
						)

					}
					this.setAttribute("sort", "desc");
				}

				return false;
			}

			this.obj_grid_header.appendChild(__li);

			var __reg_width = new RegExp("^[1-9][0-9]*px$", "gi");
			if (options.width.search && options.width.search(__reg_width) != -1)
			{
				// get offsetwidth of it.
				var __w = parseInt(options.width);
				__li.style.width = __w + "px";
				this.options.max_width = this.options.max_width - __w;
				this.options_field[__uid].is_fixed_width = true;
			} else {
				// get offsetwidth of it.
				var __w = parseInt(this.options.max_width * (options.width / 10)) - 2;
				__li.style.width = __w + "px";
			}

			this.style_column[__uid] = options.style;

			// add splitter
			var __sp =this.$c("LI");
			__sp.id = "splitter-" + __uid;
			__sp.style.width = "2px";
			__sp.className = "splitter";

			if (options.with_splitter)
			{
				__sp.setStyle(this.styles.splitter_field);
			} else {
				__sp.setStyle(this.styles.splitter_field_none);
			}


			this.obj_grid_header.appendChild(__sp);
		},
		resizeGrid: function()
		{
			//this.setStyle(this.frame, {margin: 0, padding: 0, width: this.width + "px"});
			//this.options.max_width -= 20;

			while (true)
			{
				if (this.__resizeGrid())
				{
					break;
				}
			}

			var __self = this;
			$A(this.fields).each(
				function(f)
				{
					__self.max_width_column[f] =
						parseInt($("field-" + f).style.width);
				}
			);

			this.obj_grid_header.style.width = this.width - 5 + "px";
			this.obj_grid.style.width = this.width - 5 + "px";
		},
		__resizeGrid: function()
		{
			var __width = 0;
			var __self = this;

			$A(this.fields).each(
				function(f)
				{
					__width +=
						$("field-" + f).offsetWidth +
							$("splitter-" + f).offsetWidth;
				}
			);
			if (__width <= this.options.max_width)
			{
				return true;
			} else {
				$A(this.fields).each(
					function(f)
					{
						if (__self.options_field[f].is_fixed_width) return;

						$("field-" + f).style.width =
							($("field-" + f).offsetWidth - 6) + "px";
					}
				);
				return false;
			}
		},

		is_added_column : false,
		num_of_row: 0,
		data_rows : $A(),
		addRow: function(values)
		{
			this.data_rows.push(values);
		},
		__addRow: function (values)
		{
			var __self = this;

			if (! this.is_added_column)
			{
				// add splitter
				var __sp =this.$c("DIV");
				//__sp.setStyle({clear: "both"});
				__sp.style.clear = "both";
				this.obj_grid_header.appendChild(__sp);
			}
			var __uid_row = get_unique_id();
			//if (values.length != this.fields.length) return false;

			var __columns = new Array();
			for (var i = 0; i < this.fields.length; i++)
			{
				if (! values[i]) values[i] = "";
				var __column = this.addColumn(__uid_row, values[i], i);
				__columns.push(__column);

				// attach onclick event.
				__column.onclick = function(e)
				{
					__self.toggleRow(
						this.getAttribute("uid_row"),
						__self.styles.column_selected
					);

					return true;
				}
			}

			var __self = this;
			setTimeout(
				function(e)
				{
					__self.resizeHeightOfRow(__columns);
				},
				10 * this.num_of_row
			);

			this.num_of_row += 1;
		},
		resizeHeightOfRow: function(columns)
		{
			// resize the height of this rows.
			var __max_height = 0;
			var __self = this;
			$A(columns).each(
				function(c)
				{
					var __h = c.offsetHeight;
					if (__h > __max_height) __max_height = __h;
				}
			);
			$A(columns).each(
				function(c)
				{
					c.style.height = __max_height + "px";
				}
			);
		},
		addColumn: function(uid_row, value, seq_col)
		{
			var __uid = this.fields[seq_col];

			var __li = this.$c("LI");

			// attach this grid object to this.
			__li.grid = this;
			__li.setStyle(this.styles.column);
			__li.id = "column-" + __uid + "-" + uid_row;
			__li.setAttribute("uid_field", __uid);
			__li.setAttribute("uid_row", uid_row);

			if (value instanceof Object && value.label)
			{
				if (value.label instanceof Object)
				{
					__li.appendChild(value.label);
				} else {
					try
					{
						Element.update(__li, value.label);
					} catch (e) {
						if (this.options.debug)
						{
							return;
						}
					}
				}

				if (value.callback)
				{
					Event.observe(__li, "click", value.callback);
				}

				if (value.column_value)
				{
					var __value = value.column_value.toString().unescapeHTML();
				} else {
					var __value = value.label.innerHTML;
				}
				__li.setAttribute("column_value", __value);
			} else {
				if (value instanceof Object)
				{
					__li.appendChild(value);
				} else {
					Element.update(__li, value.unescapeHTML());
				}
				__li.setAttribute("column_value", value.unescapeHTML());
			}

			var __width = this.max_width_column[__uid];
			if (seq_col == 0)
			{
				//__li.setStyle({float: "left", clear: "left"});
				__li.style.cssFloat = "left";
				__li.style.clear = "left";
			} else if (seq_col == (this.fields.length - 1)) {
				//__li.setStyle({float: "left", clear: "right"});
				__li.style.cssFloat = "left";
				__li.style.clear = "right";
				var __width = this.max_width_column[__uid] - 16;
			}

			if (this.style_column[__uid])
			{
				__li.setStyle(this.style_column[__uid]);
			}

			__li.style.width = __width + "px";
			this.obj_grid.appendChild(__li);

			return __li;
		},
		selected : null,
		selectRow: function(uid_row, style)
		{
			var __columns = this.findElementByUIDRow(uid_row);
			if (__columns.length < 1) return;

			this.selected = __columns;
			var __self = this;
			$A(__columns).each(
				function(c)
				{
					c.setStyle(style);
				}
			);
		},
		toggleRow: function(uid_row, style)
		{
			if (this.selected)
			{
				var __self = this;
				$A(this.selected).each(
					function(c)
					{
						c.setStyle(__self.styles.column);
					}
				);
			}

			this.selectRow(uid_row, style);

		}
	}
);

