/* ================================================== */
/* global PAGE */

var __CLASS__ = {
  create: function() {
    return function() {
      this.initialize.apply(this, arguments);
    }
  }
}

Egg = __CLASS__.create();
Object.extend(
	Object.extend(Egg.prototype, __CLASS__.prototype),
	{
		initialize : function(id, options)
		{
			this.id = id;
			this.page = null;
			this.value_scroll = 0;
			this.__setOptions(options);

			//this.init();
		},
		__setOptions: function(options) {
			this.options = {
				id_scrollable : null
			}

			Object.extend(this.options, options || {});
		},
		fire : function()
		{
			var __self = this;
			if (document.getElementById(this.options.id_scrollable))
			{
				$(__self.options.id_scrollable).onscroll = function(e)
				{
					__self.value_scroll = this.scrollTop;
				}
			}
		},
		reset : function()
		{
			this.setScroll(1);
		},
		setScroll : function(value)
		{
			var __self = this;
			if (__self.options.id_scrollable)
			{
				if (! value) value = __self.value_scroll;
				setTimeout(
					function(e)
					{
						if (isExists(__self.options.id_scrollable))
						{
							$(__self.options.id_scrollable).scrollTop = value;
						}
					},
					100
				);
			}
		},
		onShow : function()
		{
			this.setScroll();
		},
		onHide : function()
		{
		}
	}
);


var Page = function()
{
	// Properties
	this.parent_node = $("block_pages");
	this.parent_pager0 = $("block_pager");
	this.parent_pager = $("block_pager-ul");
	this.pages = $A();

	this.eggs = $H();

	this.statics = $A();
	this.page_current = null;

	this.offset_scroll = 500;

	this.history = $A();
}

Page.prototype.setScroll = function(id_page, value)
{
	var __egg = this.eggs[id_page];
	if (! __egg)
	{
		return false;
	} else {
		__egg.setScroll(value);
	}

	return true;
}

Page.prototype.reset = function(id_page)
{
	var __egg = this.eggs[id_page];
	if (! __egg)
	{
		return false;
	} else {
		__egg.reset();
	}

	return true;
}

Page.prototype.fire = function(id_page)
{
	var __egg = this.eggs[id_page];
	if (! __egg)
	{
		return false;
	} else {
		__egg.fire();
	}

	return true;
}

Page.prototype.initialize = function()
{
	/* find element in page & pager */
	var __children_page = findChildren(this.parent_node.id, "LI");
	var __children_pager = findChildren(this.parent_pager.id, "LI");

	/* check elements */
	var __reg_page = new RegExp("^page-", "g");
	var __reg_pager = new RegExp("^pager-", "g");

	var __self = this;

	$A(__children_page).each(
		function(e)
		{
			if (! e.id) return;
			if (e.id.search(__reg_page) == -1)
			{
				return;
			} else {
				// register
				var __id_page = e.id.replace("page-", "");
				__self.pages.push(__id_page);

				// and set size.
				__self.__setSizePage(e);

				// add egg
				var __options = $H();
				var __id_scrollable = e.getAttribute("id_scrollable");
				if (__id_scrollable && trimString(__id_scrollable))
				{
					__options["id_scrollable"] = __id_scrollable;
				}
				var __egg = new Egg(__id_scrollable, __options);
				__self.eggs[__id_page] = __egg;
			}
		}
	);

	// set the scroll to 0
	this.parent_pager0.scrollLeft = 0;

	// show right scroll button
	var __div_scroll_left = document.createElement("DIV");
	var __div_scroll_right = document.createElement("DIV");

	/*
	__div_scroll_left.style.background = "transparent url('/__media__/image/pager-background.png') top left repeat-x";
	__div_scroll_left.style.padding = "0 5px 0 5px";
	__div_scroll_left.style.position = "fixed";
	__div_scroll_left.style.left = 0 + "px";
	*/
	__div_scroll_left.className = "arrow_left";
	__div_scroll_left.style.top = this.parent_pager.offsetTop + "px";
	__div_scroll_left.style.height = this.parent_pager.offsetHeight + "px";

	/*
	__div_scroll_right.style.background = "transparent url('/__media__/image/pager-background.png') top left repeat-x";
	__div_scroll_right.style.padding = "0 5px 0 5px";
	__div_scroll_right.style.position = "fixed";
	__div_scroll_right.style.right = 0 + "px";
	*/
	__div_scroll_right.className = "arrow_right";
	__div_scroll_right.style.height = this.parent_pager.offsetHeight + "px";
	__div_scroll_right.style.top = this.parent_pager.offsetTop + "px";

	var __button_scroll_left = document.createElement("IMG");
	__div_scroll_left.appendChild(__button_scroll_left);
	__button_scroll_left.src = "/__media__/image/arrow_prev0-40.png";

	__div_scroll_left.onclick = function(e)
	{
		new Effect.ScrollPager(__self, __self.offset_scroll * -1);
	}

	var __button_scroll_right = document.createElement("IMG");
	__button_scroll_right.src = "/__media__/image/arrow_next0-40.png";
	__div_scroll_right.appendChild(__button_scroll_right);

	__div_scroll_right.onclick = function(e)
	{
		var __pager_last = $("pager-link-" + __self.pages[__self.pages.length - 1]);
		var __left_last = __pager_last.offsetLeft + __pager_last.offsetWidth;

		var __current_scroll =
			__self.parent_pager0.scrollLeft + __self.parent_pager0.offsetWidth;

		if (__left_last > __current_scroll)
		{
			var __max = __left_last - __current_scroll;
			var __offset = __self.offset_scroll;
			if (__max < __self.offset_scroll)
			{
				__offset = __max;
			}
			new Effect.ScrollPager(__self, __offset);
		}
	}

	var __body = document.getElementsByTagName("body");
	__body[0].appendChild(__div_scroll_left);
	__body[0].appendChild(__div_scroll_right);

}

Page.prototype.__setSizePage = function(obj_li)
{
	var __height = $("block_pages").offsetHeight;
	var __width = $("block_pages").offsetWidth;
	obj_li.style.height = __height - 10 + "px";
	obj_li.style.width = __width - 10 + "px";
}

Page.prototype.isExist = function(id_page)
{
	/* check whether this page in pages or not */
	if (this.pages.indexOf(id_page) == -1)
	{
		return false;
	} else {
		return true;
	}
}

Page.prototype.removePage = function(id_page)
{
	if (! this.isExist(id_page)) return false;

	this.parent_node.removeChild($("page-" + id_page));
	this.parent_pager.removeChild($("pager-" + id_page));

	this.pages.splice(this.pages.indexOf(id_page), 1)

	__GRIDS__.remove("grid-" + id_page);

	// remove from history
	while (1)
	{
		var __i = this.history.indexOf(id_page);
		if (__i == -1)
		{
			break
		} else {
			this.history.splice(__i, 1);
		}
	}

	var __id_page = this.history.last();
	if (! __id_page) __id_page = "frontpage";

	if (__id_page != this.page_current)
	{
		this.showPage(__id_page);
	}

	return true;
}

Page.prototype.__addPage = function(id_page, html, options)
{
	var __li = document.createElement("LI");
	this.__setSizePage(__li);
	__li.className = "page";
	__li.id = "page-" + id_page;
	__li.innerHTML = html.stripScripts();
	__li.style.display = "none";
	//Element.setOpacity(__li, 0.5);

	this.parent_node.appendChild(__li);
	this.pages.push(id_page);

	// create egg for sophisticated handling.
	var __page = new Egg(id_page, options);
	this.eggs[id_page] = __page;

	return true;
}

Page.prototype.addPage = function(id_page, html, options)
{
	/* check whether id_page is already added or not */
	if (! this.isExist(id_page))
	{
		this.__addPager(id_page, options);
		this.__addPage(id_page, html, options);
	}

	this.showPage(id_page, html);

	return true;
}

Page.prototype.__showPage = function(id_page, html)
{
	if (id_page == this.page_current) return true;

	/* remember the state of scroll */

	/* show page and hide others */
	this.pages.each(
		function(id)
		{
			if (id != id_page)
			{
				Element.hide("page-" + id);
			}
		}
	);

	Element.show("page-" + id_page);
	if (html)
	{
		setTimeout(
			function(e)
			{
				html.evalScripts();
			},
			10
		);
	}

	// trigger egg's event.
	if (this.eggs[id_page])
	{
		this.eggs[id_page].onShow();
	}
}

Page.prototype.showPage = function(id_page, html)
{
	new Effect.Progress("page-" + id_page);

	this.__showPage(id_page, html);
	this.__showPager(id_page);

	this.page_current = id_page;
	this.history.push(id_page);

	var __self = this;
	setTimeout(
		function(e)
		{
			// scrolling */
			var __limit = __self.parent_pager0.scrollLeft +
				__self.parent_pager0.offsetWidth;
			var __limit_pager = $("pager-link-" + id_page).offsetLeft + $("pager-link-" + id_page).offsetWidth;
			if (__limit_pager > __limit)
			{
				new Effect.ScrollPager(
					__self,
					__limit_pager - __limit
				);
			}

			/*
			if (__left_right_side_pager > __self.parent_pager0.offsetWidth)
			{
				__self.parent_pager0.scrollLeft =
					$("pager-" + id_page).offsetLeft;
			}
			*/
		},
		100
	);

	return true;
}

Page.prototype.__addPager = function(id_page, options)
{
	var __self = this;
	var __li = document.createElement("LI");
	__li.className = "li_none";
	__li.id = "pager-" + id_page;

	var __link = document.createElement("A");
	__link.id = "pager-link-" + id_page;
	__link.href = "#";
	__link.page = this;
	__link.id_page = id_page;
	if (options.label && trimString(options.label))
	{
		var __label = options.label;
	} else {
		var __label = "Page " + id_page;
	}

	__link.innerHTML = __label;

	/* close button */
	var __button_close = document.createElement("IMG");
	__button_close.src = "/__media__/image/close-pager.png";
	__button_close.onmouseover = function()
	{
		this.src = "/__media__/image/close-pager-hover.png";
	}
	__button_close.onmouseout = function()
	{
		this.src = "/__media__/image/close-pager.png";
	}
	__button_close.onclick = function()
	{
		__self.removePage(id_page);
		return false;
	}

	__link.appendChild(__button_close);

	/* attach callback */
	__link.onclick = function(e)
	{
		__self.showPage(id_page);
	}

	__li.appendChild(__link);

	__li.style.display = "none";
	//Element.setOpacity(__li, 0.5);

	this.parent_pager.appendChild(__li);

	Element.show("pager-" + id_page);

}

Page.prototype.__showPager = function(id_page)
{
	if (id_page == this.page_current) return true;

	this.pages.each(
		function(id)
		{
			if (id != id_page)
			{
				$("pager-link-" + id).className = "";
			}
		}
	);

	$("pager-link-" + id_page).className = "active";
	/*
	if (! this.isExist(id_page)) return false;
	*/

	return true;
}

Effect.Scroll2 = Class.create();
Object.extend(
	Object.extend(Effect.Scroll2.prototype, Effect.Base.prototype), {
		initialize: function(obj_page, offset)
		{
			this.page = $(obj_page);
			this.start(arguments[1] || {});
			this.offset = offset - this.page.scrollTop;
		},
		setup: function()
		{
			Position.prepare();
			this.scrollStart = this.page.scrollTop;
		},
		update: function(position)
		{
			Position.prepare();
			this.page.scrollTop += position*this.offset;
		}
	}
);

Effect.ScrollPager = Class.create();
Object.extend(
	Object.extend(Effect.ScrollPager.prototype, Effect.Base.prototype), {
		initialize: function(obj_page, offset)
		{
			this.page = obj_page;
			this.start(arguments[1] || {});
			this.offset = offset;
		},
		setup: function()
		{
			Position.prepare();
			this.scrollStart = this.page.parent_pager0.scrollLeft;
		},
		update: function(position)
		{
			Position.prepare();
			this.page.parent_pager0.scrollLeft =
				this.scrollStart + (position*this.offset);
		}
	}
);

Effect.Progress = Class.create();
Object.extend(
	Object.extend(
		Effect.Progress.prototype,
		Effect.Base.prototype
	),
	{
		initialize: function(element)
		{
			this.element = $(element);
			var options = Object.extend(
				{ duration: 0.5 },
				arguments[1] || {}
			);
			this.start(options);
		},
		setup: function()
		{
			this.layer = document.createElement("DIV");

			var __size = {
				position: "fixed",
				top : this.element.offsetTop + "px",
				left : this.element.offsetLeft + "px",
				width: this.element.offsetWidth + "px",
				height: this.element.offsetHeight + "px",
				backgroundColor: "white"
			}

			this.layer.setStyle(__size);

			// create running image element.
			var __running = document.createElement("DIV");
			this.layer.appendChild(__running);

			var __image = document.createElement("IMG");
			__image.src = "/__media__/image/running.gif";
			__running.appendChild(__image);

			// set style
			__running.setStyle(
				{
					position: "fixed",
					top : this.element.offsetTop + (this.element.offsetHeight / 2) + "px",
					left : this.element.offsetLeft + (this.element.offsetWidth / 2) + "px",
				}
			);

			this.layer.setOpacity(0.7);
			this.layer.appendChild(__running);
			this.element.parentNode.appendChild(this.layer);
		},
		update: function(position)
		{
		},
		finish: function()
		{
			this.element.parentNode.removeChild(this.layer);
		}
	}
);

