Resizer = Class.create();
Object.extend(Object.extend(Resizer.prototype), {
	initialize: function(element) {
		if (typeof element == 'object')
		{
			this.element = element;
		} else {
			this.element = $(element);
		}

		this.options = Object.extend(
			{
				handle: element,
				vertical: false,
				horizontal: false,
				maxHeight: 1000,
				minHeight: 10,
				maxWidth:	1000,
				minWidth: 10,
				onMove: function(){ return true;},
				afterFinish: function(){return true;}
			},
			arguments[1] || {}
		);

		if (typeof this.options.handle == "object")
		{
			this.handler = this.options.handle;
		} else {
			this.handler = $(this.options.handle);
		}

		this.setup();
	},
	setup: function() {
		this.eventMouseUp = this.eventUp.bindAsEventListener(this);
		//this.eventMouseOut = this.eventOut.bindAsEventListener(this);
		this.eventMouseDown = this.eventDown.bindAsEventListener(this);
		this.eventMouseMove = this.eventMove.bindAsEventListener(this);

		this.resetPosition();
		this.resize = false ;

		Event.observe(this.handler, "mousedown", this.eventMouseDown);
		//Event.observe($(this.options.handle), "mouseout", this.eventMouseOut);
		Event.observe(document, "mouseup", this.eventMouseUp);
		Event.observe(document, "mousemove", this.eventMouseMove);
	},
	resetPosition: function()
	{
		var position = this.element.style.position ;
		this.element.style.position = 'absolute' ;
		this.top = this.element.offsetTop;
		this.left = this.element.offsetLeft;
		this.element.style.position = position ;
	},
	eventUp: function(event) {
		this.resize = false ;
		this.options.afterFinish();
	},
	eventDown: function(event) {
		this.resize = true ;
	},
	eventMove: function(event) {
		if(this.resize)
		{
			var d = {};
			if(this.options.horizontal)
			{
				var width = ( Event.pointerX(event) - this.left );
				if(width < this.options.maxWidth && width > this.options.minWidth)
				{
					d.width = width + 'px' ;
				}
			}
			if(this.options.vertical)
			{
				var height = ( Event.pointerY(event) - this.top );
				if(height < this.options.maxHeight && height > this.options.minHeight)
				{
					d.height = height + 'px';
				}
			}
			this.element.setStyle(d);
		}
	}
}
);

ResizerWithSiblings = Class.create();
Object.extend(Object.extend(ResizerWithSiblings, Resizer), {

	initialize: function(element) {
		if (typeof element == 'object')
		{
			this.element = element;
		} else {
			this.element = $(element);
		}

		this.options = Object.extend(
			{
				handle: element,
				vertical: false,
				horizontal: false,
				maxHeight: 1000,
				minHeight: 10,
				maxWidth:	1000,
				minWidth: 10,
				sibling: null,
				onMove: function(){}
			},
			arguments[1] || {}
		);

		this.sibling = $(this.options.sibling);
		this.setup();
	},
	onMove: function(event)
	{
		var d = {};
		if(this.options.vertical)
		{
			var __height = ( Event.pointerY(event) - this.top );
			if(__height >= this.options.maxHeight || __height <= this.options.minHeight)
			{
				return;
			}

			var height = this.options.maxHeight - __height;
			if(height < this.options.maxHeight && height > this.options.minHeight)
			{
				d.height = height + 'px';
				this.sibling.setStyle(d);
				return true;
			}
		}

	}

});


