# -*- coding: utf-8 -*-
#	Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#	   This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, XmlMarshaller, time
import Conf, UID, func

BOOKMARK_ITEM_DATA = { \
	"__uid__" : "str", \
	"__parent__" : "str", \
	"__timestamp_added__" : "float", \
	"label" : "str", \
	"type" : "str", \
	"value" : "str", \
	"command" : "str", \
	"use_system_default_font" : "bool", \
	"font" : "str", \
	"color_foreground" : "str", \
	"color_background" : "str", \
	"color_dim" : "str", \
	"color_highlight" : "str", \
	"color_cursor" : "str", \
	"max_scroll_line" : "int", \
	"vte_background_shade" : "float", \
	"vte_background_type" : "str", \
	"vte_background_image_file" : "str", \
	"external_command_exit_without_enter" : "bool" \
}

BOOKMARK_ITEM_DATA_SKEL = { \
	"__uid__" : str(), \
	"__parent__" : str(), \
	"__timestamp_added__" : float(), \
	"label" : str(), \
	"type" : str(), \
	"value" : str(), \
	"command" : str(), \
	"use_system_default_font" : bool(), \
	"font" : str(), \
	"color_foreground" : str(), \
	"color_background" : str(), \
	"color_dim" : str(), \
	"color_highlight" : str(), \
	"color_cursor" : str(), \
	"max_scroll_line" : str(), \
	"vte_background_shade" : float(), \
	"vte_background_type" : str(), \
	"vte_background_image_file" : str(), \
	"external_command_exit_without_enter" : bool(), \
}

class One :

	__uid__ = None
	__parent__ = None
	__timestamp_added__ = None
	label = None
	type = None
	value = None

	command = str()
	use_system_default_font = False
	font = str()
	color_foreground = str()
	color_background = str()
	color_dim = str()
	color_highlight = str()
	color_cursor = str()
	max_scroll_line = str()
	vte_background_shade = float()
	vte_background_type = str()
	vte_background_image_file = str()

	def __init__(self, __uid__=str(), __parent__=str(), label=str(), type=str(), value=str()):

		self.__xmlname__ = "one"
		self.__xmlcomplextypename__ = "One"
		self.__xmlattr__ = \
			[ "__uid__", "__parent__", "__timestamp_added__", ]
		self.__xmlabbreviatednamespace__ = "pn"

		for i, j in BOOKMARK_ITEM_DATA_SKEL.items() :
			setattr(self, i, j)

		self.__uid__ = str(__uid__)
		self.__parent__ = str(__parent__)
		self.label = label
		self.type = type
		self.value = value

	def as_dict (self) :
		__skel = BOOKMARK_ITEM_DATA_SKEL
		for i, j in BOOKMARK_ITEM_DATA.items() :
			try :
				__skel[i] = func.casting(j, (getattr(self, i)))
			except ValueError, AttributeError :
				pass

		return __skel

	def absorb (self, obj) :
		for i, j in BOOKMARK_ITEM_DATA.items() :
			try :
				__value = func.casting(j, (getattr(obj, i)))
			except AttributeError :
				continue

			self.set_value(i, __value)

	def set_value (self, key, value) :
		if not hasattr(self, key) : return False

		# get type of this value.
		if not BOOKMARK_ITEM_DATA.has_key(key) :
			__type = "str"
		else :
			__type = BOOKMARK_ITEM_DATA[key]

		setattr(self, key, func.casting(__type, value))

		return True

	def get_value (self, key) :
		# get type of value.
		if BOOKMARK_ITEM_DATA.has_key(key) :
			__type = BOOKMARK_ITEM_DATA[key]
		else :
			__type = str

		if not hasattr(self, key) : return None

		try :
			return func.casting(__type, (getattr(self, key)))
		except ValueError :
			return __type()

class Them :

	ITEM_LIST = dict()
	XML_TEMPLATE = \
"""<?xml version=\"1.0\"?>
%s"""

	UID_TREE = dict()
	UID_TREE[str(Conf.BOOKMARK_ITEM_NO_PARENT)] = list()

	BOOKMARK_FILE = None

	def __init__ (self) :
		pass

	def add_item (self, __item) :
		if not isinstance(__item, One) : return False
		if not hasattr(__item, "__uid__") : return False

		self.ITEM_LIST[__item.__uid__] = __item
		self.__insert_uid_tree(__item.__parent__, __item.__uid__)

		return True

	def marshal (self) :
		__xml_dumps = str()
		if len(self.ITEM_LIST) < 1 :
			self.initiate()
		for i in self.ITEM_LIST.values() :
			__xml_dumps += XmlMarshaller.marshal(i)

		return self.XML_TEMPLATE % __xml_dumps

	def unmarshal (self, xml_string) :
		self.__get_xml_from_string(xml_string)

	def get_root (self) :
		return self.get_child(Conf.BOOKMARK_ITEM_NO_PARENT)

	def get_child (self, parent_uid) :
		"""
		get_child() produces the sequence list of items by
		__timestamp_added property.
		"""
		if not self.UID_TREE.has_key(str(parent_uid)) : return list()

		__list0 = list()
		for i in self.UID_TREE[parent_uid] :
			if not self.ITEM_LIST.has_key(i) : continue
			__list0.append(i)

		# sort item by timestamp when added.
		__list1 = dict()

		for i in self.UID_TREE[parent_uid] :
			if not self.ITEM_LIST.has_key(i) : continue
			__list1.update( \
				{self.ITEM_LIST[i].get_value("__timestamp_added__") : i} \
			)

		__ts = __list1.keys()
		__ts.sort()

		__list2 = list()
		[__list2.append(__list1[i]) for i in __ts]

		return __list2

	def get_parent (self, uid) :
		for i, j in self.UID_TREE.items() :
			if str(uid) in j : return i

		return None

	def get_value (self, uid, asDict=False) :
		if not self.ITEM_LIST.has_key(str(uid)) : return None

		if asDict :
			return self.ITEM_LIST[str(uid)].as_dict()
		else :
			return self.ITEM_LIST[str(uid)]

	def add_new (self, uid, __parent__, label, type, value):
		if self.ITEM_LIST.has_key(str(uid)) : return False

		__i = One(uid, __parent__, label, type, value)

		# remember the timestamp value when added.
		__i.set_value("__timestamp_added__", repr(float(time.time())))
		return self.add_item(__i)

	def remove (self, uid) :
		# remove recursively, so find child items and remove it FIRST.
		__item_child = self.get_child(uid)

		if len(__item_child) > 0 :
			for i in __item_child :
				if not self.remove(i) :
					return False

		try :
			del(self.ITEM_LIST[uid])
		except KeyError :
			return False

		return True

	def set_value (self, uid, key, value) :
		if not self.ITEM_LIST.has_key(str(uid)) : return False
		if not hasattr(self.ITEM_LIST[str(uid)], key) : return False

		return self.ITEM_LIST[str(uid)].set_value(key, value)

	def get_setting (self, uid) :
		if not self.ITEM_LIST.has_key(str(uid)) : return None

		__item = self.ITEM_LIST[str(uid)]
		__dict = dict()
		for i in Conf.BOOKMARK_ITEM_SETTING :
			__dict[i.replace("_", "-")] = __item.get_value(i)

		return __dict

	def save_setting (self, uid, setting) :
		if not self.ITEM_LIST.has_key(str(uid)) : return None

		for i, j in setting.items() :
			if not self.ITEM_LIST[str(uid)].set_value(i.replace("-", "_"), j) :
				return False

		self.__export__()
		return True

	def __export__ (self, filename="") :
		if not filename.strip() or \
				not os.path.isfile(filename) :
			filename = self.BOOKMARK_FILE

		__xml_data = self.marshal()
		f = open(filename, "w")
		f.write(__xml_data)
		f.close()

	def __import__ (self, filename=Conf.BOOKMARK_FILE) :
		self.BOOKMARK_FILE = filename

		if os.path.isfile(filename) :
			self.get_xml_from_file(filename)
		else :
			# initiate
			self.initiate()

	def initiate (self) :
		self.add_new( \
			Conf.BOOKMARK_ITEM_UID_NO_PARENT, \
			str(Conf.BOOKMARK_ITEM_NO_PARENT), \
			"Bookmark", "category", str() )

	##################################################
	def __insert_uid_tree (self, parent, uid) :
		"""
		make uid and parent tree.
		"""
		if str(parent).strip() :
			if not self.UID_TREE.has_key(parent) :
				self.UID_TREE[parent] = list()
			__parent = parent
		else :
			__parent = Conf.BOOKMARK_ITEM_NO_PARENT

		self.UID_TREE[__parent].append(uid)

	def get_xml_from_file (self, filename) :
		try :
			f = open(filename, "r")
			__xml_data = "".join(f.readlines())
			self.__get_xml_from_string(__xml_data)
		except IOError :
			pass

	def __get_xml_from_string (self, xml_string) :
		__a = xml_string.strip().split("<one")

		for i in __a :
			try :
				__obj = self.__get_one_obj_from_string("<one%s" % i)
			except :
				continue

			self.add_item(__obj.one)

	def __get_one_obj_from_string (self, xml_string) :
		return XmlMarshaller.unmarshalText( \
			xml_string, pathMappings = {"one" : One, })

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "BookmarkItem.py"


