# -*- coding: utf-8 -*-
#	Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#	   This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, XmlMarshaller
import func

ITEM_DATA = { \
	"__uid__" : "str", \
	"name" : "str", \
	"host" : "str", \
	"password" : "str", \
	"port" : "int", \
	"user" : "str", \
	"ssh_version" : "int", \
}

ITEM_DATA_SKEL = { \
	"__uid__" : str(), \
	"name" : str(), \
	"host" : str(), \
	"password" : str(), \
	"port" : int(), \
	"user" : str(), \
	"ssh_version" : int(), \
}

class One :

	__uid__ = str()
	name = str()
	host = str()
	port = int()
	user = str()
	password = str()
	ssh_version = int()

	def __init__(self, uid=str()) :

		self.__xmlname__ = "one"
		self.__xmlcomplextypename__ = "One"
		self.__xmlattr__ = \
			[ \
				"__uid__", \
			]
		self.__xmlabbreviatednamespace__ = "pn"

		for i, j in ITEM_DATA_SKEL.items() :
			setattr(self, i, j)

		self.__uid__ = uid

	def as_dict (self) :
		__skel = dict()
		for i, j in ITEM_DATA.items() :
			try :
				__skel[i] = func.casting(j, (getattr(self, i)))
			except ValueError, AttributeError :
				pass

		return __skel

	def absorb (self, obj) :
		for i, j in ITEM_DATA.items() :
			try :
				__value = func.casting(j, (getattr(obj, i)))
			except AttributeError :
				continue

			self.set_value(i, __value)

	def set_value (self, key, value) :
		if not hasattr(self, key) : return False

		# get type of this value.
		if not ITEM_DATA.has_key(key) :
			__type = "str"
		else :
			__type = ITEM_DATA[key]

		setattr(self, key, func.casting(__type, value))

		return True

	def get_value (self, key) :
		# get type of value.
		if ITEM_DATA.has_key(key) :
			__type = ITEM_DATA[key]
		else :
			__type = str

		if not hasattr(self, key) : return None

		try :
			return func.casting(__type, (getattr(self, key)))
		except ValueError :
			return __type()

class Them :

	ITEM_LIST = dict()
	XML_TEMPLATE = \
"""<?xml version=\"1.0\"?>
%s"""

	FILE = None

	def __init__ (self) :
		pass

	def __len__ (self) :
		return len(self.ITEM_LIST)

	def is_valid_uid (self, uid) :
		if not self.ITEM_LIST.has_key(uid) :
			return False
		else :
			return True

	def remove (self, uid) :
		if not self.is_valid_uid(uid) : return False

		del(self.ITEM_LIST[str(uid)])

		return True

	def add_item (self, __item) :

		if not isinstance(__item, One) and not isinstance(__item, One) :
			return False
		if not hasattr(__item, "__uid__") : return False
		if self.is_valid_uid(__item.__uid__) : return False

		__o = One(__item.__uid__)
		__o.absorb(__item)

		self.ITEM_LIST[__item.__uid__] = __o

		return True

	def marshal (self) :
		__xml_dumps = str()
		if len(self.ITEM_LIST) < 1 : self.initiate()
		for i in self.ITEM_LIST.values() :
			__xml_dumps += XmlMarshaller.marshal(i)

		return self.XML_TEMPLATE % __xml_dumps

	def unmarshal (self, xml_string) :
		self.__get_xml_from_string(xml_string)

	def get_list (self) :
		__list = dict()
		for i, j in self.ITEM_LIST.items() :
			__list[j.name] = j.as_dict()

		return __list

	def get_value_by_key (self, uid, key) :
		if not self.is_valid_uid(uid) : return None

		return self.ITEM_LIST[str(uid)].get_value(key)

	def set_value (self, uid, key, value) :
		if not self.is_valid_uid(uid) : return None

		if hasattr(self.ITEM_LIST[str(uid)], key) :
			return self.ITEM_LIST[str(uid)].set_value(key, value)
		else :
			return False

	def get_value (self, uid, asDict=False) :
		if not self.is_valid_uid(uid) : return None

		if not asDict :
			return self.ITEM_LIST[str(uid)]
		else :
			return self.ITEM_LIST[str(uid)].as_dict()

	def __import__ (self, filename) :
		self.FILE = filename

		if os.path.isfile(filename) :
			self.get_xml_from_file(filename)
		else :
			# initiate
			self.initiate()

	def __export__ (self, filename="") :
		if not filename.strip() or \
				not os.path.isfile(filename) :
			filename = self.FILE

		__xml_data = self.marshal()
		f = open(filename, "w")
		f.write(__xml_data)
		f.close()

	def initiate (self) :
		pass

	def get_uid (self, title) :
		__list = list()

		for i, j in self.ITEM_LIST.items() :
			if j.get_value("title") == title :
				__list.append(i)

		return __list

	##################################################
	def get_xml_from_file (self, filename) :
		try :
			f = open(filename, "r")
			__xml_data = "".join(f.readlines())
			self.__get_xml_from_string(__xml_data)
		except IOError :
			pass

	def __get_xml_from_string (self, xml_string) :
		__a = xml_string.strip().split("<one")

		for i in __a :
			try :
				__obj = self.__get_one_obj_from_string("<one%s" % i)
			except :
				continue

			self.add_item(__obj.one)

	def __get_one_obj_from_string (self, xml_string) :
		return XmlMarshaller.unmarshalText( \
			xml_string, pathMappings = {"one" : One, })

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "RemovedItems.py"


