# -*- coding: utf-8 -*-
import logging, logging.handlers, sys

DIRECTORY_LOG = "log"
LOG_TYPE = "1"
LOG_MAXBYTE = 10000
LOG_BACKUPCOUNT = 50

class Log :

	logger = None

	MSG_FORMAT = "%(asctime)s %(levelname)s %(message)s"
	ERROR_PERMISSION = "Can not create log file, %s\n"

	def __init__ (self, name) :

		logfile = "%s/%s.log" % (DIRECTORY_LOG, name)

		self.logger = logging.getLogger("mesian_engine")

		self.__set_handler(logfile)
		self.__set()

	def __set_handler (self, logfile) :

		if LOG_TYPE == "1" :
			try :
				self.hdlr = logging.handlers.RotatingFileHandler( \
					logfile, "a", LOG_MAXBYTE, LOG_BACKUPCOUNT)
			except IOError :
				raise IOError, self.ERROR_PERMISSION % logfile
		else :
			self.hdlr = logging.FileHandler(logfile)

	def __set (self) :

		formatter = logging.Formatter(self.MSG_FORMAT)
		self.hdlr.setFormatter(formatter)

		self.logger.addHandler(self.hdlr)
		self.logger.setLevel(logging.INFO)

	def info (self, msg) :
		self.logger.info(msg)

	def warning (self, msg) :
		self.logger.warning(msg)

	def error (self, msg) :
		self.logger.error(msg)

	def critical (self, msg) :
		self.logger.critical(msg)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Log.py"


