# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, sre, os, urllib, xmlrpclib, time, glob
import gtk
import UID, Conf

import i18n
_ = i18n.gettext()

import time, random, socket, md5
def get_uid (args=str()) :
	"""
	Generates a universally unique ID.
	Any arguments only create more randomness.

	----------------------------------------------------------------------
	Written by Carl Free Jr.
	url : http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/213761
	----------------------------------------------------------------------
	"""

	t = long( time.time() * 1000 )
	r = long( random.random()*100000000000000000L )
	try:
		a = socket.gethostbyname( socket.gethostname() )
	except:
		# if we can't get a network address, just imagine one
		a = random.random() * 100000000000000000L
	data = str(t) + ' ' + str(r) + ' ' + str(a) + ' ' + args
	data = md5.md5(data).hexdigest()
	return data

def get_vee_id (VEE_IDS) :
	b = VEE_IDS.keys()

	if len(b) < 1 : return 0

	b.sort()

	return int(b.pop()) + 1

def is_valid_command (command) :
	if command.count(os.sep) > 0 :
		if not os.path.exists(command) :
			return False
		else :
			return True

	else :
		_i, _o, _e = os.popen3("/usr/bin/which %s" % command)

		if len(_o.readlines()) < 1 :
			return False
		else :
			return True

def escape_path (path) :
	return path.replace( \
		" ", "\\ ").replace( \
		"#", "\\#").replace( \
		"%", "\\%").replace( \
		"(", "\\(").replace( \
		")", "\\)")

def get_filename_from_uri (uri) :
	"""
	get the unix file path from uri
	"""

	__a = uri.split(":")
	if len(__a) < 2 : return uri

	slash = sre.compile("^//")
	__b = urllib.url2pathname(slash.sub("", __a[1])).strip()

	return __b

def parse_command_line_argument (command) :
	parsed_data = { \
		"environment" : tuple(),
		"command" : str(),
		"argument" : tuple(),
	}

	__a = command.split()

	if len(__a) < 2 :
		parsed_data["command"] = command.strip()
		return parsed_data

	q = sre.compile("[A-Z][A-Z_][A-Z_]*=.*") # env

	__env = list()
	__index_env = list()
	for i in range(len(__a)) :
		if q.findall(__a[i]) :
			__env.append(__a[i].strip())
			__index_env.append(i)
		else :
			break

	parsed_data["environment"] = tuple(__env)

	if len(__index_env) > 0 :
		__index = __index_env[-1]
	else :
		__index = -1

	try :
		__command = __a[__index + 1]
	except IndexError :
		return parsed_data

	parsed_data["command"] = __command

	try :
		__argv = __a[__index + 2:]
	except IndexError :
		return parsed_data

	parsed_data["argument"] = tuple(__argv)

	return parsed_data

def normalize_path (path) :
	return path.replace("~", os.getenv("HOME"))

def get_labelname (label_name, size=10) :
	if label_name.count(os.sep) < 1 and size is not None:
		try :
			return label_name[-size]
		except IndexError :
			return label_name
	else :
		__filename = os.path.basename(label_name)
		__pathname = os.path.dirname(label_name)

		if len(__filename) >= size or size is None :
			return __filename
		else :
			__a = __pathname[-(size - len(__filename)):]

			return os.path.join(__a, __filename)

def color_to_str (gdkColor) :
	if not isinstance(gdkColor, gtk.gdk.Color) :
		raise ValueError, \
			_("gdkColor must be the instance of gtk.gdk.Color.")

	color = "#%2X%2X%2X" % ( \
		gdkColor.red / 256, \
		gdkColor.green / 256, \
		gdkColor.blue / 256, \
	)

	return color.replace(" ", "0")

def str_to_color (color_spec, default="white") :
	try :
		return gtk.gdk.color_parse(color_spec)
	except ValueError :
		return gtk.gdk.color_parse(default)
	except TypeError :
		return None

def get_list_of_vee () :
	a, b, c = os.popen3("ps aux | grep python | grep vee | grep -v grep | awk '{print $2}'")

	return [i.strip() for i in b.readlines()]

import sre, socket
def is_ip_address (ip_address) :
	if sre.compile("[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*").findall(ip_address.strip()) :
		return True
	else :
		return False

def is_valid_ip_address (ip_address) :
	try :
		socket.inet_aton(ip_address.strip())
	except socket.error :
		return False
	else :
		return True

def is_valid_pid (pid) :
	if sys.platform == "linux2" :
		__directory_pid = "/proc/%d" % pid
		if not os.path.isdir(__directory_pid) :
			return False
		else :
			return True
	else :
		return True

def create_icon (icon_file_path, w=30, h=30) :
	"""
	@return pixbuf image.
	"""
	if not os.path.isfile(icon_file_path) :
		return None

	__i = gtk.Image()
	__i.set_from_file(icon_file_path)
	__i.set_property("icon-size", 0)

	__image = __i.get_pixbuf().scale_simple(w, h, 2)

	return __image

def parse_geometry (geom) :
	if geom.count("x") == 0 :
		w, h = None, None
	else :
		__wh = sre.compile("[1-9][0-9]*x[1-9][0-9]*").findall(geom)

		try :
			w, h = __wh[0].split("x")
		except IndexError :
			return None
		else :
			w, h = (int(w), int(h),)

	if geom.count("+") == 0 :
		x, y = None, None
	else :
		__xy = sre.compile("\+[1-9][0-9]*\+[1-9][0-9]*").findall(geom)

		try :
			x, y = __xy[0].replace("+", " ").split()
		except IndexError :
			return None
		else :
			x, y = (int(x), int(y),)

	return (w, h, x, y)

def remember_geometry (window, gconf_client, is_fullscreened=False) :
	if is_fullscreened : window.unfullscreen()

	(w, h) = window.get_data("window-size")
	(x, y) = window.get_position()

	gconf_client.set_value_by_conf( \
		"latest-window-geometry", \
		"%d,%d,%d,%d" % (w, h, x, y) \
	)

	# save the state of fullscreened or not.
	gconf_client.set_value_by_conf( \
		"is-fullscreen", is_fullscreened)

def get_parent_directory (path) :
	if not os.path.isdir(path) : return None

	return os.path.abspath(os.path.join(path, os.pardir))

def get_parent_directories (path) :
	__path = get_parent_directory(path)
	return get_subdirectories(__path)

def has_parent_directory (path) :
	if not os.path.isdir(path) : return False

	if len(get_parent_directories(path)) < 1 : return False
	else : return True

def get_subdirectories (path) :
	try :
		return filter(lambda i : os.path.isdir(i), \
			[ os.path.join(path, i)  for i in os.listdir(path) ])
	except OSError :
		return list()

def has_subdirectory (path) :
	if not os.path.isdir(path) : return False

	if len(get_subdirectories(path)) < 1 : return False
	else : return True

def get_pid_by_process_name (name) :
	cmd = "COLUMNS=10000 ps aux | grep \"%s\" | grep -v grep | awk '{print $2}'" % name

	i, o, e = os.popen3(cmd)
	__a = o.readlines()

	if len(__a) != 1 : return None

	try :
		__pid = int(__a[0].strip())
	except ValueError :
		return None

	return __pid

def parse_argument_of_ssh_options (data) :
	__a = xmlrpclib.loads(data)

	if len(__a[0]) < 2 :
		__uid = None
	else :
		__uid = __a[0][1]

	__data = eval(__a[0][0])

	if type(__data) is not dict : return (None, None)

	return (__uid, __data)

def parse_argument_of_veet (data) :
	__a = xmlrpclib.loads(data)

	if len(__a[0]) < 2 :
		__uid = None
	else :
		__uid = __a[0][1]

	__data = __a[0][0][1:]

	return (__uid, __data)

def casting (type, value) :

	if type == "str" :
		return str("%s" % value)
	elif type == "int" :
		if not value :
			return int()
		else :
			value = str(value)
			return int(value.split(".")[:1][0])
	elif type == "float" :
		if not value :
			return float()
		else :
			return float("%s" % value)
	elif type == "bool" :
		return bool(value)
	else :
		return value

def create_tmp_file () :
	__filename = "__%s__.tmp" % UID.get()

	return __filename


def get_formatted_time (timestamp, format="") :
	try :
		timestamp = int(timestamp)
	except ValueError :
		return ""
	except TypeError :
		return ""

	if not format.strip() : format = "Today %-I:%M:%S %p"

	format = sre.compile("today",sre.IGNORECASE).sub(_("Today"), format)

	return time.strftime(format, time.localtime(timestamp))

def get_elapsed_time (timestamp) :
	"""
	Calculate the elapsed time.
	@return : ()
	"""

	try :
		timestamp = int(timestamp)
	except ValueError :
		return ""
	except TypeError :
		return ""

	a = time.localtime((time.time() - timestamp) + \
		time.mktime((1970, 1,1,1,1,1,1,1,0)))

	__l = list()
	[ __l.append(i - 1) for i in a[1:] ]

	__a = ([(a[0] - 1970), ]  + __l)[:-3]

	__time = list()

	if __a[4] == 0 and __a[3] == 0 and __a[2] == 0 and \
			__a[1] == 0 and __a[0] == 0 :
		__time.append(_("%d seconds") % __a[5])

	if __a[4] != 0 : __time.append(_("%d minutes") % __a[4])
	if __a[3] != 0 : __time.append(_("%d hours") % __a[3])

	if __a[2] != 0 :
		__time.append(_("%d days") % __a[2])
	#else :
	#	__time.append(_("Today"))

	if __a[1] != 0 : __time.append(_("%d months") % __a[1])
	if __a[0] != 0 : __time.append(_("%d years") % __a[0])

	__time.reverse()
	return _("%s ago") % (" ".join(__time))

def cleanup_temporary_directory (tmp_directory) :
	for i in glob.glob("%s/*" % tmp_directory) :
		try :
			os.remove(i)
		except OSError :
			continue

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "func.py"


