# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, gtk, stat, pwd, grp
import __OS__, __VEE__, WIDGET, Panel, Parser, GNOME

class MethodList (__VEE__.Core, WIDGET.WIDGET) :

	FILENAME = str()
	PARSER = None
	PANEL = None

	def __init__ (self, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)
		self.VTE = kwargs["vte"]

		WIDGET.WIDGET.__init__(self, "box_method_list")
		self.PANEL = Panel.MethodList(self.xml, **kwargs)
		self.PARSER = Parser.PYTHON()

	def setFilename (self, filename=None) :
		if filename :
			self.FILENAME = filename

		__tooltip = gtk.Tooltips()
		# update label as filename.
		self.getWidget("label_filename").set_markup( \
			os.path.basename(self.FILENAME))

		__tooltip.set_tip(self.getWidget("eventbox_filename"), self.FILENAME)
		__tooltip.enable()

		self.PARSER.readFile(self.FILENAME)
		self.PARSER.format()

		# insert members,
		self.PANEL.insertRow(self.PARSER)

		if self.FILENAME and os.path.exists(self.FILENAME) :
			self.updateInfo()

	def updateInfo (self) :
		__stat = os.stat(self.FILENAME)
		__size = __OS__.get_filesize_as_readable(__stat[stat.ST_SIZE])
		__perm = __OS__.get_permission_oct2str( \
			__OS__.get_permission_st_mode2oct(__stat[stat.ST_MODE]))

		self.getWidget("label_filename0").set_label(os.path.basename(self.FILENAME))
		__tooltip = gtk.Tooltips()
		__tooltip.set_tip(self.getWidget("eventbox_filename0"), self.FILENAME)
		__tooltip.enable()

		self.getWidget("label_size").set_label(__size)
		self.getWidget("label_permission").set_label(__perm)

		self.getWidget("label_filetype").set_label(GNOME.get_mime_type(self.FILENAME))

		__icon = GNOME.Icon()
		__icon.SIZE = 100
		__pixbuf = __icon.getPixbufByFilename(self.FILENAME)
		self.getWidget("image_filetype").set_from_pixbuf(__pixbuf)

		self.getWidget("label_user").set_label(pwd.getpwuid(__stat[stat.ST_UID])[0])
		self.getWidget("label_group").set_label(grp.getgrgid(__stat[stat.ST_GID])[0])

	###################################################################
	# EVENT HANDLER
	def on_update (self, button) :
		self.setFilename()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ = "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "AddOn.py"


