# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""
Create widgets.
"""

import gtk
import WIDGET, GNOME, Conf

class __Button__ :

	WIDGET = None
	IMAGE = gtk.Image()
	LABEL = None

	def __init__ (self, type) :
		(__xml, self.WIDGET, ) = WIDGET.get_widget("button_%s" % type)

		"""

		Set relief
			gtk.RELIEF_NORMAL, gtk.RELIEF_HALF or gtk.RELIEF_NONE
		"""
		self.set_relief = self.WIDGET.set_relief

	def set_tooltip (self, text) :
		__tips = gtk.Tooltips()
		__tips.set_tip(self.WIDGET, text)

class ButtonLableAndImage (__Button__) :

	def __init__ (self) :
		__Button__.__init__(self, "image")

		__widgets = self.WIDGET.get_children()[0].get_children()[0].get_children()
		self.IMAGE = __widgets[0]
		self.LABEL = __widgets[1]

		self.set_label = self.LABEL.set_label
		self.set_from_stock = self.LABEL.set_from_stock
		self.set_from_icon_set = self.LABEL.set_from_icon_set

class ButtonImage (__Button__) :

	def __init__ (self) :
		__Button__.__init__(self, "image")

		__widgets = self.WIDGET.get_children()
		self.IMAGE = __widgets[0]

		self.set_from_stock = self.IMAGE.set_from_stock
		self.set_from_icon_set = self.IMAGE.set_from_icon_set

class ButtonLabel (__Button__) :

	def __init__ (self) :
		__Button__.__init__(self, "label")

		__widgets = self.WIDGET.get_children()
		self.LABEL = __widgets[0]

		self.set_label = self.LABEL.set_label

class WithGNOME :

	GNOME_ICON = None
	ICONS = dict()

	def generateIcon (self) :
		self.GNOME_ICON = GNOME.Icon()

		for __type, __icons in Conf.ICONS.items() :
			self.ICONS[__type] = self.__getIconPixbuf(__icons)

	def __getIconPixbuf (self, icons=list()) :
		__icon = None
		for i in icons :
			__icon = self.GNOME_ICON.getPixbufByIcon(i)
			if __icon : break

		if not __icon :
			__icon = self.GNOME_ICON.getNone()

		return __icon

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Widgets.py"


