# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, base64, marshal, gtk
import child, __VTE__, i18n, __OS__, Label, AddOn, GNOME

_ = i18n.gettext()

COMMAND_INIT = [ \
	"\033:set title titlestring=%f;;;%t\n:\n\n",
	"\033:set mouse=nvi\n:\n\n",
	"\033:set confirm\n:\n\n",
]

COMMAND_OPEN_FILE = "\033:e %s\n:\n\n"

class EGG (__VTE__.EGG) :

	CHILD_TYPE = child.TYPE_VIM
	FILENAME = ""

	def make (self) :
		__VTE__.EGG.make(self)

		# run initial command inside vim.
		for i in COMMAND_INIT :
			self.WIDGET.feed_child(i)

	def parse_command (self) :
		(__command, __argument, __environment, __directory, ) = \
			__VTE__.EGG.parse_command(self)

		# set base directory and the file(NOT FILES) to be read from vim.
		if self.SETTING.has_key("filename") :
			__directory = os.path.dirname(self.SETTING["filename"])
			if not os.path.isdir(__directory) :
				__directory = os.getenv("HOME")

			# set file
			self.FILENAME = self.SETTING["filename"]
			__argument += (self.SETTING["filename"], )

		return (__command, __argument, __environment, __directory, )

	def getTitle (self) :
		__a = __VTE__.EGG.getTitle(self)
		if not __a : return

		__b = __a.split(";;;")

		if len(__b) < 2 :
			return self.FILENAME
		else :
			__dirname = os.path.dirname(__OS__.normalize_path(__b[0]))
			if not os.path.isdir(__dirname) :
				__title = "".join(__b[1:])
			else :
				self.FILENAME = __b[1]
				__title = __b[0]

		return __title

	def exit (self) :
		__VTE__.EGG.exit(self)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = __OS__.get_filename_from_uri(selection.data)
		self.WIDGET.feed_child(COMMAND_OPEN_FILE % __path)

		return True

class TAB (__VTE__.TAB) :

	METHOD_LIST = None

	def getSetting (self) :
		__VTE__.TAB.getSetting(self)

		if not self.SETTING.has_key("command") :
			self.SETTING["command"] = self.GCONF_CLIENT.getValue("vim_command")

	def createLabel (self, labelname) :
		if self.SETTING.has_key("label") :
			__labelname = self.SETTING["label"]
		else :
			if not self.SETTING.has_key("filename") :
				__labelname = "VIM"
			else :
				__labelname = self.SETTING["filename"]

		__VTE__.TAB.createLabel(self, __labelname)

	def getAddOnWidget (self) :
		__filename = ""
		if self.SETTING.has_key("filename") :
			__filename = self.SETTING["filename"]

		if __filename :
			__widget = None
			if GNOME.get_mime_type(__filename) == "text/x-python" :
				self.METHOD_LIST = AddOn.MethodList( \
					vte=self.WIDGET_CHILD, state=self.STATE)

				self.METHOD_LIST.setFilename(__filename)
				__widget = self.METHOD_LIST.WIDGET_SELF

			return __widget
		else :
			return None

	def attach (self) :
		__box = gtk.HBox()
		__box.pack_start(self.WIDGET_CHILD, True)

		if self.SETTING["enable_scrollbar"] :
			__scrollbar = gtk.VScrollbar()
			__scrollbar.set_adjustment(self.WIDGET_CHILD.get_adjustment())
			__scrollbar.show()
			__box.pack_start(__scrollbar, False)

		__box.show()

		addon_widget = self.getAddOnWidget()

		if not addon_widget :
			self.HPANED = __box
		else :
			self.HPANED = gtk.HPaned()
			self.HPANED.pack1(__box, True)
			self.HPANED.pack2(addon_widget, False, True)
			self.HPANED.show()

		__a = self.NOTEBOOK.get_allocation()
		if not self.SETTING["filename"] :
			self.HPANED.set_position(__a.width)

		self.NOTEBOOK.append_page(self.HPANED, self.LABEL)

		self.WIDGET_CHILD.grab_focus()

		try :
			WIDGET.set_title( \
				self.MAIN_WINDOW, \
				self.GCONF_CLIENT, \
				self.OBJ_CHILD.getTitle()
			)
		except :
			pass

		return True

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "vim.py"


