# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, sys
import gtk
from vee import Conf__, Handler, Conf_i18n

DIR_HOME = os.getenv("HOME")

import vee
DIR_LIB = vee.__path__[0]

# DEFAULT FILES
FILE_BOOKMARK = os.path.join( \
	DIR_HOME, Conf__.DIR_LOCAL, "bookmark.xml")
FILE_COMMAND = os.path.join( \
	DIR_HOME, Conf__.DIR_LOCAL, "command.xml")

# GLADE FILES ##########################################################
__FILES_GLADE = { \
	"bookmark_property_category"  : "bookmark_property_category.glade", \
	"dialog"                      : "dialog.glade", \
	"menu"                        : "menu.glade", \
	"widget_repository"           : "widget_repository.glade", \
	"widget_preference0"          : "widget_preference0.glade", \
	"window"                      : "window.glade", \
}

FILES_GLADE = dict()
for i, j in __FILES_GLADE.items() :
	FILES_GLADE[i] = os.path.join(Conf__.DIR_LIBFILE, j)

FILES_GLADE["widget_vte"] = \
	os.path.join(DIR_LIB, "child/widget_vte.glade", )

DIR_GCONF_SCHEMA = \
	os.path.join(Conf__.DIR_SHARE, "gconf", "schemas")
FILE_GTKRC = os.path.join(Conf__.DIR_LIBFILE, ".gtkrc-2.0")

# GTKRC
TEMPLATE_GTKRC = \
"""
style "vee"
{
    font_name = "@@FONTNAME@@"
}

class "GtkWidget" style "vee"
"""

# ABOUT GCONF
GCONF_APP_DIR	=	"/apps/vee/"

# TREEVIEW COLUMN ID
TREEVIEW_TREE_PANEL_COLUMN_ICON = 0
TREEVIEW_TREE_PANEL_COLUMN_NAME = 1

TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_LABEL = 0
TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_KEY = 1
TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_UID = 2

TREEVIEW_PREFERENCE_PANEL_COLUMN_NAME = 0
TREEVIEW_PREFERENCE_PANEL_COLUMN_CLASS = 1
TREEVIEW_PREFERENCE_PANEL_COLUMN_CHILD_NAME = 2
TREEVIEW_PREFERENCE_PANEL_COLUMN_TYPE = 3

TREEVIEW_BOOKMARK_PANEL_COLUMN_ICON = 0
TREEVIEW_BOOKMARK_PANEL_COLUMN_NAME = 1
TREEVIEW_BOOKMARK_PANEL_COLUMN_UID = 2

TREEVIEW_TAB_LIST_PANEL_COLUMN_SEQ = 0
TREEVIEW_TAB_LIST_PANEL_COLUMN_ICON = 1
TREEVIEW_TAB_LIST_PANEL_COLUMN_NAME = 2
TREEVIEW_TAB_LIST_PANEL_COLUMN_PAGE = 3

COMBOBOX_INITIAL_MODULE_NONE = 0
COMBOBOX_INITIAL_MODULE_FROM_BOOKMARK = 1

# ICON SIZE
ICON_SIZE_PANEL_BOOKMARK = "ICON_SIZE_BUTTON"
ICON_SIZE_PROPERTY_TYPE = "ICON_SIZE_DIALOG"
ICON_SIZE_DASHBOARD_CHILD_TYPE = "ICON_SIZE_DIALOG"

# icons for child.
ICONS = { \
	"__default__"	: "gtk-missing-image", \
	"directory"		: "gnome-fs-directory", \
	"file"			: "gtk-file", \
	"link"			: "gnome-dev-symlink", \
	"up"				: "gtk-go-up", \
	"down"			: "gtk-go-down", \
	"category"		: "gnome-fs-directory", \
	"none"			: "gtk-stop", \
}

# DEFAULT KEYBOARD SHORTCUT
# GTK MODIFIER MASK list
NULL_MODIFIER_MASK = 0

AVAILABLE_MODIFIER_MASK = \
	gtk.gdk.SHIFT_MASK | \
	gtk.gdk.LOCK_MASK | \
	gtk.gdk.CONTROL_MASK | \
	gtk.gdk.MOD1_MASK | \
	gtk.gdk.MOD2_MASK | \
	gtk.gdk.MOD3_MASK | \
	gtk.gdk.MOD4_MASK | \
	gtk.gdk.MOD5_MASK
	#gtk.gdk.BUTTON1_MASK | \
	#gtk.gdk.BUTTON2_MASK | \
	#gtk.gdk.BUTTON3_MASK | \
	#gtk.gdk.BUTTON4_MASK | \
	#gtk.gdk.BUTTON5_MASK | \
	#gtk.gdk.RELEASE_MASK | \
	#gtk.gdk.MODIFIER_MASK

UPPER_SYMBOLS = { \
	"exclam" : "1",                 	"braceleft" : "7", \
	"numbersign" : "3",             	"Control_underscore" : "7", \
	"percent" : "5",                	"asterisk" : "8", \
	"asciicircum" : "6",            	"bracketleft" : "8", \
	"plus" : "equal",               	"Delete" : "8", \
	"braceleft" : "bracketleft",    	"parenleft" : "9", \
	"colon" : "semicolon",          	"bracketright" : "9", \
	"quotedbl" : "apostrophe",      	"parenright" : "0", \
	"asciitilde" : "grave",         	"braceright" : "0", \
	"bar" : "backslash",            	"underscore" : "minus", \
	"less" : "comma",               	"backslash" : "minus", \
	"greater" : "period",           	"Control_underscore" : "minus", \
	"question" : "slash",           	"Control_underscore" : "minus", \
	"dollar" : "4",                 	"braceright" : "bracketright", \
	"Control_backslash" : "4",      	"asciitilde" : "bracketright", \
	"at" : "2",                     	"Control_bracketright" : "bracketright", \
	"nul" : "2",                    	"greater" : "less", \
	"ampersand" : "7",              	"bar" : "less", \
}

LIST_KEYBOARD_SHORTCUT = {
	"keyboard_shortcut_open_file_select_dialog" : ("<Control><Shift>o" ,
		"self.ac_open_file_select_dialog "),
	"keyboard_shortcut_tab_list" : ("<Control><Alt>t" , "self.ac_tab_list "),
	"keyboard_shortcut_next_tab" : ("<Control>Page_Up" , "self.ac_next_tab "),
	"keyboard_shortcut_prev_tab" : \
		("<Control>Page_Down" , "self.ac_previous_tab"),
	"keyboard_shortcut_increase_font" : \
		("<Control>equal" , "self.ac_font_increase "),
	"keyboard_shortcut_decrease_font" : \
		("<Control>minus" , "self.ac_font_decrease "),
	"keyboard_shortcut_mainwindow_quit" : ("<Control>q" , "self.on_quit"),
	"keyboard_shortcut_tab_close" : ("<Control><Alt>w" , "self.on_close"),
	"keyboard_shortcut_modifier_switch_tab" : \
		("<Alt>%d", "self.ac_change_nth_tab"),
	"keyboard_shortcut_toggle_bookmark_window" : \
		("<Ctrl><Alt>b", "self.ac_toggle_bookmark_window"),
	"keyboard_shortcut_toggle_full_screen" : \
		("F11", "self.ac_toggle_full_screen"),
	"keyboard_shortcut_dashboard" : ("F12", "self.ac_dashboard"),
	"keyboard_shortcut_duplication_tab" : \
		("<Control><Shift>d", "self.ac_duplication_tab"),
}

KEYBOARD_SHORTCUT_LIST_FOR_TREEVIEW = { \
	"Modules" : tuple(), \
	"VEE" : ( \
		("keyboard_shortcut_mainwindow_quit", "Quit VEE", ), \
		("keyboard_shortcut_tab_close", "Close tab", ), \

		("keyboard_shortcut_dashboard", "View dashboard", ), \
		("keyboard_shortcut_toggle_full_screen", "Toggle fullscreen", ), \
		("keyboard_shortcut_toggle_bookmark_window", "Toggle bookmark window", ), \

		("keyboard_shortcut_next_tab", "Go next tab", ), \
		("keyboard_shortcut_prev_tab", "Go previous tab", ), \
		("keyboard_shortcut_increase_font", "Increase font size", ), \
		("keyboard_shortcut_decrease_font", "Decrease font size", ), \
		("keyboard_shortcut_open_file_select_dialog", "File and Directory dialog", ), \
	),
}

NOTEBOOK_REMOVE_OFFSET = -1

MAP_WIDGET = { \
	"vee" : { \
		"handler" : Handler.MAIN_WINDOW, \
		"handler-signal" : "", \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_VEE, \
	},
	"tab_list" : { \
		"handler" : Handler.TAB_LIST, \
		"handler-signal" : "", \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_TAB_LIST, \
	},
	"box_frontpage" : { \
		"handler" : None, \
		"handler-signal" : "", \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_VEE, \
	},
	"preferences" : { \
		"handler" : Handler.PREFERENCES, \
		"handler-signal" : dict(), \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_PREFERENCES, \
	},
	"filechooser_file_logging" : { \
		"handler" : Handler.FILEDIALOG_FILELOGGING, \
		"handler-signal" : dict(), \
		"glade-file" : "dialog", \
		"message" : Conf_i18n.LABEL_FILECHOOSER_FILE_LOGGING, \
	},
	"filechooser_select_file_and_directory" : { \
		"handler" : Handler.FILECHOOSER_SELECT_FILE_AND_DIRECTORY, \
		"handler-signal" : dict(), \
		"glade-file" : "dialog", \
		"message" : Conf_i18n.LABEL_FILECHOOSER_SELECT_FILE_AND_DIRECTORY, \
	},
	"menu_input_method" : { \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "menu", \
		"message" : Conf_i18n.LABEL_MENU_INPUT_METHOD, \
	},
	"menu_vte" : { \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "menu", \
		"message" : Conf_i18n.LABEL_MENU_VTE, \
	},
	"button_label_and_image" : { \
		"handler" : dict(), \
		"handler-signal" : dict(), \
		"glade-file" : "widget_repository", \
		"message" : Conf_i18n.LABEL_VEE, \
	},
	"button_label" : { \
		"handler" : dict(), \
		"handler-signal" : dict(), \
		"glade-file" : "widget_repository", \
		"message" : None, \
	},
	"button_image" : { \
		"handler" : dict(), \
		"handler-signal" : dict(), \
		"glade-file" : "widget_repository", \
		"message" : None, \
	},
	"menu_add_new" : { \
		"handler" : dict(), \
		"handler-signal" : dict(), \
		"glade-file" : "menu", \
		"message" : Conf_i18n.LABEL_MENU_ADD_NEW, \
	},
	"quit" : { \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_QUIT, \
	},
	"dashboard" : { \
		"handler" : Handler.DASHBOARD, \
		"handler-signal" : None, \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_DASHBOARD, \
	},
	"about" : { \
		"handler" : None, \
		"handler-signal" : None, \
		"glade-file" : "window", \
		"message" : None, \
	},
	"bookmark" : { \
		"handler" : Handler.BOOKMARK, \
		"handler-signal" : "", \
		"glade-file" : "window", \
		"message" : Conf_i18n.LABEL_BOOKMARK, \
	},
	"signal_message" : { \
		"handler" : None, \
		"handler-signal" : "", \
		"glade-file" : "dialog", \
		"message" : None, \
	},
	"box_method_list" : { \
		"handler" : Handler.BOX_METHOD_LIST, \
		"handler-signal" : None, \
		"glade-file" : "widget_repository", \
		"message" : None, \
	},
	"box_font" : { \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_vte", \
		"message" : Conf_i18n.LABEL_VTE, \
	},
	"box_color" : { \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_vte", \
		"message" : Conf_i18n.LABEL_VTE, \
	},
	"box_background" : { \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_vte", \
		"message" : Conf_i18n.LABEL_VTE, \
	},
	"box_etc" : { \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "widget_vte", \
		"message" : Conf_i18n.LABEL_VTE, \
	},

	"bookmark_property_category" : { \
		"handler" : None, \
		"handler-signal" : dict(), \
		"glade-file" : "bookmark_property_category", \
		"message" : Conf_i18n.LABEL_BOOKMARK_PROPERTY_CATEGORY, \
	},

}

MENU_ACCELERATOR_SSH_FILEBROWSER_FILELIST = { \
	"copy" : "<Control>c", \
	"cut" : "<Control>x", \
	"paste" : "<Control>v", \
	"remove" : "Delete", \
	"rename" : "F2", \
	"select_all" : "<Control>a", \
}

NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_FILE = 0
NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_DIRECTORY = 1

NOTEBOOK_PAGE_BOOKMARK_PROPERTY_VTE_FONT = 1
NOTEBOOK_PAGE_BOOKMARK_PROPERTY_VTE_COLOR = 2
NOTEBOOK_PAGE_BOOKMARK_PROPERTY_VTE_BACKGROUND = 3
NOTEBOOK_PAGE_BOOKMARK_PROPERTY_VTE_ETC = 4

#############################################################
# COMMAND LINE OPTION.
OPTIONS_VEET = { \
	"-v" : ("--as-vim", { \
			"action" : "store_true", \
			"dest" : "ARG_AS_VIM", \
			"default" : False, \
			"help" : "Start with vim. (Default)", \
		}, \
	), \
}

OPTIONS_VEE = { \
	"-V" : ("--start-with-vim", { \
			"action" : "store_true", \
			"dest" : "ARG_START_WITH_VIM", \
			"default" : False, \
			"help" : "Start with vim.", \
		}, \
	), \
	"-T" : ("--start-with-terminal", { \
			"action" : "store_true", \
			"dest" : "ARG_START_WITH_TERMINAL", \
			"default" : False, \
			"help" : "Start with terminal.", \
		}, \
	), \
	"-s" : ("--install-schema", { \
			"action" : "store_true", \
			"dest" : "ARG_INSTALL_SCHEMA", \
			"default" : False, \
			"help" : "Install GConf schema.", \
		}, \
	), \
	"-f" : ("--fullscreen", { \
			"action" : "store_true", \
			"dest" : "ARG_FULLSCREEN_WINDOW", \
			"default" : False, \
			"help" : "Start the window to be fullscreened.", \
		}, \
	), \
	"-x" : ("--maximize", { \
			"action" : "store_true", \
			"dest" : "ARG_MAXIMIZE_WINDOW", \
			"default" : False, \
			"help" : "Start the default window to be maximized.", \
		}, \
	), \
	"-g" : ("--geometry", { \
			"dest" : "ARG_GEOMETRY", \
			"metavar" : "GEOMETRY", \
			"default" : "", \
			"help" : "Set the initial geometry. ex) 500x400+10+10", \
		}, \
	), \
}


GCONF_MONOSPACE_FONT_NAME = "/desktop/gnome/interface/monospace_font_name"
GCONF_GNOME_INTERFACE_FONTNAME = "/desktop/gnome/interface/font_name"

TEMPLATE_RC_FILE = \
"""style \"vee\"
{
    font_name = \"%(fontname)s\"
}

class \"GtkWidget\" style \"vee\"
"""

###############################################################################
# D&D
DND_TARGET_COLOR = 100
DND_TARGET_BGIMAGE = 101
DND_TARGET_RESET_BG = 102
DND_TARGET_URI_LIST = 103
DND_TARGET_MOZ_URL = 104
DND_TARGET_UTF8_STRING = 105
DND_TARGET_COMPOUND_TEXT = 106
DND_TARGET_TEXT_PLAIN = 107
DND_TARGET_STRING = 108
DND_TARGET_TEXT_PLAIN = 109
DND_TARGET_TEXT = 110

# drag and drop target tables, it from terminal-screen.c in
# gnome-terminal.
DND_TARGET_TABLE = [
	( "application/x-color", 0, DND_TARGET_COLOR ),
	( "property/bgimage",    0, DND_TARGET_BGIMAGE ),
	( "x-special/gnome-reset-background", 0, DND_TARGET_RESET_BG ),
	( "text/uri-list",  0, DND_TARGET_URI_LIST ),
	( "text/x-moz-url",  0, DND_TARGET_MOZ_URL ),
	( "UTF8_STRING", 0, DND_TARGET_UTF8_STRING ),
	( "COMPOUND_TEXT", 0, DND_TARGET_COMPOUND_TEXT ),
	( "TEXT", 0, DND_TARGET_TEXT ),
	( "STRING",     0, DND_TARGET_STRING ),
	( "text/plain", 0, DND_TARGET_TEXT_PLAIN )
]

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Conf.py"


