# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gtk
from vee import WIDGET, i18n, Handler
_ = i18n.gettext()

class AskCloseAllTabDialog (WIDGET.WIDGET) :

	FUNCTIONS_QUIT = None

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("callback_functions") :
			raise ValueError, "callback_functions must be given."
		else :
			self.FUNCTIONS_QUIT = kwargs["callback_functions"]["functions_quit"]

		WIDGET.WIDGET.__init__(self, "quit")

	def on_quit (self, widget) :
		self.FUNCTIONS_QUIT()

		return True

class SignalMessage (WIDGET.WIDGET) :

	MESSAGE = None
	TYPE = None

	def __init__ (self, message, type) :
		self.MESSAGE = message
		self.TYPE = type

		WIDGET.WIDGET.__init__(self, "signal_message")

	def initialize (self) :
		if self.MESSAGE :
			__message = self.MESSAGE
			self.getWidget("label_signal_message").set_markup(_(__message))

		__image_widget = self.getWidget("image_signal_type")
		if self.TYPE == "info":
			__image_widget.set_from_stock( \
				gtk.STOCK_DIALOG_INFO, gtk.ICON_SIZE_DIALOG)
		else : # default is 'error'.
			__image_widget.set_from_stock( \
				gtk.STOCK_DIALOG_ERROR, gtk.ICON_SIZE_DIALOG)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Dialog.py"


