# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, gtk
from vee import WIDGET, Conf__, Conf, GConf, TAB, Dialog, child, i18n, \
	func, Handler, Widgets

_ = i18n.gettext()

def on_show_popup_ssh_filebrowser_filelist_remote \
		(obj, event, obj_panel, STATE) :
	SSHFileBrowser_FileList(event, obj_panel=obj_panel, state=STATE)

def on_show_popup_main \
		(obj, event, obj_vee, STATE) :
	Main(event, obj_vee=obj_vee, state=STATE)

class Main (WIDGET.WIDGET, Widgets.WithGNOME) :

	STATE = None
	STATE_GLOBAL = None
	STATE_LOCAL = None

	BOOKMARK = None
	GCONF_CLIENT = None
	OBJ_VEE = None

	def __init__ (self, event, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			self.STATE_GLOBAL = self.STATE["global"]
			self.STATE_LOCAL = self.STATE["local"]

			self.BOOKMARK = self.STATE_GLOBAL["bookmark"]
			self.GCONF_CLIENT = self.STATE_GLOBAL["gconf-client"]
			self.OBJ_VEE = kwargs["obj_vee"]

		# assign handler.
		self.on_quit							= None
		self.on_close_menu					= self.on_close

		self.on_quit_vee						= self.OBJ_VEE.on_quit
		self.on_close							= self.OBJ_VEE.on_close
		self.on_insert_vim 					= self.OBJ_VEE.on_insert_vim
		self.on_insert_terminal				= self.OBJ_VEE.on_insert_terminal
		self.on_insert_ssh					= self.OBJ_VEE.on_insert_ssh
		self.on_insert_ssh_filebrowser	= self.OBJ_VEE.on_insert_ssh_filebrowser

		self.on_open_file_dialog			= self.OBJ_VEE.on_open_file_dialog
		self.on_preferences					= self.OBJ_VEE.on_preferences
		self.on_run_external_command_dialog = \
			self.OBJ_VEE.on_run_external_command_dialog

		WIDGET.WIDGET.__init__(self, "menu_main")
		self.WIDGET_SELF.popup(None,None,None,event.button,event.time)

	def initialize (self) :
		__show_toolbar = self.getWidget("show_toolbar")
		__show_toolbar.set_active( \
			self.OBJ_VEE.getWidget("toolbar").get_property("visible") \
		)

		__show_bookmark_panel = self.getWidget("show_bookmark_panel")
		__show_bookmark_panel.set_active( \
			self.OBJ_VEE.getWidget("vbox59").get_property("visible") \
		)

		__show_toolbar.connect("button-release-event", self.on_toggle_toolbar)
		__show_bookmark_panel.connect("button-release-event",
		self.on_toggle_bookmark_panel)

		self.__insert_bookmark()

	def on_toggle_toolbar (self, widget, event) :
		self.OBJ_VEE.on_toggle_toolbar(widget)
		widget.set_active( \
			not self.OBJ_VEE.getWidget("toolbar").get_property("visible") \
		)

	def on_toggle_bookmark_panel (self, widget, event) :
		self.OBJ_VEE.on_toggle_bookmark_panel(widget)
		widget.set_active( \
			not self.OBJ_VEE.getWidget("vbox59").get_property("visible") \
		)

	def __insert_bookmark (self) :
		__menu = gtk.Menu()
		for i in self.BOOKMARK.getChild() :
			self.insert_item(__menu, i)

		__bookmark = self.xml.get_widget("bookmark_menu")
		__bookmark.set_submenu(__menu)

	def append_item (self, parent, data) :
		# get icon
		if not self.ICONS.has_key(data["type"]) :
			__pixbuf = self.ICONS["__default__"]
		else :
			__pixbuf = self.ICONS[data["type"]]

		#__i = gtk.ImageMenuItem(gtk.STOCK_OPEN)
		#__i.set_data("uid", data["uid"])
		#__i.get_children()[0].set_label(data["label"])
		#__i.get_children()[1].set_from_pixbuf(__pixbuf)
		__i = create_menu_item_by_pixbuf( \
			data["label"], __pixbuf, {"uid" : data["uid"]} \
		)

		if data["type"] != "category" :
			#__i.connect("activate", self.on_bookmark_activated)
			__i.connect("button-release-event", self.on_bookmark_activated)

		parent.append(__i)
		__i.show()

		return __i

	def insert_item (self, menu, node) :
		data = self.BOOKMARK.getValues(node)

		__item = self.append_item(menu, data)

		__childNode = self.BOOKMARK.getChild(node)
		if len(__childNode) > 0 :

			__menu = gtk.Menu()
			for i in __childNode :
				__i = self.insert_item(__menu, i)

			__item.set_submenu(__menu)

		return __item

	def on_bookmark_activated (self, item, parm=None) :
		__uid = item.get_data("uid")
		__data = self.BOOKMARK.getValuesByUID(__uid)

		if __data["type"] == "category" :
			return

		self.OBJ_VEE.addPage(__data["type"], **__data)
		self.on_close_menu(None)

class SSHFileBrowser_FileList_Local (WIDGET.WIDGET) :

	def __init__ (self, **kwargs) :

		self.OBJ_PANEL = kwargs["obj_panel"]

		self.on_copy = self.OBJ_PANEL.on_copy
		self.on_cut = self.OBJ_PANEL.on_cut
		self.on_paste = self.OBJ_PANEL.on_paste
		self.on_remove0 = self.OBJ_PANEL.on_remove0
		self.on_rename = self.OBJ_PANEL.on_rename
		self.on_select_all = self.OBJ_PANEL.on_select_all

		# assign handler.
		WIDGET.WIDGET.__init__(self, "menu_ssh_filebrowser_filelist_local")

	def popup (self, event) :
		self.WIDGET_SELF.popup(None,None,None,event.button,event.time)

	def initialize (self) :

		for widget_name, accel in \
				Conf.MENU_ACCELERATOR_SSH_FILEBROWSER_FILELIST.items() :
			__key, __mod = gtk.accelerator_parse(accel)

			print widget_name
			__widget = self.getWidget("%s_local" % widget_name).get_children()[0].get_accel_widget()
			__widget.add_accelerator("activate",
				self.WIDGET_SELF.get_accel_group(), __key, __mod, gtk.ACCEL_VISIBLE)

class SSHFileBrowser_FileList_Remote (WIDGET.WIDGET) :

	def __init__ (self, **kwargs) :

		self.OBJ_PANEL = kwargs["obj_panel"]

		self.on_copy = self.OBJ_PANEL.on_copy
		self.on_cut = self.OBJ_PANEL.on_cut
		self.on_paste = self.OBJ_PANEL.on_paste
		self.on_remove0 = self.OBJ_PANEL.on_remove0
		self.on_rename = self.OBJ_PANEL.on_rename
		self.on_select_all = self.OBJ_PANEL.on_select_all

		# assign handler.
		WIDGET.WIDGET.__init__(self, "menu_ssh_filebrowser_filelist_remote")

	def popup (self, event) :
		self.WIDGET_SELF.popup(None,None,None,event.button,event.time)

	def initialize (self) :

		for widget_name, accel in \
				Conf.MENU_ACCELERATOR_SSH_FILEBROWSER_FILELIST.items() :
			__key, __mod = gtk.accelerator_parse(accel)

			__widget = self.getWidget("%s_remote" % widget_name).get_children()[0].get_accel_widget()
			__widget.add_accelerator("activate",
				self.WIDGET_SELF.get_accel_group(), __key, __mod, gtk.ACCEL_VISIBLE)

def create_menu_item_by_pixbuf (label, pixbuf, data=dict()) :
	__m = gtk.ImageMenuItem(stock_name)
	for i, j in data.items() :
		__m.set_data(i, j)

	__m.get_children()[0].set_label(label)
	__m.get_children()[1].set_from_pixbuf(pixbuf)
	__m.show()

	return __m

def create_menu_item_by_stock_id (label, stock_id, size, data=dict()) :
	__m = gtk.ImageMenuItem(stock_id)
	for i, j in data.items() :
		__m.set_data(i, j)

	__m.get_children()[0].set_label(label)
	__m.get_children()[1].set_from_stock(stock_id, size)
	__m.show()

	return __m


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Menu.py"


