# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gtk, gobject, time, md5

class File :

	FILENAME = None
	CHECKSUM = None
	CALLBACK = None
	CALLBACK_ARGS = None

	RUNNING = False
	THIS_IS_MY_EVENT = False

	def __init__ (self, filename, interval, callback, *args) :

		if interval < 900 :
			interval = 1000

		self.FILENAME = filename
		self.CALLBACK = callback
		self.CHECKSUM = self.getChecksum()
		self.CALLBACK_ARGS = args
		self.INTERVAL = interval

	def start (self) :
		self.RUNNING = True
		gobject.timeout_add(self.INTERVAL, self.__monitor)

	def thisIsMyEvent (self) :
		self.THIS_IS_MY_EVENT = True

	def stop (self) :
		self.RUNNING = False

	def getChecksum (self) :
		try :
			fd = file(self.FILENAME, "r")
		except IOError :
			return None

		__data = fd.readlines()
		fd.close()

		return md5.new("".join(__data)).hexdigest()

	def __monitor (self) :
		__checksum = self.getChecksum()

		if not __checksum or not self.RUNNING :
			return False
		
		if self.CHECKSUM != __checksum :
			self.CHECKSUM = __checksum

			if self.THIS_IS_MY_EVENT :
				self.THIS_IS_MY_EVENT = False
			else :
				print "Update............ monitor."
				self.CALLBACK(*self.CALLBACK_ARGS)

		return True

if __name__ == "__main__" :
	def monitor (parm0, parm1):
		print "modified."

	File("222", 1000, monitor, "findme", "callme")

	gtk.main()


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Monitor.py"


