# -*- coding: utf-8 -*-
#	Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#	   This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sre, tempfile
import gtk, gobject, time, os, struct, tty, fcntl, stat, gnomevfs, shutil
from vee import Handler, WIDGET, func, Conf__, Conf, __TREEVIEW__, \
	GNOME, __XML__, __OS__, i18n, Widgets, Menu, child, __VEE__

from vee.child import __VTE__

_ = i18n.gettext()

class Bookmark (__TREEVIEW__.Core, Widgets.WithGNOME) :

	STATE = None
	STATE_LOCAL = None
	STATE_GLOBAL = None
	GCONF_CLIENT = None

	BOOKMARK = None
	CALLBACK_FUNCTIONS = dict()
	NODELIST = dict()
	DOM_TMP = None

	PROPERTIES = { \
		"enable-search" : False, \
		"fixed-height-mode" : False, \
		"headers-clickable" : False, \
		"headers-visible" : False, \
		"hover-expand" : False, \
		"hover-selection" : False, \
		"reorderable" : True, \
		"rules-hint" : True, \
	}

	def __init__ (self, xml, **kwargs) :
		"""
		kwargs is,
			state
		"""

		if not kwargs.has_key("callback_functions") :
			raise RuntimeError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		if not kwargs.has_key("state") :
			raise RuntimeError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			self.STATE_LOCAL = kwargs["state"]["local"]
			self.STATE_GLOBAL = kwargs["state"]["global"]
			self.GCONF_CLIENT = self.STATE_GLOBAL.get_value("gconf-client")
			self.BOOKMARK = self.STATE_GLOBAL.get_value("bookmark")

		xml.get_widget("eventbox_bookmark").connect( \
			"event", self.on_eventbox_bookmark)

		Widgets.WithGNOME.__init__(self, Conf.ICON_SIZE_PANEL_BOOKMARK)
		self.generateIcon()

		__TREEVIEW__.Core.__init__( \
			self, xml, "treeview-bookmark")

		self.enableDND()
		#self.set_cursor((0,))

	def generateIcon (self) :
		Widgets.WithGNOME.generateIcon(self)

		# add the icons of child module.
		for __child_name, __config in self.STATE_GLOBAL["children"].items() :
			__pixbuf = \
				self.GNOME_ICON.getPixbufByChildConfig(__child_name, __config)

			self.ICONS[__child_name] = __pixbuf

	def save_tree_to_xml (self) :
		self.DOM_TMP = __XML__.create_new_document("them")
		self.WIDGET_TREESTORE.foreach(self.__save_tree_to_xml)

		fd = file(Conf.FILE_BOOKMARK, "w")
		fd.write(self.DOM_TMP.toprettyxml(indent='\t', newl='\n'))
		fd.close()

		return True

	def getUID (self, iter) :
		if not iter : return None

		return self.WIDGET_TREESTORE.get_value(iter, \
			Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_UID)

	def __save_tree_to_xml (self, model, path, iter, user_data=None) :
		__uid = self.getUID(iter)

		try :
			__node = self.BOOKMARK.getNodeByUID(__uid).cloneNode(False)
		except AttributeError :
			return

		self.NODELIST[path] = __node

		if len(path) == 1 :
			self.DOM_TMP.documentElement.appendChild(__node)
		else :
			__node_parent = self.NODELIST[path[:-1]]
			__node_parent.appendChild(__node)

	def create_frame (self) :

		# create a CellRenderers to render the data
		__cell1 = gtk.CellRendererPixbuf()
		__cell2 = gtk.CellRendererText()
		__cell3 = gtk.CellRendererText()

		# set property.
		__cell1.set_property("width", 50)
		__cell1.set_property("xalign", 0.5)
		__cell2.set_property("xalign", 0.0)

		__cell2.connect("edited", self.on_rename_edited)
		__cell2.connect("editing-started", self.on_editing_started)
		__cell2.connect("editing-canceled", self.on_editing_canceled)

		self.tvcolumn1 = gtk.TreeViewColumn()
		self.tvcolumn2 = gtk.TreeViewColumn()
		self.tvcolumn1.set_expand(True)

		self.WIDGET_TREESTORE = gtk.TreeStore( \
			gobject.TYPE_OBJECT, gobject.TYPE_STRING, gobject.TYPE_STRING)

		# connect 'row-deleted' signal to on_row_deleted().
		#self.WIDGET_TREESTORE.connect("row-deleted", self.on_row_deleted)

		self.WIDGET_TREEVIEW.set_model(self.WIDGET_TREESTORE)

		# add columns to treeview
		self.WIDGET_TREEVIEW.append_column(self.tvcolumn1)

		self.tvcolumn1.pack_start(__cell1, False)
		self.tvcolumn1.pack_start(__cell2, False)
		self.tvcolumn2.pack_start(__cell3, False)

		self.tvcolumn1.set_attributes( \
			__cell1, pixbuf=Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_ICON)
		self.tvcolumn1.set_attributes( \
			__cell2, text=Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_NAME)
		self.tvcolumn2.set_attributes( \
			__cell3, text=Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_UID)

		self.tvcolumn1.set_resizable(True)
		self.tvcolumn1.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)

	def insert_row (self) :
		if self.HANDLER_ID.has_key("row-changed") :
			self.WIDGET_TREESTORE.handler_block(self.HANDLER_ID["row-changed"])

		self.WIDGET_TREESTORE.clear()
		if not self.BOOKMARK : return

		for i in self.BOOKMARK.getChild() :
			self.add_row(i)

		if self.HANDLER_ID.has_key("row-changed") :
			self.WIDGET_TREESTORE.handler_unblock(self.HANDLER_ID["row-changed"])

	def getRowDATA (self, iter) :
		if not iter or not self.WIDGET_TREESTORE.iter_is_valid(iter) :
			return

		__uid = self.WIDGET_TREESTORE.get_value( \
			iter, Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_UID)
		__node = self.BOOKMARK.getNodeByUID(__uid)

		if not __node :
			return None

		data = self.BOOKMARK.getValues(__node)

		# get icon
		if data["type"] == "vim" :
			if not data["filename"] :
				__pixbuf = self.ICONS[data["type"]]
			else :
				__pixbuf = self.GNOME_ICON.getPixbufByFilename(data["filename"])
		else :
			if not self.ICONS.has_key(data["type"]) :
				__pixbuf = self.ICONS["__default__"]
			else :
				__pixbuf = self.ICONS[data["type"]]

		return (__pixbuf , data["label"], data["uid"], )

	def add_row (self, node, iter_parent=None) :
		data = self.BOOKMARK.getValues(node)
		if not data : return None

		# get icon
		if data["type"] == "vim" :
			__pixbuf = self.GNOME_ICON.getPixbufByFilename(data["filename"])
		else :
			if not self.ICONS.has_key(data["type"]) :
				__pixbuf = self.ICONS["__default__"]
			else :
				__pixbuf = self.ICONS[data["type"]]

		__iter = self.WIDGET_TREESTORE.append( \
			iter_parent, \
			[__pixbuf , data["label"], data["uid"], ] \
		)

		for i in self.BOOKMARK.getChild(node) :
			self.add_row(i, __iter)

		return __iter

	##################################################
	# EVENT HANDLER
	def on_drag_data_get_data \
			(self, treeview, context, selection, target_id, etime) :

		if context.action == gtk.gdk.ACTION_MOVE:
			return

		elif context.action == gtk.gdk.ACTION_COPY :
			(__treestore, __iter, ) = self.get_selected()

			__uri = "bookmark://%s" % self.WIDGET_TREESTORE.get_value( \
				__iter, Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_UID)

			selection.set( \
				selection.target, 8, __OS__.make_uri_list_from_list([__uri, ]) \
			)

		return True

	def on_drag_data_received_data \
			(self, treeview, context, x, y, selection, info, etime) :

		__treestore, iter_to_copy = self.get_selected()
		temp = self.WIDGET_TREEVIEW.get_dest_row_at_pos(x, y)
		if temp != None:
			path, pos = temp
		else:
			path, pos = \
				(len(self.WIDGET_TREESTORE) - 1, ), gtk.TREE_VIEW_DROP_AFTER

		target_iter = self.get_iter(path)
		if self.check_row_path(iter_to_copy, target_iter):
			self.iter_copy(iter_to_copy, target_iter, pos)

			context.finish(True, True, etime)
			#self..expand_all()
		else:
			context.finish(False, False, etime)

		return

	def iter_copy(self, iter_to_copy, target_iter, pos) :

		#[...retrieve data of the selected row...]
		__row_data = self.getRowDATA(iter_to_copy)
		if not __row_data :
			return

		if (pos == gtk.TREE_VIEW_DROP_INTO_OR_BEFORE) or (pos == gtk.TREE_VIEW_DROP_INTO_OR_AFTER) :
			new_iter = self.WIDGET_TREESTORE.prepend(target_iter, __row_data)

		elif pos == gtk.TREE_VIEW_DROP_BEFORE:
			new_iter = self.WIDGET_TREESTORE.insert_before(None, target_iter, __row_data)

		elif pos == gtk.TREE_VIEW_DROP_AFTER:
			new_iter = self.WIDGET_TREESTORE.insert_after(None, target_iter, __row_data)

		#[...copy over the values of the old row into the new one ...]

		for n in range(self.WIDGET_TREESTORE.iter_n_children(iter_to_copy)): 
			next_iter_to_copy = self.WIDGET_TREESTORE.iter_nth_child(iter_to_copy, n)
			self.iter_copy(next_iter_to_copy, new_iter, gtk.TREE_VIEW_DROP_INTO_OR_BEFORE)

		#[...remove old row...]
		self.remove(treeiter=iter_to_copy)

	def check_row_path (self, iter_to_copy, target_iter) :
		path_of_iter_to_copy = self.get_path(iter_to_copy)
		path_of_target_iter = self.get_path(target_iter)

		if path_of_target_iter[0:len(path_of_iter_to_copy)] == path_of_iter_to_copy :
			return False
		else:
			return True

	def on_changed_row (self, treemodel, path, iter, user_param1=None) :
		self.save_tree_to_xml()

	AVAILABLE_KEYNAMES_IN_PANEL_BOOKMARK = [ \
		"j", \
		"k", \
		"h", \
		"l", \
		"Right", \
		"Left", \
		"F2", \
		"Delete", \
		"<Alt>Return", \
		"<Control>a", \
	]
	IS_EDITING = False
	def on_eventbox_bookmark (self, widget, event) :
		if self.IS_EDITING :
			return

		if event.type in [gtk.gdk.KEY_RELEASE, gtk.gdk.KEY_PRESS, ] :
			__keyname = func.get_keyname(event)

			if __keyname not in self.AVAILABLE_KEYNAMES_IN_PANEL_BOOKMARK :
				return

			(__treestore, __treeiter, ) = self.get_selected()
			if not __treeiter : return
			__path = self.get_path(__treeiter)
			__column = self.WIDGET_TREEVIEW.get_column(0)

			if event.type == gtk.gdk.KEY_PRESS and __keyname == "j" :
				self.goDownOneRow()
			elif event.type == gtk.gdk.KEY_PRESS and __keyname == "k" :
				self.goUpOneRow()
			elif event.type == gtk.gdk.KEY_PRESS and __keyname == "l" :
				self.expandRow()
			elif __keyname == "Right" :
				self.expandRow()
			elif event.type == gtk.gdk.KEY_PRESS and __keyname == "h" :
				self.collapseRow()
			elif __keyname == "Left" :
				self.collapseRow()

			elif __keyname == "F2" and event.type not in [gtk.gdk.KEY_PRESS, ] :
				self.IS_EDITING = True
				(__store, __iter, ) = self.get_selected()
				self.set_editable( \
					__iter, 0, Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_NAME, \
				)

			elif __keyname == "Delete" and \
					event.type not in [gtk.gdk.KEY_PRESS, ] :
				(__store, __iter, ) = self.get_selected()
				if not __iter : return

				__uid = self.getUID(__iter)

				# remove from xml
				__this_node = self.BOOKMARK.getNodeByUID(__uid)
				__parent_node = self.BOOKMARK.getParent(__this_node)

				if not __parent_node : return
				__parent_node.removeChild(__this_node)

				# remove from panel.
				self.remove(treeiter=__iter)

			elif __keyname == "<Control>a" and \
					event.type not in [gtk.gdk.KEY_PRESS, ] :
				self.CALLBACK_FUNCTIONS["on_bookmark_add_current"](None)
			elif __keyname == "<Alt>Return" and \
					event.type not in [gtk.gdk.KEY_PRESS, ] :
				self.CALLBACK_FUNCTIONS["on_bookmark_property"](None)
			else :
				return

	###################################################################3
	# EVENT HANDLER
	def remove (self, **kwargs) :
		if kwargs.has_key("treeiter") :
			__path = self.get_path(kwargs["treeiter"])
		if kwargs.has_key("path") :
			__path = kwargs["path"]

		# set cursor to another row.
		self.on_row_deleted(self.WIDGET_TREESTORE, __path)
		self.save_tree_to_xml()
		return __TREEVIEW__.Core.remove(self, **kwargs)

	def on_row_deleted (self, treemodel, path) :
		__n = path[-1] - 1

		if len(path) < 2 :
			if __n < 0 :
				__next_row_to_focus = None
			else :
				__next_row_to_focus = (__n, )
		else :
			if __n < 0 :
				__next_row_to_focus = path[:-1]
			else :
				__next_row_to_focus = path[:-1] + (path[-1], )

		if __next_row_to_focus :
			self.set_cursor(__next_row_to_focus)

	def on_editing_started (self, cell, editable, path, user_param1=None) :
		self.IS_EDITING = True

	def on_editing_canceled (self, cell) :
		cell.set_property("editable", False)
		self.IS_EDITING = False

	def on_rename_edited (self, cell, path, new_text) :
		cell.set_property("editable", False)

		__iter = self.WIDGET_TREESTORE.get_iter(path)
		__uid = self.getUID(__iter)
		__node = self.BOOKMARK.getNodeByUID(__uid)

		self.BOOKMARK.setValue(__node, "label", new_text)
		self.save_tree_to_xml()
		self.set_value(path, Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_NAME, new_text)

		self.IS_EDITING = False

	def on_row_activated (self, treeview, path, view_column, user_param=None) :
		__iter = self.WIDGET_TREESTORE.get_iter(path)
		__uid = self.getUID(__iter)

		__data = self.BOOKMARK.getValuesByUID(__uid)

		if __data["type"] == "category" :
			if self.WIDGET_TREEVIEW.row_expanded(path) :
				self.WIDGET_TREEVIEW.collapse_row(path)
			else :
				self.WIDGET_TREEVIEW.expand_row(path, False)

			return

		if not self.CALLBACK_FUNCTIONS.has_key("addPage") : return

		self.CALLBACK_FUNCTIONS["addPage"](__data["type"], **__data)

class TabList (__VEE__.Core, __TREEVIEW__.Core, Widgets.WithGNOME) :

	WIDGET_ROOT = None
	TAB_LIST = None
	NOTEBOOK = None

	PROPERTIES = { \
		"enable-search" : False, \
		"fixed-height-mode" : False, \
		"headers-clickable" : False, \
		"headers-visible" : False, \
		"hover-expand" : False, \
		"hover-selection" : False, \
		"reorderable" : False, \
		"rules-hint" : False, \
	}

	def __init__ (self, xml, root, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)
		self.WIDGET_ROOT = root
		self.TAB_LIST = self.STATE_LOCAL["tab-list"]
		self.NOTEBOOK = self.STATE_LOCAL["notebook"]

		Widgets.WithGNOME.__init__(self, "ICON_SIZE_DIALOG")
		self.generateIcon()

		xml.get_widget("eventbox_tab_list").connect("event", self.on_event)

		__TREEVIEW__.Core.__init__(self, xml, "treeview-tab-list")

		
		self.set_cursor((self.NOTEBOOK.get_current_page(),))

	def generateIcon (self) :
		Widgets.WithGNOME.generateIcon(self)

		# add the icons of child module.
		for __child_name, __config in self.STATE_GLOBAL["children"].items() :
			__pixbuf = \
				self.GNOME_ICON.getPixbufByChildConfig(__child_name, __config)

			self.ICONS[__child_name] = __pixbuf

	def create_frame (self) :
		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()
		__cell1 = gtk.CellRendererPixbuf()
		__cell2 = gtk.CellRendererText()
		__cell3 = gtk.CellRendererText()

		# set property.
		__cell1.set_property("width", 50)
		__cell1.set_property("xalign", 0.5)
		__cell2.set_property("xalign", 0.0)
		__cell2.set_property("markup", True)

		self.tvcolumn1 = gtk.TreeViewColumn()
		self.tvcolumn1.set_expand(True)

		self.WIDGET_TREESTORE = gtk.TreeStore( \
			gobject.TYPE_STRING, gobject.TYPE_OBJECT, \
			gobject.TYPE_STRING, gobject.TYPE_PYOBJECT \
		)

		self.WIDGET_TREEVIEW.set_model(self.WIDGET_TREESTORE)

		# add columns to treeview
		self.WIDGET_TREEVIEW.append_column(self.tvcolumn1)

		self.tvcolumn1.pack_start(__cell0, False)
		self.tvcolumn1.pack_start(__cell1, False)
		self.tvcolumn1.pack_start(__cell2, False)

		self.tvcolumn1.set_attributes( \
			__cell0, markup=Conf.TREEVIEW_TAB_LIST_PANEL_COLUMN_SEQ)
		self.tvcolumn1.set_attributes( \
			__cell1, pixbuf=Conf.TREEVIEW_TAB_LIST_PANEL_COLUMN_ICON)
		self.tvcolumn1.set_attributes( \
			__cell2, markup=Conf.TREEVIEW_TAB_LIST_PANEL_COLUMN_NAME)

		self.tvcolumn1.set_resizable(True)
		self.tvcolumn1.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)

	def insert_row (self) :
		self.WIDGET_TREESTORE.clear()
		if not self.TAB_LIST : return

		n = 1
		for i in self.TAB_LIST :
			self.add_row(n, i)
			n += 1

	def add_row (self, num, page) :
		data = page.getObjectChild().PROPERTIES
		if not data : return None

		# get icon
		if page.getName() == "vim" :
			if not data["filename"] :
				__pixbuf = self.ICONS[page.getName()]
			else :
				__pixbuf = self.GNOME_ICON.getPixbufByFilename(data["filename"])
		else :
			if not self.ICONS.has_key(page.getName()) :
				__pixbuf = self.ICONS["__default__"]
			else :
				__pixbuf = self.ICONS[page.getName()]

		__iter = self.WIDGET_TREESTORE.append( \
			None, \
			[ \
				"<span size=\"x-large\">%s.</span>" % num, \
				__pixbuf , \
				"<span size=\"x-large\">%s</span>" % page.getObjectChild().getLabelName(), \
				page, \
			] \
		)

		return __iter

	##################################################
	# EVENT HANDLER
	AVAILABLE_KEYNAMES = [ \
		"j", \
		"k", \
	]
	def on_event (self, widget, event) :
		if event.type in [gtk.gdk.KEY_RELEASE, gtk.gdk.KEY_PRESS, ] :
			__keyname = func.get_keyname(event)

			if __keyname not in self.AVAILABLE_KEYNAMES :
				return

			(__treestore, __treeiter, ) = self.get_selected()
			if not __treeiter : return
			__path = self.get_path(__treeiter)
			__column = self.WIDGET_TREEVIEW.get_column(0)

			if event.type == gtk.gdk.KEY_PRESS and __keyname == "j" :
				self.goDownOneRow()
			elif event.type == gtk.gdk.KEY_PRESS and __keyname == "k" :
				self.goUpOneRow()
			else :
				return

	###################################################################3
	# EVENT HANDLER
	def on_row_activated (self, treeview, path, view_column, user_param=None) :
		__page = self.get_value(path, Conf.TREEVIEW_TAB_LIST_PANEL_COLUMN_PAGE)
		self.NOTEBOOK.set_current_page(__page.getPageNumber())

		# present main window.
		__vee = self.STATE_LOCAL["obj-vee"]
		__vee.WIDGET_SELF.present()
		__vee.setFocus()
		self.WIDGET_ROOT.present()
		self.WIDGET_TREEVIEW.grab_focus()

class Preference (__TREEVIEW__.Core) :

	STATE = None
	STATE_LOCAL = None
	STATE_GLOBAL = None
	GCONF_CLIENT = None

	WIDGET_SIDE = None
	WINDOW = None

	PROPERTIES = { \
		"enable-search" : False, \
		"fixed-height-mode" : False, \
		"headers-clickable" : False, \
		"headers-visible" : False, \
		"hover-expand" : False, \
		"hover-selection" : False, \
		"reorderable" : False, \
		"rules-hint" : False, \
	}

	def __init__ (self, xml, window, **kwargs) :
		"""
		kwargs is,
			state
		"""

		if not kwargs.has_key("state") :
			raise RuntimeError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			self.STATE_LOCAL = kwargs["state"]["local"]
			self.STATE_GLOBAL = kwargs["state"]["global"]
			self.GCONF_CLIENT = self.STATE_GLOBAL.get_value("gconf-client")
			self.BOOKMARK = self.STATE_GLOBAL.get_value("bookmark")

		self.WINDOW = window

		__TREEVIEW__.Core.__init__( \
			self, xml, "treeview-preference")

		self.BOX_SIDE = self.XML.get_widget("box_preferences_side")
		self.LABEL_SIDE = self.XML.get_widget("label_side")

		self.HANDLER_ID_CURSOR_CHANGED = \
			self.WIDGET_TREEVIEW.connect("cursor-changed", self.on_cursor_changed)

	def create_frame (self) :

		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()

		# set property.
		__cell0.set_property("xalign", 0.0)

		self.tvcolumn0 = gtk.TreeViewColumn()
		self.tvcolumn0.set_expand(True)

		self.WIDGET_TREESTORE = gtk.TreeStore( \
			gobject.TYPE_STRING, gobject.TYPE_STRING, \
			gobject.TYPE_STRING, gobject.TYPE_STRING \
		)

		self.WIDGET_TREEVIEW.set_model(self.WIDGET_TREESTORE)

		# add columns to treeview
		self.WIDGET_TREEVIEW.append_column(self.tvcolumn0)

		self.tvcolumn0.pack_start(__cell0, False)

		self.tvcolumn0.set_attributes( \
			__cell0, text=Conf.TREEVIEW_PREFERENCE_PANEL_COLUMN_NAME)

		self.tvcolumn0.set_resizable(True)
		self.tvcolumn0.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)

		#self.tvcolumn1.set_reorderable(True)

	def insert_row (self) :
		self.WIDGET_TREESTORE.clear()

		for child_name, j in self.STATE_GLOBAL["children"].items() :
			__config = j["layout"]["preferences"]
			if not __config.has_key("pages") : continue

			__iter = self.add_row( \
				child_name, {"label" : __config["label"], "class" : str(),}, \
				str(), None \
			)

			__pages = __config["pages"]
			for k, l in __pages.items() :
				self.add_child_pages(__pages, child_name, l, __iter)

	def add_child_pages (self, pages, child_name, list_page, iter_parent=None) :
		for config in list_page :
			if config["class"] == "__PREFERENCES_VTE__" :
				self.add_child_vte(child_name, iter_parent, config)
			else :
				__iter = self.add_row(child_name, config, str(), iter_parent)
				if pages.has_key(config["class"]) :
					self.add_child_pages( \
						pages, child_name, pages[conifg["class"]], __iter)

	def add_child_vte (self, child_name, iter_parent, config) :
		__iter = self.add_row( \
			child_name, \
			{"label" : "Terminal Setting", "class" : str(),}, str(), iter_parent \
		)

		__children = __VTE__.LIST_PREFERENCES_CHILD
		if config.has_key("children") :
			__children = [ i.strip() for i in config["children"].split(",")]

		for item in __VTE__.LIST_PREFERENCES_CHILD :
			if item not in __children :
				continue

			self.add_row( \
				child_name, \
				__VTE__.DATA_PREFERENCES_CHILD[item], \
				"vte", \
				__iter \
			)

	def add_row (self, child_name, config, type, iter_parent=None) :

		__iter = self.WIDGET_TREESTORE.append( \
			iter_parent, [_(config["label"]), config["class"], child_name, type, ])

		return __iter

	##################################################
	# EVENT HANDLER
	def getUIDs (self, iter) :
		if not iter : return None

		__class = self.WIDGET_TREESTORE.get_value(iter, \
			Conf.TREEVIEW_PREFERENCE_PANEL_COLUMN_CLASS, \
		)
		__child_name = self.WIDGET_TREESTORE.get_value(iter, \
			Conf.TREEVIEW_PREFERENCE_PANEL_COLUMN_CHILD_NAME, \
		)
		__type = self.WIDGET_TREESTORE.get_value(iter, \
			Conf.TREEVIEW_PREFERENCE_PANEL_COLUMN_TYPE, \
		)

		return (__class, __child_name, __type, )

	XML_CURRENT = None
	def on_cursor_changed (self, widget) :
		if len(self.BOX_SIDE.get_children()) > 0 :
			try :
				self.WIDGET_SIDE.destroy()
				del self.XML_CURRENT
				del self.WIDGET_SIDE
			except :
				pass

		__store, __iter = self.get_selected()
		(__class_name, __child_name, __type) = self.getUIDs(__iter)

		__title = self.get_value( \
			self.get_path(__iter), Conf.TREEVIEW_PREFERENCE_PANEL_COLUMN_NAME)
		self.LABEL_SIDE.set_markup( \
			"<span size=\"x-large\" weight=\"bold\">%s</span>" % _(__title))

		if not __class_name : return

		if __type != "vte" :
			__object = child.get_object_from_main(__child_name, __class_name)
			__o = __object(__child_name, state=self.STATE)
		else :
			from child import __VTE__
			__o = \
				__VTE__.__PREFERENCES__( \
					__child_name, __class_name, state=self.STATE)

		(self.XML_CURRENT, self.WIDGET_SIDE) = __o.getXMLAndWidget()

		self.BOX_SIDE.pack_start(self.WIDGET_SIDE, True)

	def getWidgetCurrent (self, widget_name) :
		return self.XML_CURRENT.get_widget(widget_name)

class KeyboardShortcutForPreferences (__TREEVIEW__.Core) :

	PROPERTIES = { \
		"enable-search" : False, \
		"fixed-height-mode" : False, \
		"headers-clickable" : False, \
		"headers-visible" : True, \
		"hover-expand" : False, \
		"hover-selection" : False, \
		"reorderable" : False, \
		"rules-hint" : False, \
	}

	def __init__ (self, xml, **kwargs) :
		"""
		kwargs is,
			state
		"""

		self.STATE = kwargs["state"]
		self.STATE_LOCAL = kwargs["state"]["local"]
		self.STATE_GLOBAL = kwargs["state"]["global"]
		self.GCONF_CLIENT = self.STATE_GLOBAL.get_value("gconf-client")

		__TREEVIEW__.Core.__init__( \
			self, xml, "treeview-keyboard-shortcut")

	def getUID (self, iter) :
		if not iter : return None

		return self.WIDGET_TREESTORE.get_value( \
			iter, Conf.TREEVIEW_SHORTCUT_PANEL_COLUMN_UID)

	def create_frame (self) :

		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()
		__cell1 = gtk.CellRendererText()

		__tvcolumn0 = gtk.TreeViewColumn(_("Action"))
		__tvcolumn1 = gtk.TreeViewColumn(_("Shortcut"))

		__tvcolumn0.set_expand(True)
		__tvcolumn0.set_sort_column_id( \
			Conf.TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_LABEL)

		self.WIDGET_TREESTORE = gtk.TreeStore(str, str, str)
		self.WIDGET_TREEVIEW.set_model(self.WIDGET_TREESTORE)

		self.WIDGET_TREEVIEW.append_column(__tvcolumn0)
		self.WIDGET_TREEVIEW.append_column(__tvcolumn1)

		__tvcolumn0.pack_start(__cell0, True)
		__tvcolumn1.pack_start(__cell1, True)

		__tvcolumn0.set_attributes( \
			__cell0, text=Conf.TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_LABEL)
		__tvcolumn1.set_attributes( \
			__cell1, text=Conf.TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_KEY)

		self.EVENTBOX = self.XML.get_widget("eventbox-keyboard-shortcut")
		self.EVENTBOX.set_events(gtk.gdk.KEY_RELEASE)
		self.EVENTBOX.add_events(gtk.gdk.KEY_PRESS)

		# connect event.
		self.WIDGET_TREEVIEW.connect( \
			"row-activated", self.on_accel_activated)

		self.EVENTBOX.connect("key-release-event", self.on_grab_keyval)

	def insert_row (self) :
		self.WIDGET_TREESTORE.clear()
		for __name, __child in Conf.KEYBOARD_SHORTCUT_LIST_FOR_TREEVIEW.items() :
			__iter = self.WIDGET_TREESTORE.append(None, [_(__name), "", "", ])

			# insert item of modules
			if __name == "Modules" :
				# get list by module
				__children = self.STATE_GLOBAL["children"]
				for i in __children.keys() :
					if not __children[i]["gconf"].has_key("keyboard_shortcut") :
						continue

					# get current key.
					__d = __children[i]["gconf"]["keyboard_shortcut"]

					# add row
					for j in __d :
						self.add_row(__iter, [j["key"], j["preferences_label"], ])
			else :
				for j in __child :
					self.add_row(__iter, j)

		self.WIDGET_TREEVIEW.expand_all()

	def add_row (self, parent, child) :
		__key_in_gconf = self.GCONF_CLIENT.getValue(child[0])
		if not __key_in_gconf :
			__key_in_gconf = _("Disabled")

		return self.WIDGET_TREESTORE.append( \
			parent, \
			[_(child[1]), __key_in_gconf, child[0], ] \
		)

	#####################################################################
	# EVENT HANDLER
	CURRENT_PATH = None
	def on_accel_activated \
			(self, treeview, path, view_column, user_param1=None) :
		self.SHORTCUT_KEY_VALUE_ORG = \
			self.get_value(path, Conf.TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_KEY)

		if not self.SHORTCUT_KEY_VALUE_ORG.strip() : return

		self.WIDGET_TREESTORE[path][1] = _("Press Key...")
		self.CURRENT_PATH = path

		return

	def __accel_disable (self) :
		self.WIDGET_TREESTORE[self.CURRENT_PATH][1] = _("Disabled")

		__conf_key = self.get_value( \
				self.CURRENT_PATH, \
				Conf.TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_UID \
		)
		self.__set_keyval(__conf_key, "")

		self.CURRENT_PATH = None

	def __accel_cancel (self) :
		self.WIDGET_TREESTORE[self.CURRENT_PATH][1] = self.SHORTCUT_KEY_VALUE_ORG
		self.CURRENT_PATH = None

	def get_value (self, path, column_number) :
		__tree_iter = self.WIDGET_TREESTORE.get_iter(path)
		__value = self.WIDGET_TREESTORE.get_value(__tree_iter, column_number)

		return __value

	def on_grab_keyval (self, widget, event) :
		if not self.CURRENT_PATH : return

		__conf_key = self.get_value( \
				self.CURRENT_PATH, \
				Conf.TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_UID \
		)
		__keyval_name = gtk.gdk.keyval_name(event.keyval)

		#__mod = event.state & gtk.gdk.MODIFIER_MASK
		__mod = event.state & Conf.AVAILABLE_MODIFIER_MASK
		if __mod == Conf.NULL_MODIFIER_MASK :

			# if backspace, cancel the operation.
			if __keyval_name == "BackSpace" :
				self.__accel_disable()
			elif __keyval_name == "Escape" :
				self.__accel_cancel()
			elif __keyval_name != "Return" :
				self.__accel_cancel()

			return

		if not __keyval_name : return
		if not __keyval_name.strip() : return

		if not gtk.accelerator_valid(event.keyval, event.state) : return

		# check the symbols caused by SHIFT key.
		__key_string = gtk.gdk.keyval_name(event.keyval)
		if Conf.UPPER_SYMBOLS.has_key(__key_string) :
			mods = event.state & ~ gtk.gdk.SHIFT_MASK
		else :
			mods = event.state

		# store key event.
		if len(__key_string) == 1 : __key_string = __key_string.upper()

		__key_name = gtk.accelerator_name(event.keyval, mods)

		# filtering the close this window.
		if __key_name == "<Control>c" : self.__accel_cancel()

		__key_value = ">".join(__key_name.split(">")[:-1]) + ">" + \
			__key_string

		# check this key is already in use.
		self.__KEYBOARD_SHORTCUT_IN_USE = None
		self.WIDGET_TREESTORE.foreach(self.__search_keyval_in_column, __key_value)

		if self.__KEYBOARD_SHORTCUT_IN_USE and \
				len(self.__KEYBOARD_SHORTCUT_IN_USE) == 2:
			Dialog.ShortcutKeyInUse(__key_value, self.__KEYBOARD_SHORTCUT_IN_USE[1])
			self.__accel_cancel()
			return

		# update gconf value.
		if not self.__set_keyval(__conf_key, __key_value) :
			raise RuntimeError, \
				_("Keyboard shortcut did not update, caused by gconf.")

		self.WIDGET_TREESTORE[self.CURRENT_PATH][1] = __key_value
		self.CURRENT_PATH = None

		return

	def __set_keyval (self, conf_key, keyval) :
		if not self.GCONF_CLIENT.setValue(conf_key, keyval) :
			return False
		else :
			return True

	def __search_keyval_in_column (self, model, path, iter, key_value) :
		if self.get_value( \
				path, Conf.TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_KEY) == key_value :
			self.__KEYBOARD_SHORTCUT_IN_USE = (path, self.get_value( \
					path, Conf.TREEVIEW_PREFERENCES_SHORTCUT_COLUMN_LABEL), \
			)

			return True
		else :
			return False


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Panel.py"


