# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import sys, os, sre

class PYTHON :

	BUFFER = tuple()
	CLASS_MEMBERS = dict()
	LIST_CLASS = list()
	FUNCTIONS = list()
	THIS_IS_CLASS = False
	CLASS_NAME = str()
	NUMBER_OF_INDENT_OF_THIS_CLASS = 0

	LINE_COUPLING = dict()

	SRE_UNFINISHED_LINE = sre.compile("\\\\%s$" % os.linesep)
	SRE_INDENT_STRING = sre.compile("^[\t ][\t ]*")

	def __init__ (self, filename=None) :
		if filename :
			self.setFromFile(filename)

	def setFromFile (self, filename) :
		try :
			fd = file(filename)
			self.BUFFER = self.removeUnfinishedLine(fd.readlines())
			fd.close()
		except IOError :
			self.BUFFER = list()

	def setFromString (self, strs) :
		__s = strs.split(os.linesep)
		self.BUFFER = self.removeUnfinishedLine(__s)

	def removeUnfinishedLine (self, lines) :

		__is_unfinished_previous_line = False
		__buffer = list()
		__line_orig = 1

		self.LINE_COUPLING = dict()
		__line_coupling = dict()
		for i in lines :

			"""
			if this line is unfinished,
				if previous line also unfinished,
					append this line to __buffer[-1]
				else
					append this line to __buffer
			else
				append this line to __buffer
			"""

			__is_not_unfinished = self.SRE_UNFINISHED_LINE.findall(i)

			if __is_not_unfinished :
				__l = self.SRE_UNFINISHED_LINE.sub("", i)
				if __is_unfinished_previous_line :
					__buffer[-1] += __l
				else :
					__buffer.append(__l)

				__is_unfinished_previous_line = True
			else :
				if __is_unfinished_previous_line :
					__buffer[-1] += i
				else :
					__buffer.append(i)

				__is_unfinished_previous_line = False

			if not __line_coupling.has_key(len(__buffer)) :
				__line_coupling[len(__buffer)] = __line_orig

			__line_orig += 1

		self.LINE_COUPLING = __line_coupling

		return __buffer

	def format (self) :
		# initiate
		self.CLASS_MEMBERS = dict()
		self.LIST_CLASS = list()
		self.FUNCTIONS = list()

		__this_line = 1
		__class_name = str()
		__indent_class = 100

		for i in self.BUFFER :
			is_class = False
			is_def = False

			is_class = self.isClass(i)
			if not is_class :
				is_def = self.isDef(i)

			__indent = self.__getIndent(i)

			"""
			if this is class,
				register class name in self.LIST_CLASS
				remember the indent as indent_class

			if this is not def or not class,
				if indent < indent_class :
					set __class_name = str()

			if this is def,
				if class_name is null :
					remember def name in self.FUNCTIONS

				elif indent > indent_class
					remember def name in self.CLASS_MEMBERS

				else :
					remember def name in self.FUNCTIONS
			"""
			if is_class :
				__class_name = self.parseClass(i)
				__indent_class = __indent
				self.CLASS_MEMBERS[__class_name] = list()
				self.LIST_CLASS.append( \
					(__class_name, self.LINE_COUPLING[__this_line], ) \
				)
			elif is_def :
				__function_name = self.parseDef(i)
				if __indent > __indent_class :
					self.CLASS_MEMBERS[__class_name].append( \
						(__function_name, self.LINE_COUPLING[__this_line], ) \
					)
				else :
					self.FUNCTIONS.append( \
						(__function_name, self.LINE_COUPLING[__this_line], ) \
					)
					__class_name = str()

			__this_line += 1

	def __getIndent (self, line) :
		__a = self.SRE_INDENT_STRING.findall(line)
		if len(__a) < 1 :
			return 0
		else :
			__b = __a[0].replace("\t", "    ")
			return len(__b)

	def getClassMembers (self) :
		return (self.LIST_CLASS, self.CLASS_MEMBERS, )

	def getFunctions (self) :
		return self.FUNCTIONS

	def isClass (self, line) :
		__a = sre.compile("class[ \t][ \t]*.* :").findall(line)
		if len(__a) < 1 : return False
		return True

	def isDef (self, line) :
		__a = sre.compile("def[ \t][ \t]*.* :").findall(line)
		if len(__a) < 1 : return False
		return True

	def parseClass (self, line) :
		__a = sre.compile( \
			"class[ \t][ \t]*").split(line)[1].split( \
				"(")[0].replace(":", "").strip()

		return __a

	def parseDef (self, line) :
		__name = sre.compile("def[ \t][ \t]*").split(line)[1].split("(")[0].strip()

		return __name

if __name__ == "__main__" :
	__b = file(sys.argv[1], "r")

	p = PYTHON(sys.argv[1])
	p.format()
	print p.getClassMembers()
	print p.getFunctions()


"""
Description
-----------

>>> p = Parser("/bebop/1.txt")
>>> p.format()
>>> print p.getClassMembers()
>>> print p.getFunctions()


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Parser.py"


