# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from vee import XMLHandler, Conf

class Core :

	STATE = None
	STATE_GLOBAL = None
	STATE_LOCAL = None
	GCONF_CLIENT = None

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			self.STATE_GLOBAL = self.STATE["global"]
			self.STATE_LOCAL = self.STATE["local"]
			self.GCONF_CLIENT = self.STATE_GLOBAL["gconf-client"]

def readBookmark (config_children) :
	# add bookmark to state_global
	try :
		__bookmark = XMLHandler.Bookmark( \
			Conf.FILE_BOOKMARK, children=config_children)
	except IOError :
		__bookmark = XMLHandler.Bookmark(children=config_children)

	return __bookmark

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "__VEE__.py"


