# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import xml.dom.ext as ext
from xml.dom import minidom
class __XML_PARSER__ :

	DOM = None

	def __init__ (self, xml_filename) :
		self.DOM = minidom.parseString("".join(file(xml_filename).readlines()))

	def getXml (self) :
		return self.DOM.toxml(encoding=self.DOM.encoding)

	def saveXml (self, filename) :
		try :
			__d = file(filename, "w")
			__d.write(self.getXml())
			__d.close()
		except IOError :
			return False
		else :
			return True

	def getChildren (self, node) :
		if node.nodeType != node.ELEMENT_NODE :
			return list()
		else :
			return node.childNodes

	def getParent (self, node) :
		return node.parentNode

	def appendChild (self, node, childNode) :
		return node.appendChild(childNode)

	def copy (self, node) :
		if not hasattr(node, "attributes") :
			return None
		else :
			__node = self.DOM.createElement("one")
			for __key, __value in node.attributes.items() :
				__node.setAttribute(__key, __value)

			return __node

##################################################
# FUNCTIONS
from xml.xpath import Evaluate
def evaluate_path (dom, xpath) :
	"""
	Evaluate xpath in dom.

	@return:
		False : invalid dom
		None : no return nodes
		list() : nodes list
	"""

	if not hasattr(dom, "documentElement") : return list()

	nodes = Evaluate(xpath, dom.documentElement)

	if len(nodes) < 1 : return list()

	return nodes

##################################################
# FUNCTIONS
import xml
def get_attributes_extended (named_node_map, template=dict()) :
	__template = dict()
	[__template.update({__key : __value["type"]}) \
		for __key, __value in template.items()]

	return get_attributes(named_node_map, __template)

def get_attributes (named_node_map, template=dict()) :
	if not isinstance(named_node_map, xml.dom.minidom.NamedNodeMap) :
		return None
	else :
		__dict = dict()
		for __key, __value in named_node_map.items() :
			if len(template) > 0 and template.has_key(str(__key)) :
				__dict[str(__key)] = casting(template[str(__key)], __value)
			else :
				__dict[str(__key)] = str(__value)

		return __dict

def casting (__type, value, encoding=None) :
	"""
	Convert data __type.
	"""

	if __type == "unicode" :
		if encoding :
			return unicode(value).encode(encoding)
		else :
			return unicode(value)
	elif __type == "str" :
		return str(value)
	elif __type == "int" :
		if not value :
			return int()
		else :
			value = str(value)
			return int(value.split(".")[:1][0])
	elif __type == "float" :
		if not value :
			return float()
		else :
			return float(value)
	elif __type == "bool" :
		if value.capitalize() in ["True", "False", ] :
			try :
				return eval(value.capitalize())
			except NameError :
				return not(not value)
		else :
			return bool(value)
	else :
		return value

def create_new_document (root_node_name) :
	return minidom.parseString( \
		"<?xml version='1.0' encoding='UTF-8'?>\n<%s></%s>" % \
			(root_node_name, root_node_name) \
	)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "__XML__.py"


