# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import gtk
from vee import WIDGET, __VEE__, child, func, Conf, GConf
from vee.child import __WIDGET__, __PROPERTY__

class egg (__VEE__.Core) :

	UID = None
	WIDGET = None
	OBJ_TAB = None

	KWARGS = None
	PROPERTIES = None
	CONFIG = dict()

	CHILD_NAME = None

	def __init__ (self, state, **kwargs) :
		self.UID = func.get_uid()

		__VEE__.Core.__init__(self, state=state)

		self.KWARGS = kwargs
		self.CHILD_NAME = child.get_child_name_by_object(self)

		self.normalizeProperty(kwargs)
		self.make()
		self.done()

	def __del__ (self) :
		del self.WIDGET

	def done (self) : pass
	def reset (self) : pass

	def myNameIs (self) :
		return self.CHILD_NAME

	def normalizeProperty (self, kwargs=dict()) :
		self.CONFIG = child.get_child_config(self.CHILD_NAME)

		# get the configuration from gconf.
		__setting = dict()
		for i in self.GCONF_CLIENT.getAllEntries( \
					os.path.join(self.GCONF_CLIENT.APP_PATH, self.CHILD_NAME, ) \
				) :

			__path = os.path.join(self.GCONF_CLIENT.APP_PATH, self.CHILD_NAME, i, )
			__value = self.GCONF_CLIENT.getValue(__path)
			__type = self.GCONF_CLIENT.getValueType(__path)
			__key = os.path.basename(i)

			__setting[__key] = func.casting(__type, __value)

		__setting.update(kwargs)

		self.PROPERTIES = __setting

	def attached (self, obj_tab) :
		self.OBJ_TAB = obj_tab

	def getConfig (self) :
		return self.CONFIG

	def getWidget (self) :
		return self.WIDGET

	def getBox (self) :
		return self.WIDGET

	def getProperties (self) :
		return self.PROPERTIES

	def getProperty (self, key) :
		if not self.PROPERTIES.has_key(key) :
			return None
		else :
			return self.PROPERTIES[key]

	def setProperty (self, key, value) :
		self.PROPERTIES.update({key : value})

	def make (self) :
		"""
		* Must be implemented
		Make child widget
			@return : None
		"""
		pass

	def createBox (self) :

		# attach scrollbar
		if self.PROPERTIES.has_key("enable_scrollbar") and \
				not self.PROPERTIES["enable_scrollbar"] :
			return self.WIDGET

		# SET SCROLLBAR POLICY #############################################
		__show_vertical = \
			self.CONFIG["layout"]["tab"]["scrollbar"]["vertical"]
		__show_horizontal = \
			self.CONFIG["layout"]["tab"]["scrollbar"]["horizontal"]

		if not __show_vertical and not __show_horizontal :
			return self.WIDGET

		__box_h = None; __box_v = None

		__adjustment = self.WIDGET.get_adjustment()
		if __show_vertical :
			__scrollbar_v = gtk.VScrollbar()
			__scrollbar_v.set_adjustment(__adjustment)
			__scrollbar_v.show()

			__box_h = gtk.HBox()
			__box_h.pack_start(self.WIDGET, True)
			__box_h.pack_start(__scrollbar_v, False)
			__box_h.show()

		if __show_horizontal :
			__scrollbar_h = gtk.HScrollbar()
			__scrollbar_h.set_adjustment(__adjustment)
			__scrollbar_h.show()

			__box_v = gtk.VBox()
			if not __box_h :
				__box_v.pack_start(self.WIDGET, True)
			else :
				__box_v.pack_start(__box_h, True)

			__box_v.pack_start(__scrollbar_h, False)
			__box_v.show()

		if __box_v :
			return __box_v
		elif __box_h :
			return __box_h

	def getTitle (self) :
		"""
		Get the window title
			@return : str
		"""

		try :
			return self.WIDGET.get_window_title()
		except :
			return str()

	def getLabelName (self) :
		return self.CHILD_NAME

	def on_changed_title (self) :
		pass

class main (__VEE__.Core) :

	OBJ_VEE = None

	def __init__ (self, obj_vee, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)
		self.OBJ_VEE = obj_vee
		self.ACCEL_GROUP_GLOBAL = self.STATE_LOCAL["obj-vee"].ACCEL_GROUP_GLOBAL

		self.initialize()

	def initialize (self) : pass

	def nf_update_accel_key (self, client, parm1, entry, parm3) :
		uid = os.path.basename(entry.get_key())

		# get new key and mods.
		__key, __mod = \
			gtk.accelerator_parse(self.GCONF_CLIENT.getValueFromValue(entry.get_value()))

		if not __key or __mod == Conf.NULL_MODIFIER_MASK :
			return self.ACCEL_GROUP_GLOBAL.removeKey(uid)

		return self.ACCEL_GROUP_GLOBAL.updateKey(uid, __key, __mod)

class dashboard (__VEE__.Core) :

	def __init__ (self, obj_dashboard, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)
		self.OBJ_DASHBOARD = obj_dashboard

		self.initialize()

	def initialize (self) : pass


class bookmark_property (__PROPERTY__.CORE) :
	def __init__ (self, uid, **kwargs) :
		__childname = child.get_child_name_by_object(self)
		__PROPERTY__.CORE.__init__(self, __childname, uid, **kwargs)

class preferences_main (__VEE__.Core) :
	XML = None
	WIDGET = None
	HANDLER_METHOD = dict()

	def __init__ (self, childname, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)

		# set gconf
		self.GCONF_CLIENT = \
			GConf.Client(os.path.join(Conf.GCONF_APP_DIR, childname, ))

		# get config
		if not self.STATE_GLOBAL["children"].has_key(childname) :
			raise \
				ValueRrror, "This child, %s does not have preperences page." % \
					childname
		else :
			self.CONFIG = self.STATE_GLOBAL["children"][childname]

		(self.XML, self.WIDGET, ) = __WIDGET__.get_widget( \
			"preferences_main", childname, self.CONFIG)

		__main = child.load_module(childname, "main")
		__Conf_i18n = child.load_module(childname, "Conf_i18n")
		__messages = None
		if hasattr(__Conf_i18n,
				self.CONFIG["widget"]["map"]["preferences_main"]["message"]) :
			__messages = getattr( \
				__Conf_i18n, \
				self.CONFIG["widget"]["map"]["preferences_main"]["message"] \
			)

		WIDGET.translate(self.XML, __messages)

		self.initialize()
		self.__connectHandler()

	def __connectHandler (self) :
		[self.HANDLER_METHOD.update({i["name"] : eval("self.%s" % i["value"])}) \
			for i in self.CONFIG["widget"]["handler"]["preferences_main"]]

		self.XML.signal_autoconnect(self.HANDLER_METHOD)

	def getXMLAndWidget (self) :
		return (self.XML, self.WIDGET, )

	def getWidget (self, widget_name) :
		return self.XML.get_widget(widget_name)

	def initialize (self) : pass

"""
Description
-----------


ChangeLog
---------


Usage
-----

"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "__BASIC__.py"


