# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, os
from vee import WIDGET as WIDGET_GLOBAL, Conf, child

class WIDGET (WIDGET_GLOBAL.__WIDGET__) :

	def __init__ (self, childname, widget_name, config) :

		self.CONFIG_CHILD = config

		if not self.CONFIG_CHILD["widget"]["map"].has_key(widget_name) :
			raise RuntimeError, \
				"widget_name, %s does not registered in config.xml" % widget_name

		self.CONFIG_WIDGET = self.CONFIG_CHILD["widget"]["map"][widget_name]

		self.CONFIG_HANDLER = dict()
		try :
			[self.CONFIG_HANDLER.update({i["name"] : i["value"]}) \
				for i in self.CONFIG_CHILD["widget"]["handler"][widget_name]]
		except KeyError :
			pass

		# for translate
		__Conf_i18n = child.load_module(childname, "Conf_i18n")
		if not hasattr(__Conf_i18n, self.CONFIG_WIDGET["message"]) :
			__message = None
		else :
			__message = getattr(__Conf_i18n, self.CONFIG_WIDGET["message"])

		WIDGET_GLOBAL.__WIDGET__.__init__( \
			self, \
			widget_name, \
			self.CONFIG_WIDGET["root"], \
			self.CONFIG_HANDLER, \
			None, \
			os.path.join(Conf.DIR_LIB, "child", childname, self.CONFIG_WIDGET["glade_file"]), \
			__message, \
		)

def get_widget (widget_name, childname, config_child) :
	if config_child["widget"]["map"].has_key(widget_name) :
		__config =  config_child["widget"]["map"][widget_name]
	else :
		raise RuntimeError, \
			"widget_name, %s does not registered in child/%s/config.xml" % \
			(widget_name, childname, )

	return \
		WIDGET_GLOBAL.get_widget_from_xml( \
			widget_name, \
			os.path.join(Conf.DIR_LIB, "child", childname, __config["glade_file"]), \
		)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "__WIDGET__.py"


