# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import xmlrpclib
import gobject, gtk
from vee import __VEE__, __TREEVIEW__, func, GNOME

TREEVIEW_COMMAND_LIST_PANEL_COLUMN_ICON = 0
TREEVIEW_COMMAND_LIST_PANEL_COLUMN_COMMAND = 1
class __PANELCOMMANDLIST__ (__VEE__.Core, __TREEVIEW__.Core) :

	MODEL_COMMAND_HISTORY = gtk.ListStore(gobject.TYPE_STRING)
	COMMAND_LIST = None
	ICON = None

	PROPERTIES = { \
		"enable-search" : True, \
		"fixed-height-mode" : False, \
		"headers-clickable" : False, \
		"headers-visible" : False, \
		"hover-expand" : False, \
		"hover-selection" : False, \
		"reorderable" : False, \
		"rules-hint" : True, \
	}

	def __init__ (self, xml, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)

		self.COMMAND_LIST = self.STATE_GLOBAL["command"]
		__TREEVIEW__.Core.__init__(self, xml, "treeview_command_list")

	def create_frame (self) :
		# read the stored EXTERNAL COMMAND LIST
		self.MODEL_COMMAND_HISTORY.clear()
		for i in self.COMMAND_LIST.getChild() :
			__d = self.COMMAND_LIST.getValues(i)
			if not __d.has_key("value") :
				continue
			self.MODEL_COMMAND_HISTORY.append((__d["value"], ))

		# get icon.
		self.ICON = GNOME.get_pixbuf_from_stock( \
			gtk.STOCK_EXECUTE, gtk.ICON_SIZE_SMALL_TOOLBAR)

		__cell1 = gtk.CellRendererPixbuf()
		__cell2 = gtk.CellRendererCombo()
		__cell2.set_property("editable", True)
		__cell2.set_property("xalign", 0.0)
		__cell2.set_property("model", self.MODEL_COMMAND_HISTORY)
		__cell2.set_property("text-column", 0)

		__cell2.connect("edited", self.on_rename_edited)
		__cell2.connect("editing-started", self.on_editing_started)
		__cell2.connect("editing-canceled", self.on_editing_canceled)

		self.tvcolumn1 = gtk.TreeViewColumn()
		self.tvcolumn1.set_expand(True)

		self.WIDGET_TREESTORE = gtk.TreeStore( \
				gobject.TYPE_OBJECT, \
				gobject.TYPE_STRING, \
				gobject.TYPE_OBJECT \
			)

		self.WIDGET_TREEVIEW.set_model(self.WIDGET_TREESTORE)

		# add columns to treeview
		self.WIDGET_TREEVIEW.append_column(self.tvcolumn1)
		self.tvcolumn1.pack_start(__cell1, False)
		self.tvcolumn1.pack_start(__cell2, True)

		self.tvcolumn1.set_attributes( \
			__cell1, pixbuf=TREEVIEW_COMMAND_LIST_PANEL_COLUMN_ICON)
		self.tvcolumn1.set_attributes( \
			__cell2, text=TREEVIEW_COMMAND_LIST_PANEL_COLUMN_COMMAND)

		self.XML.get_widget("eventbox_command_list").connect( \
			"event", self.on_eventbox_command_list)

	def add_row (self, data, iter_parent=None) :
		if type(data) is not str : return None

		__iter = self.WIDGET_TREESTORE.append( \
			None, [self.ICON, data, self.MODEL_COMMAND_HISTORY, ])

		return __iter

	def addNew (self) :
		__iter = self.add_row(str())
		self.set_editable( \
			__iter, \
			0, \
			TREEVIEW_COMMAND_LIST_PANEL_COLUMN_COMMAND, \
		)

	##################################################
	# EVENT HANDLER
	def remove0 (self) :
		(__treestore, __treeiter, ) = self.get_selected()
		if not __treeiter : return

		return self.remove(treeiter=__treeiter)

	def moveUp (self) :
		(__treestore, __treeiter, ) = self.get_selected()
		if not __treeiter : return False

		__path = self.get_path(__treeiter)
		__path_previous = __TREEVIEW__.get_previous_path(__path)

		try :
			__iter_previous = self.get_iter(__path_previous)
		except ValueError :
			return False
		except TypeError :
			return False

		self.WIDGET_TREESTORE.swap(__treeiter, __iter_previous)
		return True

	def moveDown (self) :
		(__treestore, __treeiter, ) = self.get_selected()
		if not __treeiter : return False

		(__treestore, __treeiter, ) = self.get_selected()
		if not __treeiter : return False

		__path = self.get_path(__treeiter)
		__path_next = __TREEVIEW__.get_next_path(__path)

		try :
			__iter_next = self.get_iter(__path_next)
		except ValueError :
			return False

		self.WIDGET_TREESTORE.swap(__treeiter, __iter_next)
		return True

	AVAILABLE_KEYNAMES_IN_PANEL_BOOKMARK = [ \
		"F2", \
		"Delete", \
	]
	IS_EDITING = False
	def on_eventbox_command_list (self, widget, event) :
		if self.IS_EDITING :
			return

		if event.type in [gtk.gdk.KEY_RELEASE, gtk.gdk.KEY_PRESS, ] :
			__keyname = func.get_keyname(event)

			if __keyname not in self.AVAILABLE_KEYNAMES_IN_PANEL_BOOKMARK :
				return

			(__treestore, __treeiter, ) = self.get_selected()
			if not __treeiter : return
			__path = self.get_path(__treeiter)

			if __keyname == "F2" and event.type not in [gtk.gdk.KEY_PRESS, ] :
				self.IS_EDITING = True
				(__store, __iter, ) = self.get_selected()
				self.set_editable( \
					__iter, \
					TREEVIEW_COMMAND_LIST_PANEL_COLUMN_COMMAND, 0 \
				)

			elif __keyname == "Delete" and event.type not in [gtk.gdk.KEY_PRESS, ] :
				(__store, __iter, ) = self.get_selected()
				if not __iter : return

				# remove from panel.
				self.remove0(treeiter=__iter)

			else :
				return

	def remove (self, **kwargs) :
		if kwargs.has_key("treeiter") : __path = self.get_path(kwargs["treeiter"])
		if kwargs.has_key("path") : __path = kwargs["path"]

		# set cursor to another row.
		self.on_row_deleted(self.WIDGET_TREESTORE, __path)

		__TREEVIEW__.Core.remove(self, **kwargs)

	def on_row_deleted (self, treemodel, path) :
		__next_row_to_focus = __TREEVIEW__.get_previous_path(path)

		if __next_row_to_focus :
			self.set_cursor(__next_row_to_focus)

	def on_editing_started (self, cell, editable, pathcell) :
		self.IS_EDITING = True

	def on_editing_canceled (self, cell) :
		self.IS_EDITING = False

	def on_rename_edited (self, cell, path, new_text) :
		__d = self.get_value(path, TREEVIEW_COMMAND_LIST_PANEL_COLUMN_COMMAND)
		if __d.strip() == new_text.strip() :
			return

		__previous_data = self.COMMAND_LIST.getByValue(new_text.strip())
		if len(__previous_data) < 1 :
			__new_node = self.COMMAND_LIST.addNew()
			self.COMMAND_LIST.updateValues(__new_node, {"value" : new_text.strip(),})
			self.MODEL_COMMAND_HISTORY.append((new_text.strip(), ))

		__iter = self.WIDGET_TREESTORE.get_iter(path)
		self.set_value( \
			path, TREEVIEW_COMMAND_LIST_PANEL_COLUMN_COMMAND, new_text)
		self.IS_EDITING = False

	def on_row_activated (self, treeview, path, view_column, user_param=None) :
		pass

class PanelCommandListForProperty (__VEE__.Core, __PANELCOMMANDLIST__) :

	UID = None
	BOOKMARK = None
	DATA = None

	def __init__ (self, xml, node, bookmark, **kwargs) :
		self.NODE = node
		self.BOOKMARK = bookmark

		__PANELCOMMANDLIST__.__init__(self, xml, **kwargs)

	def __encodeData (self, __list) :
		return xmlrpclib.dumps(tuple(__list))

	def __decodeData (self, data) :
		return xmlrpclib.loads(data)

	def save (self) :
		__list = list()
		self.WIDGET_TREESTORE.foreach(self.__save, __list)

		__l = self.__encodeData(__list)
		return self.BOOKMARK.setValue(self.NODE, "command_list", __l)

	def __save (self, model, path, iter, __list=list()) :
		__d = self.get_value(path, TREEVIEW_COMMAND_LIST_PANEL_COLUMN_COMMAND)
		__list.append(__d)

	def insert_row (self) :
		self.WIDGET_TREESTORE.clear()
		__d = self.BOOKMARK.getValues(self.NODE)
		if not __d.has_key("command_list") :
			return

		__f = self.__decodeData(__d["command_list"])
		if __f and len(__f[0]) < 1 :
			return

		for i in __f[0] :
			self.add_row(i)

	def moveUp (self) :
		if __PANELCOMMANDLIST__.moveUp(self) :
			self.save()

	def moveDown (self) :
		if __PANELCOMMANDLIST__.moveDown(self) :
			self.save()

	def remove0 (self) :
		__PANELCOMMANDLIST__.remove0(self)
		return self.save()

	def on_rename_edited (self, cell, path, new_text) :
		__PANELCOMMANDLIST__.on_rename_edited(self, cell, path, new_text)
		return self.save()

class PanelCommandListForWindow (__PANELCOMMANDLIST__) :

	def __init__ (self, xml, **kwargs) :
		__PANELCOMMANDLIST__.__init__(self, xml, **kwargs)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Panel.py"


