# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, base64, marshal, xmlrpclib
from vee import i18n, __OS__, child
from vee.child import __BASIC__, __VTE__

_ = i18n.gettext()

STR_COMMAND_WITH_ENTER = \
"""%s; echo ''; echo \" Press Enter to exit..............\"; read"""
STR_COMMAND_WITHOUT_ENTER = """%s"""
STR_COMMAND_LIST = "%s\n"

class egg (__VTE__.egg) :
	PATH = "~"
	EXIT_WITHOUT_ENTER = False
	COMMAND_LIST = tuple()

	def done (self) :
		__VTE__.egg.done(self)

		# run initial command.
		for i in self.COMMAND_LIST[1:] :
			self.WIDGET.feed_child(STR_COMMAND_LIST % i)

	def normalizeProperty (self, kwargs=dict()) :
		__VTE__.egg.normalizeProperty(self, kwargs)

		# get command list.
		__d = xmlrpclib.loads(self.PROPERTIES["command_list"])
		if len(__d) < 1 :
			raise RuntimeError, "No command."
		else :
			self.COMMAND_LIST = __d[0]
			if len(self.COMMAND_LIST) < 1 :
				raise RuntimeError, "No command."

		if self.PROPERTIES.has_key("exit_without_enter") :
			self.EXIT_WITHOUT_ENTER = \
				self.PROPERTIES["exit_without_enter"]

	def parse_command (self) :
		if self.EXIT_WITHOUT_ENTER :
			__command = STR_COMMAND_WITHOUT_ENTER
		else :
			__command = STR_COMMAND_WITH_ENTER

		__argument = ( \
			"bash", \
			"-c", \
			__command % self.COMMAND_LIST[0], \
		)

		self.setProperty("title", self.COMMAND_LIST[0])

		return ("bash", __argument, tuple(), os.getcwd(), )

	def attached (self, obj_tab) :
		__VTE__.egg.attached(self, obj_tab)

	def getTitle (self) :
		__t = __VTE__.egg.getTitle(self)

		if not __t : return self.PATH

		__t0 = "".join(__t.split(":")[1:]).strip()

		if len(__t0) < 1 :
			__title = __t
		else :
			__title = __t0

		return __title

	def getLabelName (self) :
		#return self.PROPERTIES["external_command"]
		return self.COMMAND_LIST[0]

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "egg.py"


