# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import xmlrpclib
import gtk, gobject
from vee import __VEE__, __TREEVIEW__, Widgets, func, child
from vee.child import __WIDGET__, __BASIC__, __PROPERTY__
from vee.child.external_command import Panel

class main (__BASIC__.main) :
	"""
	Define the routine when child was catched by VEE.
	"""

	def initialize (self) :
		# ADD KEYBOARD SHORTCUT ##########################################
		__accel_group = self.STATE_LOCAL["obj-vee"].ACCEL_GROUP_GLOBAL
		(__key, __mod, ) = \
			__accel_group.getDataByGConf("keyboard_shortcut_insert_external_command")
		if __key :
			__accel_group.addKey( \
				"keyboard_shortcut_insert_external_command", \
				__key, __mod, self.on_insert)

			self.GCONF_CLIENT.CLIENT.notify_add( \
				self.GCONF_CLIENT.generatePath("keyboard_shortcut_insert_external_command"), \
				self.nf_update_accel_key \
			)

	def on_insert (self, accel_group, acceleratable, keyval, modifier) :
		self.OBJ_VEE.on_insert_child(None, "external_command")

class bookmark_property (__PROPERTY__.VTE) :

	def __init__ (self, uid, **kwargs) :
		#__BASIC__.bookmark_property.__init__ (self, uid, **kwargs)
		__PROPERTY__.VTE.__init__(self, "external_command", uid, **kwargs)

		# initialize treeview
		self.PANEL_COMMAND_LIST = \
			Panel.PanelCommandListForProperty( \
				self.xml, self.NODE, self.BOOKMARK, **kwargs)

	def initialize (self) :
		self.getWidget("checkbutton3").set_active(self.DATA["exit_without_enter"])

		__PROPERTY__.VTE.initialize(self)

	##################################################
	# EVENT HANDLER
	def on_external_command_changed_command (self, entry) :
		__command = entry.get_text().strip()
		if len(__command) < 1 : return
		self.BOOKMARK.setValue(self.NODE, "command", __command)

	def on_external_command_exit_without_enter (self, checkbox) :
		self.BOOKMARK.setValue(self.NODE, "exit_without_enter", checkbox.get_active())

	def on_command_list_add (self, button) :
		self.PANEL_COMMAND_LIST.addNew()

	def on_command_list_remove (self, button) :
		self.PANEL_COMMAND_LIST.remove0()

	def on_command_list_up (self, button) :
		self.PANEL_COMMAND_LIST.moveUp()

	def on_command_list_down (self, button) :
		self.PANEL_COMMAND_LIST.moveDown()

class preferences_main (__BASIC__.preferences_main) :

	def initialize (self) :
		__BASIC__.preferences_main.initialize(self)
		__shell_command = self.GCONF_CLIENT.getValue("command")

		self.getWidget("entry65").set_text(__shell_command)

	##################################################
	# EVENT HANDLER
	def on_external_command_changed_filechooser_command (self, chooser) :
		__new = chooser.get_filename()

		if not __new : return
		self.getWidgetCurrent("entry65").set_text(__new)

	def on_external_command_changed_command (self, entry) :
		__command = entry.get_text().strip()

		if len(__command) < 1 : return
		self.GCONF_CLIENT.setValue("command", __command)

class WindowExternalCommand (__VEE__.Core, __WIDGET__.WIDGET) :

	def __init__ (self, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)

		self.COMMAND_LIST = self.STATE_GLOBAL["command"]

		__WIDGET__.WIDGET.__init__( \
			self, "external_command", "window_external_command", kwargs["config"])

		self.PANEL_COMMAND_LIST = \
			Panel.PanelCommandListForWindow(self.xml, **kwargs)

		self.getWidget("comboboxentry1").set_model( \
			self.PANEL_COMMAND_LIST.MODEL_COMMAND_HISTORY)

	def initialize (self) :
		self.getWidget("comboboxentry1").child.set_property("width-chars", 40)

	def readCommand (self) :
		__list = list()
		self.PANEL_COMMAND_LIST.WIDGET_TREESTORE.foreach(self.__read, __list)
		return __list

	def __read (self, model, path, iter, __list=list()) :
		__d = self.PANEL_COMMAND_LIST.get_value( \
			path, Panel.TREEVIEW_COMMAND_LIST_PANEL_COLUMN_COMMAND)
		__list.append(__d)

	##################################################
	# EVENT HANDLER
	def on_activated_expander (self, expander) :
		self.getWidget("comboboxentry1").set_property( \
			"sensitive", expander.get_expanded())

		if not expander.get_expanded() : # if expanded.
			self.getWidget("treeview_command_list").grab_focus()
		else :
			self.getWidget("comboboxentry1").child.grab_focus()

	def on_command_list_add (self, button) :
		self.PANEL_COMMAND_LIST.addNew()

	def on_command_list_remove (self, button) :
		self.PANEL_COMMAND_LIST.remove0()

	def on_command_list_up (self, button) :
		self.PANEL_COMMAND_LIST.moveUp()

	def on_command_list_down (self, button) :
		self.PANEL_COMMAND_LIST.moveDown()

	def on_execute (self, widget) :
		__command = self.getWidget("comboboxentry1").child.get_text()
		__command_list = self.readCommand()

		if len(__command.strip()) > 0 :
			__command_list = [__command, ]

			__previous_data = self.COMMAND_LIST.getByValue(__command.strip())
			if len(__previous_data) < 1 :
				__new_node = self.COMMAND_LIST.addNew()
				self.COMMAND_LIST.updateValues( \
					__new_node, {"value" : __command.strip(),})

		elif len(__command_list) < 1 :
			return

		self.on_close(None)

		__addPage = self.STATE_LOCAL["obj-vee"].addPage
		__addPage("external_command", \
			**{"command_list": xmlrpclib.dumps(tuple(__command_list))})

def test (state, **kwargs) :
	if kwargs.has_key("command_list") :
		return True
	else :
		gobject.idle_add( \
			load_window_external_command, \
			state, \
			child.get_child_config("external_command") \
		)

		return False

def load_window_external_command (state, config) :
	WindowExternalCommand(state=state, config=config)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "main.py"


