# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from twisted.internet import reactor
from twisted.conch.ssh import transport, filetransfer, common
from twisted.conch.ssh import transport, common
from twisted.python import failure

import gtk, gobject, pango
import os, pwd, getpass, exceptions, time

#import filetransfer
from vee import Conf, __OS__, XMLHandler, __VEE__, func as func_global
from vee.child import __WIDGET__
from vee.child.filebrowser_ssh \
	import __SSHClient__, FileTransfer, func, Panel, FileTransferQueue, main
from vee.child.ssh import main as main_ssh

class SSH (__VEE__.Core, __WIDGET__.WIDGET) :

	KWARGS = None
	PROPERTIES = dict()
	CONFIG = dict()
	CONF = dict()

	DIALOG_MESSAGE = None

	HANDLER_ID_CONNECT = None
	CONNECTION = None
	CONF = None
	FT = None
	CURRENT_DIRECTORY_REMOTE = None
	CURRENT_DIRECTORY_LOCAL = None

	DIRECTORY_HISTORY_REMOTE = list()
	DIRECTORY_HISTORY_LOCAL = list()

	FILE_TRANSFER = None
	FILETRANSFERQUEUE = None

	BUFFER_LOG = None
	TAG = dict()

	def __init__ (self, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)
		self.KWARGS = kwargs

		#self.SHORTCUT_LOCAL = self.STATE_GLOBAL["shortcut-local"]
		self.FILE_TRANSFER = FileTransfer.FileTransfer(self)
		#self.CURRENT_DIRECTORY_REMOTE = self.FILE_TRANSFER.CURRENT_DIRECTORY
		self.FILETRANSFERQUEUE = FileTransferQueue.SSH(self)

		self.PROPERTIES = kwargs["property"]
		self.CONFIG = kwargs["config"]

		__WIDGET__.WIDGET.__init__( \
			self, "filebrowser_ssh", "frame_filebrowser", self.CONFIG)

		self.connect()

	def __del__ (self) :
		self.disconnect()

	def delete (self) :
		self.disconnect()
		self.WIDGET_SELF.emit("delete-event", gtk.gdk.Event(gtk.gdk.NOTHING))

	def initialize (self) :
		__button_connect = self.getWidget("togglebutton_connect")
		self.HANDLER_ID_CONNECT = \
			__button_connect.connect("toggled", self.on_connect)

		self.PANEL_LOCAL = Panel.FileListLocal(self.xml, filebrowser=self)
		self.PANEL_TREE_LOCAL = Panel.TreeLocal(self.xml, filebrowser=self)
		self.PANEL_REMOTE = Panel.FileListRemote(self.xml, filebrowser=self)
		self.PANEL_TREE_REMOTE = Panel.TreeRemote(self.xml, filebrowser=self)

		# log textview
		__textview_log = self.getWidget("textview_log")
		self.BUFFER_LOG = __textview_log.get_buffer()
		self.BUFFER_LOG.connect("insert-text", self.on_insert_text_buffer_log)

		__style = self.WIDGET_SELF.get_style()
		__font_desc = __style.font_desc
		__font_desc.set_size(int(__font_desc.get_size() - 5 * pango.SCALE))
		__color = gtk.gdk.color_parse("#FF4E00")

		self.TAG["error"] = self.BUFFER_LOG.create_tag( \
			"error", \
			foreground_gdk=__color, \
			font_desc=__font_desc, \
		)

		self.TAG["info"] = self.BUFFER_LOG.create_tag( \
			"info", \
			font_desc=__font_desc, \
		)

		# shortcut
		self.PANEL_SHORTCUT_LOCAL = \
			Panel.ShortcutLocal(self.xml, self, **self.KWARGS)

		# initiate filetransferQueue
		self.PANEL_FILETRANSFER_STATUS = Panel.FileTransferStatus(self.xml, self)

		for i in \
				["hpaned3", "toolbar3", "entry_directory_remote", \
					"label464", "label465", ] :
			self.getWidget(i).set_property("sensitive", True)

		self.getWidget("box_tree_local").set_property("visible", True)
		self.getWidget("box_shortcut_local").set_property("visible", False)
		self.getWidget("box_tree_remote").set_property("visible", True)
		self.getWidget("box_shortcut_remote").set_property("visible", False)

		self.getWidget("toggletoolbutton4").set_active( \
			self.getWidget("box_shortcut_local").get_property("visible"))

		self.getWidget("toggletoolbutton2").set_active( \
			self.getWidget("box_shortcut_remote").get_property("visible"))

		self.listAllLocal(self.PROPERTIES["initial_directory_local"])

		self.toggleConnected()

		# connect handlers.
		#self.connect_handler(Handler.SSH_FILEBROWSER)

	##################################################
	# EVENT HANDLER
	def on_insert_text_buffer_log (self, buffer, iter, text, length) :
		start, end = self.BUFFER_LOG.get_bounds()
		mark = self.BUFFER_LOG.create_mark(None, end, False)

		self.getWidget("textview_log").scroll_to_mark(mark, 0, True, 0.0, 1.0)
		self.BUFFER_LOG.delete_mark(mark)

	def on_clean_up_file_transfer_status (self, widget) :
		self.PANEL_FILETRANSFER_STATUS.clear()

	def on_toggle_tree_and_shortcut_local (self, widget) :
		self.getWidget("box_tree_local").set_property( \
			"visible", \
			not self.getWidget("box_tree_local").get_property("visible") \
		)
		self.getWidget("box_shortcut_local").set_property( \
			"visible", \
			not self.getWidget("box_tree_local").get_property("visible") \
		)

	def on_toggle_tree_and_shortcut_remote (self, widget) :
		self.getWidget("box_tree_remote").set_property( \
			"visible", \
			not self.getWidget("box_tree_remote").get_property("visible") \
		)
		self.getWidget("box_shortcut_remote").set_property( \
			"visible", \
			not self.getWidget("box_tree_remote").get_property("visible") \
		)

	def on_connect (self, widget=None) :
		self.connect()

	def connect (self) :
		__is_connected = self.isConnected()
		if __is_connected :
			self.disconnect()
		else :
			self.__connect()

	def __setSizeOfWidget (self) :
		# resize the horizontal paned.
		self.getWidget("hpaned2").set_position(100)
		self.getWidget("hpaned3").set_position(100)
		self.getWidget("hpaned1").set_position( \
			int(self.STATE_LOCAL["obj-vee"].WIDGET_SELF.allocation.width / 2))
		self.getWidget("vpaned2").set_position( \
			int(self.STATE_LOCAL["obj-vee"].WIDGET_SELF.allocation.height - 200))

	def toggleConnected (self) :
		__is_connected = self.isConnected()
		__button_connect = self.getWidget("togglebutton_connect")
		if not __button_connect : return

		if __is_connected :
			__image = gtk.Image()
			__image.set_from_stock("gtk-disconnect", gtk.ICON_SIZE_BUTTON)
			__label = gtk.Label(_("Disconnect"))
			__button_connect.set_icon_widget(__image)
			__button_connect.set_label_widget(__label)

			for i in \
					["hpaned3", "toolbar3", "entry_directory_remote", \
						"label464", "label465", ] :
				self.getWidget(i).set_property("sensitive", True)

			self.PANEL_SHORTCUT_REMOTE = \
				Panel.ShortcutRemote(self.xml, self, **self.KWARGS)
		else :
			__image = gtk.Image()
			__image.set_from_stock("gtk-connect", gtk.ICON_SIZE_BUTTON)
			__label = gtk.Label(_("Connect"))
			__button_connect.set_icon_widget(__image)
			__button_connect.set_label_widget(__label)

			for i in \
					["hpaned3", "toolbar3", "entry_directory_remote", \
						"label464", "label465", ] :
				self.getWidget(i).set_property("sensitive", False)

			if self.DIALOG_MESSAGE :
				self.DIALOG_MESSAGE.on_close(None)

		__image.show()
		__label.show()
		self.__setSizeOfWidget()

		# update the 'active' state of togglebutton
		__button_connect.handler_block(self.HANDLER_ID_CONNECT)
		__button_connect.set_active(__is_connected)
		__button_connect.handler_unblock(self.HANDLER_ID_CONNECT)

	def on_stop_transfer (self, widget) :
		__uids = self.PANEL_FILETRANSFER_STATUS.getCurrentSelectedUID()
		for i in __uids :
			self.FILETRANSFERQUEUE.stop(i)

	#######################################################
	# LOCAL EVENT
	def on_open_session (self, toolbutton) :
		__new_property = { \
			"user" : self.PROPERTIES["user"], \
			"password" : self.PROPERTIES["password"], \
			"host" : self.PROPERTIES["host"], \
			"port" : self.PROPERTIES["port"], \
		}
		if self.PROPERTIES.has_key("ssh_version") :
			__new_property["ssh_versions"] = self.PROPERTIES["ssh_version"]

		self.STATE_LOCAL["obj-vee"].addPage("ssh", **__new_property)

	def on_directory_new_local (self, widget) :
		__name = \
			__OS__.get_new_directory_name(os.listdir(self.CURRENT_DIRECTORY_LOCAL))

		__new_filepath = os.path.join(self.CURRENT_DIRECTORY_LOCAL, __name)
		__ret = __OS__.mkdir(__new_filepath)
		if __ret is not True :
			if __ret == __OS__.ERROR_FILE_ALREADY_EXISTS :
				__log_text = "'%s' already exists." % __new_filepath
			elif __ret == __OS__.ERROR_NO_PERMISSION :
				__log_text = "You have no permission."
			elif __ret == __OS__.IOError :
				__log_text = "IOError"
			else :
				__log_text = "Failed to create new directory, '%s'" % __new_filepath

			self.writeLog("%s\n" % __log_text, "local", "error")
			return False

		__iter = \
			self.PANEL_LOCAL.addRow( \
				[__new_filepath] + list(os.stat(__new_filepath)) \
			)
		self.PANEL_LOCAL.set_editable(__iter)

	def on_directory_home_local (self, widget) :
		self.listAllLocal(pwd.getpwnam(getpass.getuser())[5])

	def on_directory_up_local (self, widget) :
		self.listAllLocal ( \
			os.path.normpath(os.path.join(self.CURRENT_DIRECTORY_LOCAL, "../")) \
		)

	def on_refresh_list_all_local (self, widget) :
		self.listAllLocal()

	def on_done_directory_entry_local (self, widget, event) :
		if func_global.get_keyname(event) != "Return" :
			return
		else :
			__path = self.getRealPathLocal(widget.get_text())
			if not __path :
				self.updateDirectoryEntryLocal(self.getRealPathLocal())
				return

			self.listAllLocal(__path)

	#######################################################
	# REMOTE EVENT
	def on_directory_new_remote (self, widget) :
		path = self.getRealPathRemote(self.FILE_TRANSFER.CURRENT_DIRECTORY)

		d = self.FILE_TRANSFER.cmd_LS(path)
		d.addCallback(self.__cb_on_directory_new_remote, path)
		d.addErrback(self.errBackRemote, "create new directory")

	def __cb_on_directory_new_remote (self, result, path) :
		__name = __OS__.get_new_directory_name([i[0] for i in result])

		__new_filepath = os.path.join(self.FILE_TRANSFER.CURRENT_DIRECTORY, __name)
		d = self.FILE_TRANSFER.cmd_MKDIR(__new_filepath)
		d.addCallback(self.__cb_on_directory_new_remote0, __new_filepath)
		d.addErrback(self.errBackRemote, "create new directory")

	def __cb_on_directory_new_remote0 (self, result, new_filepath) :
		d = self.FILE_TRANSFER.cmd_LS(new_filepath)
		d.addCallback(self.__cb_on_directory_new_remote1, new_filepath)
		d.addErrback(self.errBackRemote, "create new directory")

	def __cb_on_directory_new_remote1 (self, result, new_filepath) :
		if len(result) < 1 :
			return

		__iter = self.PANEL_REMOTE.addRow( \
			[os.path.basename(new_filepath), ] + list(result[0])[1:])

		self.PANEL_REMOTE.set_editable(__iter)

	def on_directory_home_remote (self, widget) :
		self.listAllRemote(self.FILE_TRANSFER.TRANSFER.DIRECTORY_HOME)

	def on_directory_up_remote (self, widget) :
		self.listAllRemote ( \
			os.path.normpath(os.path.join(self.FILE_TRANSFER.CURRENT_DIRECTORY, "../")) \
		)

	def on_refresh_list_all_remote (self, widget) :
		self.listAllRemote()

	def on_done_directory_entry_remote (self, widget, event) :
		if func_global.get_keyname(event) != "Return" :
			return
		else :
			__path = widget.get_text()
			self.listAllRemote(__path)

	##################################################
	# misc HANDLER
	def getDefaultPathLocal (self) :
		return os.path.abspath(os.curdir)

	def getRealPathLocal (self, path=None, isFile=False) :
		if not path : return self.CURRENT_DIRECTORY_LOCAL
		if not path.strip().startswith("/") :
			path = os.path.join(self.CURRENT_DIRECTORY_LOCAL, path.strip())

		if not isFile and not path.endswith('/') :
			path += '/'

		if not __OS__.exists(path) :
			return None

		return os.path.normpath(path)

	def getRealPathRemote (self, path, isFile=False) :
		if not path : return self.FILE_TRANSFER.CURRENT_DIRECTORY
		if not path.strip().startswith("/") :
			path = os.path.join(self.FILE_TRANSFER.CURRENT_DIRECTORY, path.strip())

		if not isFile and not path.endswith("/") :
			path += "/"

		return path

	def isConnected (self) :
		if self.CONNECTION :
			try :
				return self.CONF["filetransfer"].getClient().connected
			except :
				return False
		else :
			return False

	def disconnect (self) :
		if self.CONNECTION :
			self.CONNECTION.transport.loseConnection()

			self.CONNECTION = None
			self.CONF = None

	def __connect (self) :
		options = __SSHClient__.ClientOptions()
		options.opt_logininfo(**self.PROPERTIES)

		self.CONF = { \
			"state" : self.STATE, \
			"gconf_client" : self.GCONF_CLIENT, \
			"options" : options, \
			"filetransfer" : self.FILE_TRANSFER, \
		}

		options = self.CONF["options"]

		__factory = __SSHClient__.SSHClientFactory(self.CONF, self)
		reactor.connectTCP( \
			options["host"], \
			options["port"], \
			__factory, \
		)

		self.writeLog( \
			"Connecting to %s........." % main_ssh.get_label_name(self.PROPERTIES), \
			None, \
			"info", \
		)

	def connectionMade (self) :
		self.writeLog("Done.\n", None, "info")
		self.__connectionMade()

	def __connectionMade (self) :
		# go home.
		self.FILE_TRANSFER.cmd_CD().addCallback(self._cb_connectionMade)

	def _cb_connectionMade (self, path) :
		self.listAllRemote(self.PROPERTIES["initial_directory_remote"])

	##############################################################
	# LISTING
	def updateDirectoryEntryRemote (self, path=None) :
		__entry = self.getWidget("entry_directory_remote")
		__entry.set_text(self.FILE_TRANSFER.CURRENT_DIRECTORY)
		__entry.select_region(0, -1)

	def updateDirectoryEntryLocal (self, path) :
		__entry = self.getWidget("entry_directory_local")
		__entry.set_text(path)
		__entry.select_region(0, -1)

	##############################################################
	# LOCAL LISTING
	def listAllLocal (self, path=None) :
		self.listFileLocal(path)
		return

	def listFileLocal (self, path=None) :
		path = self.getRealPathLocal(path)
		if not path :
			path = __OS__.get_valid_path(self.CURRENT_DIRECTORY_LOCAL)
			if not path :
				path = self.getDefaultPathLocal()

		self.CURRENT_DIRECTORY_LOCAL = path

		__files = os.listdir(path)
		result = list()
		for i in __files :
			__filepath = os.path.join(path, i)
			result.append(tuple([__filepath, ] + list(os.stat(__filepath))))

		self.PANEL_LOCAL.clear()
		self.PANEL_LOCAL.addRows(result)

		self.updateDirectoryEntryLocal(path)
		self.listTreeLocal(os.path.normpath(os.path.join(path, "../")))

		return

	def listTreeLocal (self, path) :
		path = self.getRealPathLocal(path)

		__files = os.listdir(path)
		result = list()
		for i in __files :
			__filepath = os.path.join(path, i)
			result.append(tuple([__filepath, ] + list(os.stat(__filepath))))

		self.PANEL_TREE_LOCAL.addRows(result)

		return

	##############################################################
	# REMOTE LISTING
	def listAllRemote (self, path=None) :
		if not path : path = self.FILE_TRANSFER.CURRENT_DIRECTORY
		self.listFileRemote(path)

	def listTreeRemote (self, path) :
		path = self.getRealPathRemote(path)

		d = self.FILE_TRANSFER.cmd_LS(path)
		d.addCallback(self.__listTreeRemote, path)
		d.addErrback(self.errBackRemote, "tree-remote")

		return

	def __listTreeRemote (self, result, path) :
		if not result : return

		self.PANEL_TREE_REMOTE.addRows(result)

	def listFileRemote (self, path=None) :
		if path :
			path = self.getRealPathRemote(path)

		d = self.FILE_TRANSFER.cmd_CD(path)
		d.addCallback(self._cb_listFileRemote, path)
		d.addErrback(self._eb_listFileRemote)

	def _eb_listFileRemote (self, f) :
		self.listAllRemote(self.FILE_TRANSFER.CURRENT_DIRECTORY)
		self.writeLog("%s\n" % f.value, "remote", "error")

	def _cb_listFileRemote (self, result, path) :
		d = self.FILE_TRANSFER.cmd_LS(path)
		d.addCallback(self.__listFileRemote1, path)
		d.addErrback(self.errBackRemote, "listfile-remote")

		return d

	def __listFileRemote1 (self, result, path) :
		if not result : return
		#if path == self.CURRENT_DIRECTORY_REMOTE : return

		self.DIRECTORY_HISTORY_REMOTE.append(path)
		self.updateDirectoryEntryRemote(path)

		self.PANEL_REMOTE.clear()
		self.PANEL_REMOTE.addRows(result)
		self.listTreeRemote(os.path.normpath(os.path.join(path, "../")))

	def errBackLocal (self, retval, parm0=None) :
		if retval == __OS__.ERROR_OK :
			__log_text = "OK"
		elif retval == __OS__.ERROR_FILE_ALREADY_EXISTS :
			__log_text = "File or directory already exists."
		elif retval == __OS__.ERROR_NO_PERMISSION :
			__log_text = "No permission"
		elif retval == __OS__.ERROR_IOERROR :
			__log_text = "IO Error"
		elif retval == __OS__.ERROR_NO_SUCH_FILE_OR_DIRECTORY :
			__log_text = "No such file or directory"
		elif retval == __OS__.ERROR_DESTINATION_NO_SUCH_FILE_OR_DIRECTORY :
			__log_text = "No such file or directory"
		elif retval == __OS__.ERROR_OS_ERROR :
			__log_text = "OSError"
		elif retval == __OS__.ERROR_DESTINATION_IS_FILE :
			__log_text = "It is file."
		else :
			__log_text = "Failed."

		self.writeLog("%s\n" % __log_text, "local", "error")

	def ignore (self, f, parm0=None) :
		pass

	def errBackRemote (self, f, error_type=None) :
		if error_type == "listfile-remote" :
			self.updateDirectoryEntryRemote()

		self.writeLog("%s\n" % f.value, "remote", "error")
		return

	def writeLog (self, message, direction=None, type="error") :
		message = _(message)

		if type not in ["info", "error", ] :
			type = "info"

		message = "%s" % (message, )
		if direction :
			message = "[%s] %s" % (_(direction), message, )

		__iter = self.BUFFER_LOG.get_bounds()[1]
		self.BUFFER_LOG.insert_with_tags(__iter, "%s" % message, self.TAG[type])

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "FileBrowser.py"


