# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import time, gobject
from vee import func
from vee.child.filebrowser_ssh import main

class SSH :
	METHOD = "get"
	TREESTORE = None
	ITER = None
	REMOTE_FILE = None
	START_TIME = None

	HANDLER_ID_UPDATE = None

	def __init__ (self, method, treestore, iter, filebrowser) :
		self.METHOD = method
		self.TREESTORE = treestore
		self.ITER = iter
		self.FILEBROWSER = filebrowser

	def starting (self, lf, rf, startTime) :
		self.START_TIME = startTime

		if self.METHOD == "get" :
			self.FILE = rf
		elif self.METHOD == "put" :
			self.FILE = lf

		self.HANDLER_ID_UPDATE = gobject.timeout_add(1000, self.update)

	def stop (self) :
		gobject.source_remove(self.HANDLER_ID_UPDATE)
		self.HANDLER_ID_UPDATE = None

	def update (self) :
		diff = time.time() - self.START_TIME
		total = self.FILE.total
		speed = total/diff

		if speed > 10000 :
			__str_speed = "%s M/s" % round(speed / 10000)
		elif speed > 1000 :
			__str_speed = "%s K/s" % round(speed / 1000)
		else :
			__str_speed = "%s B/s" % speed

		if speed :
			timeLeft = (self.FILE.size - total) / speed
		else :
			timeLeft = 0

		#(total/self.FILE.size) * 100, \
		#self._abbrevSize(total),
		#self._abbrevSize(total/diff), \
		#self._abbrevTime(timeLeft) \

		try :
			__rate = int(float(total)/float(self.FILE.size) * 100)
		except ZeroDivisionError :
			__rate = 100

		return self.FILEBROWSER.PANEL_FILETRANSFER_STATUS.update( \
			self.ITER, timeLeft, __rate, __str_speed)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Progress.py"


