# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
from vee import i18n, __OS__, child
from vee.child import __BASIC__
from vee.child.ssh import main
from vee.child.filebrowser_ssh import Filebrowser

COMMAND_CONCH_SESSION = "conch.py"
SIGNAL_REMOVE = "delete-event"

_ = i18n.gettext()

class egg (__BASIC__.egg) :
	FILE_UID = None

	def normalizeProperty (self, kwargs) :
		__BASIC__.egg.normalizeProperty(self, kwargs)

		# save property in pickled file.
		__data = main.check_uid_data(self.PROPERTIES)
		if __data == main.RETVAL_UID_INSUFFICIENT_DATA :
			raise RuntimeError, "insufficient data."
		elif __data == main.RETVAL_UID_HOST_INVALID :
			raise RuntimeError, "invalid host."
		elif __data == main.RETVAL_UID_IP_ADDRESS_INVALID :
			raise RuntimeError, "invalid ipaddress or host."
		elif __data == main.RETVAL_UID_NO_PASSWORD :
			raise RuntimeError, "password was missing."

	FILEBROWSER = None
	def make (self) :
		self.FILEBROWSER = Filebrowser.SSH( \
				state=self.STATE, \
				config=self.CONFIG, \
				property=self.PROPERTIES \
			)

		self.WIDGET = self.FILEBROWSER.WIDGET_SELF

	def attached (self, obj_tab) :
		__BASIC__.egg.attached(self, obj_tab)
		self.WIDGET.connect(SIGNAL_REMOVE, self.OBJ_TAB.on_remove)

	def getLabelName (self) :
		return main.get_label_name(self.PROPERTIES)

	def __del__ (self) :
		self.FILEBROWSER.__del__()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "egg.py"


