# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import gobject, gtk, gnomevfs
from vee import __VEE__, WIDGET, __OS__, Conf, Conf__, child
from vee.child import __BASIC__, __WIDGET__, __PROPERTY__
from vee.child.ssh import main as main_ssh
from vee.child.filebrowser_ssh import XMLHandler

FILE_SHORTCUT_LOCAL = \
	os.path.join(os.getenv("HOME"), Conf__.DIR_LOCAL, "shortcut_local.xml")
TREEVIEW_TREE_PANEL_COLUMN_ICON = 0
TREEVIEW_TREE_PANEL_COLUMN_NAME = 1

TREEVIEW_FILELIST_PANEL_COLUMN_ICON = 0
TREEVIEW_FILELIST_PANEL_COLUMN_NAME = 1
TREEVIEW_FILELIST_PANEL_COLUMN_SIZE = 2
TREEVIEW_FILELIST_PANEL_COLUMN_PERMISSION = 3
TREEVIEW_FILELIST_PANEL_COLUMN_CREATED_TIME = 4
TREEVIEW_FILELIST_PANEL_COLUMN_PERMISSION_BIN = 5
TREEVIEW_FILELIST_PANEL_COLUMN_FULL_PATH = 6
TREEVIEW_FILELIST_PANEL_COLUMN_FULL_FILEATTR = 7

TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_DIRECTION = 0
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_ICON = 1
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_FILEPATH = 2
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_FILE_SIZE = 3
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_TIME_LEFT = 4
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_PERCENT = 5
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_SPEED = 6
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_LOCAL_FILEPATH = 7
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_UID = 8
TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_DONE = 9

TREEVIEW_SHORTCUT_PANEL_COLUMN_ICON = 0
TREEVIEW_SHORTCUT_PANEL_COLUMN_NAME = 1
TREEVIEW_SHORTCUT_PANEL_COLUMN_VALUE = 2
TREEVIEW_SHORTCUT_PANEL_COLUMN_UID = 3

MENU_ACCELERATOR_SSH_FILEBROWSER_FILELIST = { \
	"copy" : "<Control>c", \
	"cut" : "<Control>x", \
	"paste" : "<Control>v", \
	"remove" : "Delete", \
	"rename" : "F2", \
	"select_all" : "<Control>a", \
}

class main (__BASIC__.main) :
	"""
	Define the routine when child was catched by VEE.
	"""

	def initialize (self) :
		# ADD KEYBOARD SHORTCUT ##########################################
		__accel_group = self.STATE_LOCAL["obj-vee"].ACCEL_GROUP_GLOBAL
		(__key, __mod, ) = \
			__accel_group.getDataByGConf("keyboard_shortcut_insert_filebrowser_ssh")
		if __key :
			__accel_group.addKey( \
				"keyboard_shortcut_insert_filebrowser_ssh", __key, __mod, self.on_insert)

			self.GCONF_CLIENT.CLIENT.notify_add( \
				self.GCONF_CLIENT.generatePath("keyboard_shortcut_insert_filebrowser_ssh"), \
				self.nf_update_accel_key \
			)

		# get local shortcut xmlhandler.
		if self.STATE_GLOBAL.has_key("shortcut-local") and \
				self.STATE_GLOBAL["shortcut-local"] :
			pass
		else :
			try :
				__shortcut_local = XMLHandler.Shortcut(FILE_SHORTCUT_LOCAL)
			except IOError :
				__shortcut_local = XMLHandler.Shortcut()

			self.STATE_GLOBAL.set_value("shortcut-local", __shortcut_local)

	def on_insert (self, accel_group, acceleratable, keyval, modifier) :
		self.OBJ_VEE.on_insert_child(None, "filebrowser_ssh")

class bookmark_property (__PROPERTY__.CORE) :

	def __init__ (self, uid, **kwargs) :
		__PROPERTY__.CORE.__init__(self, "filebrowser_ssh", uid, **kwargs)

	def initialize (self) :
		self.getWidget("entry4").set_text(self.DATA["host"])
		self.getWidget("entry5").set_text(self.DATA["user"])
		self.getWidget("entry3").set_text(self.DATA["password"])

		if not str(self.DATA["port"]).strip() :
			__port = "22"
		else :
			try :
				int(self.DATA["port"])
			except ValueError :
				__port = "22"
			else :
				__port = str(self.DATA["port"]).strip()

		self.getWidget("entry6").set_text(__port)

		# set ssh version.
		__combobox_ssh_version = self.xml.get_widget("combobox1")

		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()
		__cell0.set_property("xalign", 0.0)
		__cell1 = gtk.CellRendererText()

		__treestore_ssh_version = gtk.TreeStore(str, str)
		__combobox_ssh_version.set_model(__treestore_ssh_version)

		# add columns to treeview
		__combobox_ssh_version.pack_start(__cell0, False)
		__combobox_ssh_version.set_attributes(__cell0, text=0)

		__treestore_ssh_version.append(None, [_("Version 2"), "2"])
		__treestore_ssh_version.append(None, [_("Version 1"), "1"])
		__combobox_ssh_version.set_active(0)

		# set initial directory
		self.getWidget("filechooserbutton1").set_filename( \
			__OS__.normalize_path(self.DATA["initial_directory_local"]) \
		)
		self.getWidget("entry7").set_text(self.DATA["initial_directory_remote"])

		__PROPERTY__.CORE.initialize(self)

	##################################################
	# EVENT HANDLER
	def on_ssh_changed_ssh_version (self, combobox) :
		__treemodel = combobox.get_model()
		self.BOOKMARK.setValue( \
			self.NODE, \
			"ssh_version", \
			__treemodel.get_value(combobox.get_active_iter(), 1), \
		)

	def on_ssh_changed_host (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "host", __new)

	def on_ssh_changed_user (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "user", __new)

	def on_ssh_changed_password (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "password", __new)

	def on_ssh_changed_port (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return

		try :
			int(__new)
		except ValueError :
			entry.set_text("22")
			return

		self.BOOKMARK.setValue(self.NODE, "port", __new)

	def on_changed_initial_directory_local (self, fileselector) :
		self.BOOKMARK.setValue( \
			self.NODE, "initial_directory_local", fileselector.get_filename())

	def on_changed_initial_directory_remote (self, entry) :
		self.BOOKMARK.setValue( \
			self.NODE, "initial_directory_remote", entry.get_text())

class preferences_main (__BASIC__.preferences_main) :

	def initialize (self) :
		__BASIC__.preferences_main.initialize(self)

class Message (__VEE__.Core, __WIDGET__.WIDGET) :

	FACTORY = None

	def __init__ (self, **kwargs) :
		if not kwargs.has_key("factory") :
			raise RuntimeError, "factory must be given."
		else :
			self.FACTORY = kwargs["factory"]

		__VEE__.Core.__init__(self, **kwargs)

		__WIDGET__.WIDGET.__init__( \
			self, "filebrowser_ssh", "connecting", kwargs["config"])

		self.WIDGET_SELF.present()
		self.WIDGET_SELF.present()
		self.WIDGET_SELF.present()

	def on_cancel (self, button) :
		self.on_close(None)
		del self.FACTORY

def test (state, **kwargs) :
	if type(main_ssh.check_uid_data(kwargs)) is dict :
		return True
	else :
		gobject.idle_add( \
			load_dialog_connection, \
			state, \
			child.get_child_config("filebrowser_ssh") \
		)

		return False

def load_dialog_connection (state, config) :
	main_ssh.DialogConnection( \
		session_type=main_ssh.SSH_SESSION_SFTP, state=state, config=config \
	)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "main.py"


