# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import gtk
from vee import WIDGET, GNOME, child
from vee.child import __VTE__

def show_menu (event, WIDGET_ROOT, callback_functions, properties, config) :
	if event.button == 3 :
		__MENU__( \
			event, \
			widget_root=WIDGET_ROOT, \
			callback_functions=callback_functions, \
			properties=properties, \
			config=config \
		)

class __MENU__ (__VTE__.__MENU__) :

	PROPERTIES = None

	def __init__ (self, event, **kwargs) :
		self.PROPERTIES = kwargs["properties"]
		self.CONFIG = kwargs["config"]

		__VTE__.__MENU__.__init__ (self, event, **kwargs)

	def initialize (self) :
		__VTE__.__MENU__.initialize(self)

		# separator.
		__menu = gtk.SeparatorMenuItem()
		__menu.show()
		self.WIDGET_SELF.prepend(__menu)

		# add custom menu item.
		GNOME_ICON = GNOME.Icon("ICON_SIZE_BUTTON")

		if self.CONFIG["layout"]["icon"]["stock_id"] :
			__icon = GNOME_ICON.getPixbufByIcon( \
				self.CONFIG["layout"]["icon"]["stock_id"])
		elif self.CONFIG["layout"]["icon"]["image"]:
			__icon_path = os.path.join( \
				child.get_path_child("filebrowser_ssh"), \
				self.CONFIG["layout"]["icon"]["image"] \
			)
			__icon = GNOME_ICON.getPixbufFromFile(__icon_path)

		__image = gtk.Image()
		__image.set_from_pixbuf(__icon)
		__image.show()

		__menu = gtk.ImageMenuItem("Open this session in Filebrowser")
		__menu.set_image(__image)
		__menu.connect("activate", self.on_open_filebrowser)
		__menu.show()
		self.WIDGET_SELF.prepend(__menu)

	def on_open_filebrowser (self, menuitem) :
		__new_property = { \
			"user" : self.PROPERTIES["user"], \
			"password" : self.PROPERTIES["password"], \
			"host" : self.PROPERTIES["host"], \
			"port" : self.PROPERTIES["port"], \
		}
		if self.PROPERTIES.has_key("ssh_version") :
			__new_property["ssh_versions"] = self.PROPERTIES["ssh_version"]

		self.CALLBACK_FUNCTIONS["addPage"]( \
			"filebrowser_ssh", **__new_property)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "1.py"


