# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, base64, marshal
import gobject

from vee import i18n, __OS__, child
from vee.child import __VTE__
from vee.child.ssh import main, Menu

COMMAND_CONCH_SESSION = "conch.py"

_ = i18n.gettext()

class egg (__VTE__.egg) :
	PATH = "~"
	FILE_UID = None

	def __del__ (self) :
		__VTE__.egg.__del__(self)

		# remove temporary file.
		__OS__.remove(self.FILE_UID)

	def normalizeProperty (self, kwargs=dict()) :
		__VTE__.egg.normalizeProperty(self, kwargs)

		# save property in pickled file.
		__data = main.check_uid_data(self.PROPERTIES)
		if __data == main.RETVAL_UID_INSUFFICIENT_DATA :
			raise RuntimeError, "insufficient data."
		elif __data == main.RETVAL_UID_HOST_INVALID :
			raise RuntimeError, "invalid host."
		elif __data == main.RETVAL_UID_IP_ADDRESS_INVALID :
			raise RuntimeError, "invalid ipaddress or host."
		elif __data == main.RETVAL_UID_NO_PASSWORD :
			raise RuntimeError, "password was missing."

		__command_path = \
			os.path.join(child.get_path_child("ssh"), COMMAND_CONCH_SESSION)
		self.FILE_UID = main.save_pickle_data_for_ssh(__data)

		self.PROPERTIES["command"] = \
			"%s --uid=%s" % (__command_path, self.FILE_UID)

	def fork_command (self) :
		gobject.timeout_add(100, self.__fork_command)

	def __fork_command (self) :
		__VTE__.egg.fork_command(self)
		return False

	def parse_command (self) :
		(__command, __argument, __environment, __directory, ) = \
			__VTE__.egg.parse_command(self)

		return (__command, __argument, __environment, os.getcwd(), )

	def getTitle (self) :
		__t = __VTE__.egg.getTitle(self)

		if not __t : return self.PATH

		__t0 = "".join(__t.split(":")[1:]).strip()

		if len(__t0) < 1 :
			__title = __t
		else :
			__title = __t0

		return __title

	def getLabelName (self) :
		return main.get_label_name(self.PROPERTIES)

	def on_changed_title (self) : pass

	def attachPopupMenu (self, vte, event) :
		__callback_function = { \
			"addPage" : self.STATE_LOCAL["obj-vee"].addPage, \
		}
		Menu.show_menu( \
			event, \
			self.WIDGET,\
			__callback_function, \
			self.PROPERTIES, \
			self.CONFIG \
		)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "egg.py"


