# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import gobject, gtk, gnomevfs
from vee import __VEE__, WIDGET, __OS__, child
from vee.child import __BASIC__, __WIDGET__, __PROPERTY__

class main (__BASIC__.main) :
	"""
	Define the routine when child was catched by VEE.
	"""

	def __init__ (self, obj_vee, **kwargs) :
		__BASIC__.main.__init__(self, obj_vee, **kwargs)

		if not self.STATE_GLOBAL["use_twisted"] :
			raise RuntimeError, "Twisted was not installed or not properly configured."

	def initialize (self) :
		# ADD KEYBOARD SHORTCUT ##########################################
		__accel_group = self.STATE_LOCAL["obj-vee"].ACCEL_GROUP_GLOBAL
		(__key, __mod, ) = \
			__accel_group.getDataByGConf("keyboard_shortcut_insert_ssh")
		if __key :
			__accel_group.addKey( \
				"keyboard_shortcut_insert_ssh", __key, __mod, self.on_insert)

			self.GCONF_CLIENT.CLIENT.notify_add( \
				self.GCONF_CLIENT.generatePath("keyboard_shortcut_insert_ssh"), \
				self.nf_update_accel_key \
			)

	def on_insert (self, accel_group, acceleratable, keyval, modifier) :
		self.OBJ_VEE.on_insert_child(None, "ssh")

class bookmark_property (__PROPERTY__.VTE) :

	def __init__ (self, uid, **kwargs) :
		__PROPERTY__.VTE.__init__(self, "ssh", uid, **kwargs)

	def initialize (self) :
		self.getWidget("entry4").set_text(self.DATA["host"])
		self.getWidget("entry5").set_text(self.DATA["user"])
		self.getWidget("entry3").set_text(self.DATA["password"])

		if not str(self.DATA["port"]).strip() :
			__port = "22"
		else :
			try :
				int(self.DATA["port"])
			except ValueError :
				__port = "22"
			else :
				__port = str(self.DATA["port"]).strip()

		self.getWidget("entry6").set_text(__port)

		# set ssh version.
		__combobox_ssh_version = self.xml.get_widget("combobox1")

		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()
		__cell0.set_property("xalign", 0.0)
		__cell1 = gtk.CellRendererText()

		__treestore_ssh_version = gtk.TreeStore(str, str)
		__combobox_ssh_version.set_model(__treestore_ssh_version)

		# add columns to treeview
		__combobox_ssh_version.pack_start(__cell0, False)
		__combobox_ssh_version.set_attributes(__cell0, text=0)

		__treestore_ssh_version.append(None, [_("Version 2"), "2"])
		__treestore_ssh_version.append(None, [_("Version 1"), "1"])
		__combobox_ssh_version.set_active(0)

		__PROPERTY__.VTE.initialize(self)

	##################################################
	# EVENT HANDLER
	def on_ssh_changed_ssh_version (self, combobox) :
		__treemodel = combobox.get_model()
		self.BOOKMARK.setValue( \
			self.NODE, \
			"ssh_version", \
			__treemodel.get_value(combobox.get_active_iter(), 1), \
		)

	def on_ssh_changed_host (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "host", __new)

	def on_ssh_changed_user (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "user", __new)

	def on_ssh_changed_password (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "password", __new)

	def on_ssh_changed_port (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return

		try :
			int(__new)
		except ValueError :
			entry.set_text("22")
			return

		self.BOOKMARK.setValue(self.NODE, "port", __new)

class preferences_main (__BASIC__.preferences_main) :

	def initialize (self) :
		__BASIC__.preferences_main.initialize(self)

	##################################################
	# EVENT HANDLER

SSH_SESSION_SESSION = 100
SSH_SESSION_SFTP = 101
class DialogConnection (__VEE__.Core, __WIDGET__.WIDGET) :

	CALLBACK_FUNCTIONS = dict()
	PANEL = None
	SESSION_TYPE = SSH_SESSION_SESSION

	def __init__ (self, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)

		__WIDGET__.WIDGET.__init__( \
			self, "ssh", "connection_ssh", kwargs["config"])

		# set the session type, "session" or "sftp"
		if kwargs.has_key("session_type") and \
				kwargs["session_type"] == SSH_SESSION_SFTP :
			self.SESSION_TYPE = SSH_SESSION_SFTP
		else :
			self.SESSION_TYPE = SSH_SESSION_SESSION

	def saveDefaultValue (self, data) :
		self.STATE_LOCAL["latest_ssh_connection_info"] = data

	def getDefaultValue (self) :
		if not self.STATE_LOCAL.has_key("latest_ssh_connection_info") :
			self.STATE_LOCAL["latest_ssh_connection_info"] = { \
				"host" : str(), \
				"user" : str(), \
				"password" : str(), \
				"port" : 22, \
				"ssh_version" : 2, \
			}

		return self.STATE_LOCAL["latest_ssh_connection_info"]

	def initialize (self) :
		__value = self.getDefaultValue()

		# expander.
		self.xml.get_widget("expander4").set_expanded(False)

		__combobox_ssh_version = self.xml.get_widget("combobox5")

		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()
		__cell0.set_property("xalign", 0.0)

		__treestore_ssh_version = gtk.TreeStore(str, str)
		__combobox_ssh_version.set_model(__treestore_ssh_version)

		# add columns to treeview
		__combobox_ssh_version.pack_start(__cell0, False)
		__combobox_ssh_version.set_attributes(__cell0, text=0)

		__treestore_ssh_version.append(None, [_("Version 2"), "2", ])
		__treestore_ssh_version.append(None, [_("Version 1"), "1", ])

		# assign value
		self.xml.get_widget("entry23").set_text(__value["host"])
		self.xml.get_widget("entry24").set_text(__value["user"])
		self.xml.get_widget("entry27").set_text(__value["password"])
		self.xml.get_widget("entry26").set_text(str(__value["port"]))

		if __value["ssh_version"] == 1 :
			__combobox_ssh_version.set_active(1)
		else :
			__combobox_ssh_version.set_active(0)

	def __grab_data (self) :
		__info = dict()

		__info["host"] = self.xml.get_widget("entry23").get_text()
		__info["user"] = self.xml.get_widget("entry24").get_text()

		__combobox_ssh_version = self.xml.get_widget("combobox5")
		__treemodel = __combobox_ssh_version.get_model()

		try :
			__info["ssh_version"] = \
				int(__treemodel.get_value( \
					__combobox_ssh_version.get_active_iter(), 1) \
				)
		except ValueRrror :
			__info["ssh_version"] = 2

		try :
			__info["port"] = int(self.xml.get_widget("entry26").get_text())
		except ValueError :
			__info["port"] = 22

		if len(self.xml.get_widget("entry27").get_text()) > 0 :
			__info["password"] = self.xml.get_widget("entry27").get_text()

		return __info

	def on_connect (self, widget) :
		__args = self.__grab_data()
		__args_parsed = check_uid_data(__args)

		if type(__args_parsed) is not dict :
			return

		__args.update(__args_parsed)

		# save info.
		self.saveDefaultValue(__args)

		__addPage = self.STATE_LOCAL["obj-vee"].addPage
		self.on_close(None)

		if self.SESSION_TYPE == SSH_SESSION_SFTP :
			__addPage("filebrowser_ssh", **__args)
		else :
			__addPage("ssh", **__args)

		return False


##################################################
# FUNCTIONS
import pickle
from vee import Conf__, func
def get_pickle_data_for_ssh (uid) :
	__directory_tmp = os.path.join(Conf__.DIR_LOCAL, "tmp")
	if not __OS__.is_file(os.path.join(__directory_tmp, uid)) :
		return None
	else :
		__fd = file(os.path.join(__directory_tmp, uid), "r")
		__obj = pickle.load(__fd)
		__fd.close()

		return __obj

def save_pickle_data_for_ssh (obj) :
	__directory_tmp = os.path.join(os.getenv("HOME"), Conf__.DIR_LOCAL, "tmp")

	uid = func.get_uid()
	while __OS__.is_file(os.path.join(__directory_tmp, uid)) :
		# get new uid.
		uid = func.get_uid()

	__file_uid = os.path.join(__directory_tmp, uid)
	__fd = file(__file_uid, "w")
	__obj = pickle.dump(obj, __fd)
	__fd.close()

	return __file_uid

RETVAL_UID_INSUFFICIENT_DATA = -5
RETVAL_UID_HOST_INVALID = -4
RETVAL_UID_IP_ADDRESS_INVALID = -3
RETVAL_UID_NO_PASSWORD = -2
def check_uid_data (data) :
	__new = dict()

	__keys = data.keys()
	if "host" not in __keys or \
			"user" not in __keys or \
			"password" not in __keys :
		return RETVAL_UID_INSUFFICIENT_DATA

	if not data["host"].strip() :
		return RETVAL_UID_HOST_INVALID

	if not func.is_ip_address(data["host"]) :
		__new["host"] = data["host"]
	else :
		if not func.is_valid_ip_address(data["host"]) :
			return RETVAL_UID_IP_ADDRESS_INVALID
		else :
			__new["host"] = data["host"]

	if not data.has_key("password") :
		return RETVAL_UID_NO_PASSWORD
	else :
		__new["password"] = data["password"]

	if not data.has_key("user") :
		__new["user"] = os.getlogin()
	else :
		if not data["user"].strip() :
			__new["user"] = os.getlogin()
		else :
			__new["user"] = data["user"]

	if not data.has_key("port") :
		__new["port"] = 22
	else :
		try :
			__new["port"] = int(data["port"])
		except ValueError :
			__new["port"] = 22

	if not data.has_key("ssh_version") : 
		__new["ssh_version"] = 2
	else :
		if data["ssh_version"] == 1 :
			__new["ssh_version"] = 1
		else :
			__new["ssh_version"] = 2

	return __new

def get_label_name (data) :
	__label = "%(user)s@%(host)s" % data

	if data["port"] != 22 :
		__label += ":%s" % data["port"]

	return __label

def test (state, **kwargs) :
	if type(check_uid_data(kwargs)) is dict :
		return True
	else :
		gobject.idle_add( \
			load_dialog_connection, \
			state, \
			child.get_child_config("ssh") \
		)

		return False

def load_dialog_connection (state, config) :
	DialogConnection(state=state, config=config)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "main.py"


