# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gnomevfs
from vee import __VEE__, WIDGET, __OS__
from vee.child import __BASIC__, __WIDGET__, __PROPERTY__

class main (__BASIC__.main) :
	"""
	Define the routine when child was catched by VEE.
	"""
	def initialize (self) :
		# ADD KEYBOARD SHORTCUT ##########################################
		__accel_group = self.STATE_LOCAL["obj-vee"].ACCEL_GROUP_GLOBAL
		(__key, __mod, ) = __accel_group.getDataByGConf("keyboard_shortcut_insert_terminal")
		if __key :
			__accel_group.addKey("keyboard_shortcut_insert_terminal", __key, __mod, self.on_insert)

			self.GCONF_CLIENT.CLIENT.notify_add( \
				self.GCONF_CLIENT.generatePath("keyboard_shortcut_insert_terminal"), \
				self.nf_update_accel_key \
			)

	def on_insert (self, accel_group, acceleratable, keyval, modifier) :
		self.OBJ_VEE.on_insert_child(None, "terminal")

class bookmark_property (__PROPERTY__.VTE) :

	def __init__ (self, uid, **kwargs) :
		__PROPERTY__.VTE.__init__(self, "terminal", uid, **kwargs)

	def initialize (self) :
		if not __OS__.is_dir(self.DATA["path"]) :
			__path = ""
		else :
			__path = self.DATA["path"]

		self.getWidget("filechooserbutton2").set_filename(__path)
		self.getWidget("entry3").set_text(self.DATA["command"])

		__PROPERTY__.VTE.initialize(self)

	##################################################
	# EVENT HANDLER
	def on_terminal_changed_command (self, entry) :
		__command = entry.get_text().strip()

		if len(__command) < 1 : return

		self.BOOKMARK.setValue(self.NODE, "command", __command)

	def on_terminal_changed_path (self, chooser) :
		__path =  chooser.get_filename()

		if not __path :
			chooser.set_uri(self.DATA["path"])
			return

		self.BOOKMARK.setValue(self.NODE, "path", __path)

class preferences_main (__BASIC__.preferences_main) :

	def initialize (self) :
		__BASIC__.preferences_main.initialize(self)
		__command = self.GCONF_CLIENT.getValue("command")

		self.getWidget("filechooserbutton15").set_uri( \
			gnomevfs.make_uri_canonical(__command))
		self.getWidget("entry62").set_text(__command)

	##################################################
	# EVENT HANDLER
	def on_terminal_changed_filechooser_command (self, chooser) :
		__new = chooser.get_filename()

		if not __new : return
		self.getWidget("entry62").set_text(__new)

	def on_terminal_changed_command (self, entry) :
		__command = entry.get_text().strip()

		if len(__command) < 1 : return
		self.GCONF_CLIENT.setValue("command", __command)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "main.py"


