# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gtk, gobject
from vee import __TREEVIEW__, func

class MethodList (__TREEVIEW__.Core) :

	PARSER = None
	VTE = None

	PROPERTIES = { \
		"enable-search" : False, \
		"fixed-height-mode" : False, \
		"headers-clickable" : False, \
		"headers-visible" : False, \
		"hover-expand" : False, \
		"hover-selection" : False, \
		"reorderable" : False, \
		"rules-hint" : False, \
	}

	def __init__ (self, xml, **kwargs) :
		"""
		kwargs is,
			state
		"""

		self.STATE = kwargs["state"]
		self.STATE_LOCAL = kwargs["state"]["local"]
		self.STATE_GLOBAL = kwargs["state"]["global"]
		self.GCONF_CLIENT = self.STATE_GLOBAL.get_value("gconf-client")
		self.VTE = kwargs["vte"]

		self.ON_UPDATE = kwargs["callback_functions"]

		__TREEVIEW__.Core.__init__(self, xml, "treeview_method_list")

	def create_frame (self) :
		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()

		__tvcolumn0 = gtk.TreeViewColumn()

		__tvcolumn0.set_expand(True)

		self.WIDGET_TREESTORE = gtk.TreeStore(str, str)
		self.WIDGET_TREEVIEW.set_model(self.WIDGET_TREESTORE)

		self.WIDGET_TREEVIEW.append_column(__tvcolumn0)

		__tvcolumn0.pack_start(__cell0, True)

		__tvcolumn0.set_attributes( \
			__cell0, text=0)

	AVAILABLE_KEYNAMES_IN_PANEL = \
		[ \
			"j", \
			"k", \
			"<Shift>g", \
			"g", \
			"Right", \
			"Left", \
			"h", \
			"l", \
			"<Control>r", \
		]
	def on_key_press_event (self, __eventbox, event) :

		__keyname = func.get_keyname(event)
		if __keyname not in self.AVAILABLE_KEYNAMES_IN_PANEL :
			return

		(__treestore, __treeiter, ) = self.get_selected()
		if not __treeiter :
			return

		if __keyname == "<Control>r" : # Updating.
			self.ON_UPDATE(None)
		elif __keyname in ["l", "Right", ] :
			self.expandRow()
		elif __keyname in ["h", "Left", ] :
			self.collapseRow()
		elif __keyname == "j" :
			self.goDownOneRow()
		elif __keyname == "k" :
			self.goUpOneRow()
		else :
			return

		return True

	def insertRow (self, parser) :
		self.PARSER = parser
		self.insert_row()

	def insert_row (self) :
		self.WIDGET_TREESTORE.clear()

		if not self.PARSER : return

		(__list_class, __class_members, ) = self.PARSER.getClassMembers()
		__functions = self.PARSER.getFunctions()

		if len(__functions) > 0 :
			__iter_functions = self.add_row(None, ("Functions", None, ))

			for i in __functions :
				functions_name = i[0]
				line_number = i[1]
				__iter = self.add_row( \
					__iter_functions, (functions_name, line_number))

		if len(__list_class) > 0 :
			for class_name, line_number in __list_class :
				__iter = self.add_row(None, (class_name, line_number))

				for i in __class_members[class_name] :
					self.add_row(__iter, i)

		self.WIDGET_TREEVIEW.expand_all()

	def add_row (self, parent, node_value) :
		return self.WIDGET_TREESTORE.append( \
			parent, \
			[node_value[0], node_value[1], ] \
		)

	#####################################################################
	# EVENT HANDLER
	def on_row_activated \
			(self, treeview, path, view_column, user_param1=None) :

		__tree_iter = self.WIDGET_TREESTORE.get_iter(path)
		__value = self.WIDGET_TREESTORE.get_value(__tree_iter, 1)

		if __value :
			self.VTE.feed_child("\033%sggz.\033" % __value)

		self.VTE.grab_focus()
		return

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Panel.py"


