# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gnomevfs, os
from vee import __VEE__, WIDGET, __OS__, GNOME, Conf
from vee.child import __BASIC__, __WIDGET__, __PROPERTY__

class main (__BASIC__.main) :
	"""
	Define the routine when child was catched by VEE.
	"""

	def initialize (self) :
		# ADD KEYBOARD SHORTCUT ##########################################
		__accel_group = self.STATE_LOCAL["obj-vee"].ACCEL_GROUP_GLOBAL
		(__key, __mod, ) = \
			__accel_group.getDataByGConf("keyboard_shortcut_insert_vim")
		if __key :
			__accel_group.addKey( \
				"keyboard_shortcut_insert_vim", __key, __mod, self.on_insert)

			self.GCONF_CLIENT.CLIENT.notify_add( \
				self.GCONF_CLIENT.generatePath("keyboard_shortcut_insert_vim"), \
				self.nf_update_accel_key \
			)

	def on_insert (self, accel_group, acceleratable, keyval, modifier) :
		self.OBJ_VEE.on_insert_child(None, "vim")

class bookmark_property (__PROPERTY__.VTE) :

	def __init__ (self, uid, **kwargs) :
		#__BASIC__.bookmark_property.__init__ (self, uid, **kwargs)
		__PROPERTY__.VTE.__init__(self, "vim", uid, **kwargs)

	def initialize (self) :
		if not __OS__.is_file(self.DATA["filename"]) :
			__path = ""
		else :
			__path = self.DATA["filename"]

		self.getWidget("filechooserbutton2").set_filename(__path)
		self.getWidget("entry3").set_text(self.DATA["command"])

		__PROPERTY__.VTE.initialize(self)

	def setIcon (self) :
		GNOME_ICON = GNOME.Icon(Conf.ICON_SIZE_PROPERTY_TYPE)
		__icon = GNOME_ICON.getPixbufByFilename(self.DATA["filename"])

		self.getWidget("image1").set_from_pixbuf(__icon)

	def changeBookmarkIcon (self) :
		GNOME_ICON = GNOME.Icon(Conf.ICON_SIZE_PANEL_BOOKMARK)
		__icon = GNOME_ICON.getPixbufByFilename(self.DATA["filename"])

		self.PANEL_BOOKMARK.set_value( \
			self.PANEL_PATH, \
			Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_ICON, \
			__icon \
		)

	##################################################
	# EVENT HANDLER
	def on_vim_changed_filename (self, chooser) :
		__new_filename = chooser.get_filename()

		if not __new_filename :
			chooser.set_filename(self.DATA["filename"])
			return

		self.DATA["filename"] = __new_filename
		self.BOOKMARK.setValue(self.NODE, "filename", __new_filename)
		self.setIcon()
		self.changeBookmarkIcon()

	def on_vim_changed_command (self, entry) :
		__command = entry.get_text().strip()
		if len(__command) < 1 : return
		self.DATA["command"] = __command
		self.BOOKMARK.setValue(self.NODE, "command", __command)

class preferences_main (__BASIC__.preferences_main) :

	def initialize (self) :
		__BASIC__.preferences_main.initialize(self)
		__command = self.GCONF_CLIENT.getValue("command")

		self.getWidget("filechooserbutton16").set_uri( \
			gnomevfs.make_uri_canonical(__command))
		self.getWidget("entry63").set_text(__command)

	##################################################
	# EVENT HANDLER
	def on_vim_changed_filechooser_command (self, chooser) :
		__new = chooser.get_filename()

		if not __new : return
		self.getWidget("entry63").set_text(__new)

	def on_vim_changed_command (self, entry) :
		__command = entry.get_text().strip()

		if len(__command) < 1 : return
		self.GCONF_CLIENT.setValue("command", __command)

import xml, xmlrpclib
def parse_argument_of_veet (data) :
	try :
		__a = xmlrpclib.loads(data)
	except xml.parsers.expat.ExpatError :
		return None

	if len(__a[0]) < 2 :
		__uid = None
	else :
		__uid = __a[0][1]

	__data = __a[0][0][1:]

	return (__uid, __data)

def notification_handler_filename_to_insert_as_new_tab \
		(client, parm1, entry, state) :
	instance_vee = state["local"]["obj-vee"]
	__data = instance_vee.GCONF_CLIENT.getValueFromValue(entry.get_value())
	
	try :
		(__uid, __filenames) = parse_argument_of_veet(__data)
	except TypeError :
		return
	
	if not __uid : return
	if instance_vee.UID != __uid : return
	
	for i in __filenames :
		instance_vee.addPage("vim", filename=i)
	
	instance_vee.GCONF_CLIENT.setValue(os.path.basename(entry.get_key()), "")


def escape_path (path) :
	return path.replace(" ", "\ ")

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "main.py"


