#!/usr/bin/env python

import os, sys, sre, time
#import Conf_i18n

sys.path.append(os.path.dirname(sys.argv[1]))
CONF_I18N_NAME = os.path.basename(os.path.splitext(sys.argv[1])[0])
CONF_I18N = \
	__import__("%s" % CONF_I18N_NAME, globals(), locals(), [type,])

def print_usage () :
	print "Usage %s : %s <conf i18n script> <previous po filename> <output po filename>" % \
		(sys.argv[0], sys.argv[0], )

if len(sys.argv) < 2 :
	print_usage()
	sys.exit(1)

pofile_previous = sys.argv[2]
pofile_output = sys.argv[3]

################################################################
# parse previous PO file

def get_str (data) :
	__key = sre_msgstr.sub("", data).strip()

	if __key.startswith("\"") and __key.endswith("\"") :
		__k = __key[1:-1]
	else :
		__k = __key

	return __k

def get_id (data) :
	__key = sre_msgid.sub("", data).strip()

	if __key.startswith("\"") and __key.endswith("\"") :
		__k = __key[1:-1]
	else :
		__k = __key

	return __k

fd = file(pofile_previous, "r")

sre_msgid = sre.compile("^msgid ")
sre_msgstr = sre.compile("^msgstr ")

__in_id = False
__in_str = False

__data_msg = dict()
__msg_pool = list()
__key_pool = list()

while 1 :
	__data = fd.readline()

	if not __data : break
	if __data.startswith("#") : continue
	if not __data.strip() : continue

	__id = sre_msgid.findall(__data)
	__str = sre_msgstr.findall(__data)

	if len(__id) and __key_pool :
		if __key_pool != __msg_pool :
			#__data_msg.update({"".join(__key_pool) : __msg_pool, })
			__KK = "".join(__key_pool).replace("\\n", "\n").replace("\\", "")
			__data_msg.update({__KK : __msg_pool, })

	if len(__id) > 0 :
		__in_id = True
		__in_str = False
		__key_pool = list()
	elif len(__str) > 0 :
		__in_id = False
		__in_str = True
		__msg_pool = list()

	if len(__id) > 0 :
		__key = get_id(__data)
		if __key.strip() :
			__key_pool.append(__key)
	elif __in_id :
		__d = get_id(__data)
		if len(__d) == 0 :
			__key_pool.append("\n")
		else :
			__key_pool.append(__d)

	if len(__str) > 0 :
		__msg = get_str(__data)

		if __msg.strip() :
			__msg_pool.append(__msg)
	elif __in_str :
		__msg = get_str(__data)
		if len(__msg) == 0 :
			__msg_pool.append("\n")
		else :
			__msg_pool.append(__msg)

if __key_pool :
	#__data_msg.update({"".join(__key_pool) : __msg_pool, })
	__KK = "".join(__key_pool).replace("\\n", "\n").replace("\\", "")
	__data_msg.update({__KK : __msg_pool, })

fd.close()

###############################################################
TEMPLATE_POFILE = \
"""##############################################################################
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################

##############################################################################
# Translated by Spike^ekipS <spikeekips@gmail.com>
# Last edited at %s.

"""

if not os.path.exists(pofile_output) :
	output = file(pofile_output, "w")
	output.write(TEMPLATE_POFILE % time.strftime("%c"))
else :
	output = file(pofile_output, "a")

sys.stdout = output

###############################################################
# generate po file.
for i in dir(CONF_I18N) :
	if not i.startswith("LABEL") : continue
	__a = getattr(CONF_I18N, i)

	print "#============================"
	print "## glade file name, %s" % i
	for k, m in __a.items() :
		print "### widget, %s" % k
		for n in m :
			if __data_msg.has_key(n[2]) :
				__msg = __data_msg[n[2]]
			else :
				print "#### EDITME"
				__msg = n[2].split("\n")
				__msg = ["%s\n" % i for i in __msg]
				__msg = __msg[:-1] + [__msg[-1].strip()]
				__msg = [i.replace("\"", "\\\"") for i in __msg]

			__id= n[2].replace("\"", "\\\"")
			__b = __id.split("\n")
			__b = ["%s\n" % i for i in __b]
			__b = __b[:-1] + [__b[-1].strip()]
			if len(__b) < 2 :
				print "\nmsgid \"%s\"" % __id
			else :
				print "\nmsgid \"\""

				for o in __b :
					print "\"%s\"" % o.replace("\n", "\\n")

			if len(__msg) < 2 :
				print "msgstr \"%s\"" % __msg[0]
			else :
				print "msgstr \"\""

				for o in __msg :
					print "\"%s\"" % o.replace("\n", "\\n")


		# insert blank line.
		print ""

output.close()

