#!/bin/sh

##################################################################
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##################################################################

DIRECTORY_TMP=`pwd`/pofile/vee
[ -d "${DIRECTORY_TMP}" ] || mkdir -p ${DIRECTORY_TMP}

rm -f ${DIRECTORY_TMP}/tmp-Conf_i18n.py
rm -f ${DIRECTORY_TMP}/vee.po

DIRECTORY_CURRENT=`pwd`
VEE_HOME=/home/spike/system/lib/vee.run
POFILE_PREVIOUS=${VEE_HOME}/share/locale/ko/LC_MESSAGES/vee.po
POFILE_NEW=${DIRECTORY_TMP}/vee.po
CONF_I18N_FILENAME=${DIRECTORY_TMP}/Conf_i18n.py

VEE_LIB=${VEE_HOME}/lib/python2.3/site-packages/vee
GLADE_PATH_EXTRA=${VEE_LIB}/child

#find ${GLADE_PATH_EXTRA} -maxdepth 2 -type f -name "*.glade" \
#	-exec python createConfi18nFromGlade.py {} {}-child-Conf_i18n.py \;
GLADE_FILE_EXTRA=`find ${GLADE_PATH_EXTRA} -mindepth 2 -maxdepth 2 -type f -name "*.glade"`

LIST_CHILD=""
for i in ${GLADE_FILE_EXTRA}
do
	child__=`dirname $i`
	childname=`basename $child__`
	name=`basename $i | sed -e 's/\.glade//g'`
	LIST_CHILD="${LIST_CHILD} ${childname}"

	[ -d ${DIRECTORY_TMP}/child/${childname} ] || mkdir -p ${DIRECTORY_TMP}/child/${childname}
	CONF_FILENAME=${DIRECTORY_TMP}/child/${childname}/Conf_i18n-${childname}-${name}.py
	rm -f ${CONF_FILENAME}
	python createConfi18nFromGlade.py $i ${CONF_FILENAME}
	python createPoFileFromConfi18n.py ${CONF_FILENAME} ${POFILE_PREVIOUS} ${POFILE_NEW}

done

LIST_CHILD=`echo ${LIST_CHILD} | sed -e 's/\<child\>//g' | sed -e 's/[ \t][ \t]*/\n/g'| sort -u`

for i in ${LIST_CHILD}
do
	[ -z "$i" ] && continue
	#(cd ${DIRECTORY_TMP}/${i}; echo `pwd`; cat * > Conf_i18n.py; rm -f Conf_i18n-*.py*)

	cd ${DIRECTORY_TMP}/child/${i}
	rm -f Conf_i18n.py
	rm -f *.pyc
	for j in Conf_i18n-*
	do
		cat $j >> Conf_i18n.py

		# check checksum.
		CHECKSUM_NEW=`md5sum Conf_i18n.py | awk '{print $1}'`
		CHECKSUM_ORIG=`md5sum ${VEE_LIB}/child/${i}/Conf_i18n.py | awk '{print $1}'`

		[ "${CHECKSUM_NEW}" == "${CHECKSUM_ORIG}" ] && rm -f Conf_i18n.py
	done
	rm -f Conf_i18n-*.py*
done

cd ${DIRECTORY_CURRENT}

rm -f ${CONF_I18N_FILENAME}

for i in *.glade ${GLADE_PATH_EXTRA}/widget_vte.glade
do
	python createConfi18nFromGlade.py $i ${CONF_I18N_FILENAME}
done

python createPoFileFromConfi18n.py ${CONF_I18N_FILENAME} ${POFILE_PREVIOUS} ${POFILE_NEW}

(cd ${DIRECTORY_TMP}; find . -type f -name "*.pyc" -exec rm -f {} \;)

# check checksum.
CHECKSUM_ORIG=`md5sum ${CONF_I18N_FILENAME} | awk '{print $1}'`
CHECKSUM_NEW=`md5sum ${VEE_LIB}/Conf_i18n.py | awk '{print $1}'`

[ "${CHECKSUM_NEW}" == "${CHECKSUM_ORIG}" ] && rm -f ${CONF_I18N_FILENAME}

