# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, gettext as __gettext
from vee import Conf__

def gettext () :
	try :
		t = __gettext.translation("vee", Conf__.DIR_LOCALE)
	except IOError :
		return __gettext.gettext
	else :
		t.install(unicode=1)
		return t.ugettext

import locale
def getLocale (envvars=list()) :
	return __getLocale(Conf__.DIR_LOCALE, envvars)

def __getLocale (localedir, envvars=list()) :
	# get locale environment value.
	if len(envvars) < 1 :
		envvars = ["LC_ALL", "LANG", "LC_MESSAGES", ]

	envLocale = str()
	for i in envvars :
		__v = os.getenv(i)

		if __v :
			envLocale = __v
			break

	envLocale = None
	if envLocale :
		langlist = __gettext._expand_lang(envLocale)
		for lang in langlist :
			if lang == "C" :
				return (None, lang)

			__dir = os.path.join(localedir, lang)
			if os.path.exists(__dir) and os.path.isdir(__dir) :
				return (__dir, lang)

	return (None, None)

def set_labelname (xml, label_data) :
	for i, j in label_data.items() :
		try :
			xml.get_widget(i).set_label(j)
		except AttributeError :
			print "(EE) Widget, %s does not exists. (labelname : %s)" % (i, j)

if __name__ == "__main__" :
	print getLocale()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "i18n.py"


